<?php
	include("./include/config.php");
	include("./include/getdata.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/user.php");
	include("./models/session.php");
	include("./models/site.php");
	include("./models/contact.php");
	include("./models/page.php");
	include("./models/category.php");
	include("./models/rss.php");
	include("./models/rssArticle.php");
	include("./models/rssRequest.php");
	include("./models/rssCategory.php");
	include("./twitter/twitter_oauth.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_name'=>'名前',
		'txt_mail_address'=>'メールアドレス',
		'txt_service_name'=>'サービス名',
		'txt_content_text'=>'内容',
		'txt_detail_text'=>'本文',
	);
	//ルール定義
	$rules = array(
		'txt_name'=>'required',
		'txt_mail_address'=>'required,email',
		'txt_service_name'=>'required',
		'txt_content_text'=>'required',
		'txt_detail_text'=>'required',
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	if ($_POST["proc_type"] == "entry") {
		if ($modelView->validateParams()){
			$contact_id = createID();

			//お問い合わせ登録
			$ModelContact = new ModelContact();
			$data = array(
				"contact_id"=>$contact_id,
				"name"=>$modelView->posts["txt_name"],
				"mail_address"=>$modelView->posts["txt_mail_address"],
				"service_name"=>$modelView->posts["txt_service_name"],
				"content_text"=>$modelView->posts["txt_content_text"],
				"detail_text"=>crLfHTML($modelView->posts["txt_detail_text"]),
				"ip_address"=>$_SERVER["REMOTE_ADDR"],
				"enable_flag"=>"Y",
				"time_stamp"=>date("Y-m-d H:i:s")
			);
			$ModelContact->insert($data);

			//メール送信
			mailContact($modelView->posts["txt_mail_address"],$modelView->posts["txt_name"],$modelView->posts["txt_service_name"],$modelView->posts["txt_content_text"],$modelView->posts["txt_detail_text"]);
			//メール送信(管理者)
			mailContactToAdmin($modelView->posts["txt_mail_address"],$modelView->posts["txt_name"],$modelView->posts["txt_service_name"],$modelView->posts["txt_content_text"],$modelView->posts["txt_detail_text"]);
		}
	}

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div class='align-left'>\n";

		$htmlRight .= "<h2>お問い合わせ</h2>\n";
		$htmlRight .= "";
		
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<form></form>";
		$htmlRight .= "<form id='frmEntry' action='./' method='post'>";
		$htmlRight .= "<div class='cls_section'>名前</div>";
		$htmlRight .= "<div><input type='text' id='txt_name' name='txt_name' size=40></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<input type='hidden' name='txt_service_name' value='".$admin_site_title."'>";
		$htmlRight .= "<div class='cls_section'>内容</div>";
		$htmlRight .= "<div><select id='txt_content_text' name='txt_content_text'>";
		$htmlRight .= "<option value=''>選択してください";
		$htmlRight .= "<option value='お問い合わせ'>お問い合わせ";
		$htmlRight .= "<option value='不具合報告'>不具合報告";
		$htmlRight .= "<option value='要望'>要望";
		$htmlRight .= "<option value='その他'>その他";
		$htmlRight .= "</select></div>";
		$htmlRight .= "<div class='cls_section'>本文</div>";
		$htmlRight .= "<div><textarea rows=10 cols=60 id='txt_detail_text' name='txt_detail_text'></textarea></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='entry'>";
		$htmlRight .= "<br><br>";

		$htmlRight .= "<div><input type='button' id='btn_entry' name='btn_entry' value='送信する'></div>";
		$htmlRight .= "<br>";
		$htmlRight .= "</form>";

		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";

		$htmlRight .= <<<EOF
<script type="text/javascript">
$(document).on("click", "#btn_entry", function(){
	$("#txt_detail_text").val(escapeHTML($("#txt_detail_text").val()));
	$("#frmEntry").submit();
});
</script>
EOF;
	} else {
		$htmlRight .= "<div class='align-left'>\n";
		$htmlRight .= "<h2>お問い合わせ</h2>\n";
		$htmlRight .= "<br>\n";
		$htmlRight .= "<div style='line-height:1.8;'>";
		$htmlRight .= "ありがとうございます。<br>";
		$htmlRight .= "お問い合わせを受け付けました。<br>";
		$htmlRight .= "<br>\n";
//		if (!is_authenticated()) {
//			$htmlRight .= "このサイトは <b>".$admin_site_title."</b> を利用して作成されています。<br>";
//			$htmlRight .= "あなたも、アンテナサイトを運営してみませんか？<br><br>";
//			$htmlRight .= "<a href='${sub_dir}/'>".$admin_site_title."</a>";
//			$htmlRight .= "<br>\n";
//		}
		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";
	}

	//$htmlRight = cnvContents($htmlRight);
	
	//ヘッダ部
	$title = "";
	$description = "";
	$keywords = "";
	getHeaderHTML($title,$description,$keywords);

	print $htmlRight;

	//メニュー
	getMenuHTML(ADMIN_USER_ID);

	//フッター
	getFooterHTML();

	endProc();

?>
