<?php
	include("./include/config.php");
	include("./include/common.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/session.php");

	initProc();

	$http_referer = $_SERVER['HTTP_REFERER'];
	if(strpos($http_referer, HOME_URL) < 0 || $http_referer == ""){
		print "<b>不正アクセス検知</b><br>";
		print "アクセス元：".$http_referer."<br>";
		print "IPアドレス：".$_SERVER["REMOTE_ADDR"]."<br>";
		exit();
	}

	$app_id = $_GET["app"];
	$tblname = $_GET["tblname"];
	$func = $_GET["func"];

	if (!is_authenticated($_GET["auth_mode"])) {
		switch ($func) {
			case "select":
			case "insert":
			case "update":
			case "delete":
				$ModelSession = new ModelSession();
				$ModelSession->error_code = "9";
				$ModelSession->error_message = "タイムアウトしました。";
				$txtJSON = $ModelSession->return_json();
				header('Content-Type: text/javascript; charset=utf-8');
				print $txtJSON;
				exit();
				break;
		}
	}

	$className = "Model".ucfirst($tblname);

	include("./models/".$tblname.".php");

	$ModelClass = new $className();

	//POSTデータ取得
	$ModelClass->posts = postToArray();
	//GETデータ取得
	$ModelClass->gets = getToArray();
	//JSONで取得
	$ModelClass->data_type = "json";

	switch ($app_id) {
		case "admin":
		case "contact":
		case "support":
		case "page_index":
		case "page_menu":
		case "tag_menu":
		case "page_faq":
		case "page_ad":
		case "page_info":
		case "account":
			if (is_admin()) {
				$ModelClass->posts["user_id"] = ADMIN_USER_ID;
			} else {
				exit();
			}
	}

	//処理振り分け
	switch ($func) {
		case "insert":
			$txtJSON = $ModelClass->insertControl();
			break;
		case "update":
			$txtJSON = $ModelClass->updateControl();
			break;
		case "delete":
			$txtJSON = $ModelClass->deleteControl();
			break;
		case "select":
			$txtJSON = $ModelClass->selectControl();
			break;
		case "count":
			$txtJSON = $ModelClass->countControl();
			break;
		default:
			$txtJSON = $ModelClass->commonControl($func);
			break;
	}
	$txtJSON = str_replace("\t","",$txtJSON);

	header('Content-Type: text/javascript; charset=utf-8');
	echo $txtJSON;

	endProc();
?>
