<?php
$login_id = "";

$HTML_HOME_URL = $site_title;
$HTML_SITE_TITLE = $site_title;
$HTML_TITLE = "";
$HTML_DESCRIPTION = $site_description;
$HTML_KEYWORDS = "";
$HTML_META = "";
$HTML_SCRIPTS = "";
$HTML_LINKS = "";
$HTML_CONTENTS = "";

class ModelView {
	public $app_id = "";
	public $page_id = "";
	public $type_id = "";
	public $dir = "";

	public $title = "";
	public $description = "";
	public $keywords = "";

	public $htmlMeta = "";
	public $htmlScripts = "";
	public $htmlStyle = "";
	public $htmlCenter = "";
	public $htmlLeft = "";
	public $htmlRight = "";
	public $shortcutIcon = "";
	public $touchIcon = "";
	
	public $params = Array();
	public $rules = Array();
	public $posts = Array();
	public $gets = Array();

	public $error_params = "";
	public $error_message = "";

	public $validate_on = false;

	//Center用HTML生成
	private function centerContensHTML() {
		if ($this->htmlCenter != "") {
			return("<div id='header-contents'>\n".$this->htmlCenter."</div>\n");
		}
	}

	//Left用HTML生成
	private function leftContensHTML() {
		if ($this->htmlLeft != "") {
			return("<div id='left-contents'>\n".$this->htmlLeft."</div>");
		}
	}

	//Right用HTML生成
	private function rightContensHTML() {
		if ($this->htmlRight != "") {
			$this->htmlRight .= "\n".$this->copyRightHTML();
			if ($this->htmlLeft != "") {
				return("<div id='right-contents'>\n".$this->htmlRight."</div>\n");
			} else {
				return("<div id='center-contents'>\n".$this->htmlRight."</div>\n");
			}
		}
	}
	
	private function copyRightHTML() {
		global $HTML_HOME_URL;
		global $HTML_SITE_TITLE;
		$html = "<div id='footer-contents'><div>Copyright (C) <a href='http://${HTML_HOME_URL}' target='_blank'>${HTML_SITE_TITLE}</a> All Rights Reserved</div></div>";
		return($html);
	}

	//document.ready用script生成
	private function scriptHTML() {
		if ($this->validate_on) {
			//初期設定
			foreach ($this->params as $key => $value){
				$html .= "$('#".$key."').val('".$this->posts[$key]."');\n";
			}
			//エラー表示
			$html .= "$('div.cls_message').html('".$this->error_message."');\n";
			if ($this->error_message != ""){
				$html .= "$('div.cls_message').show()\n";
			}
			if ($this->error_params != ""){
				$col = explode(",", $this->error_params);
				foreach ($col as $value){
					$html .= "$('#".$value."').addClass('cls_error');\n";
				}
			}
		}
		$html .= $this->htmlScripts;
		return($html);
	}

	private function getSubDir() {
		$path = $_SERVER["REQUEST_URI"];
		$path = substr($path,0,strpos($path,"/setting"));
		return($path);
	}

	//scriptタグ生成
	private function scriptTag($url) {
		$path = $this->getSubDir();
		$html = "";
		if (file_exists(SITE_PATH.$url)){
			$html = "<script src='${path}${url}' type='text/javascript'></script>\n";
		}
		return($html);
	}
	//linkタグ生成
	private function linkTag($url) {
		$path = $this->getSubDir();
		$html = "";
		if (file_exists(SITE_PATH.$url)){
			$html = "<link href='${path}${url}' type='text/css' rel='stylesheet'>\n";
		}
		return($html);
	}
	//rssタグ生成
	private function rssTag($url) {
		$path = $this->getSubDir();
		$html = "<link rel='alternate' type='application/rss+xml' title='RSS2.0' href='${path}${url}'/>\n";
		return($html);
	}
	//styleタグ生成
	private function styleHTML() {
		$html = "";
		if ($this->htmlStyle != "") {
			$html .= "<style type='text/css'>\n";
			$html .= "<!--\n";
			$html .= $this->htmlStyle."\n";
			$html .= "-->\n";
			$html .= "</style>\n";
		}
		return($html);
	}

	//HTML表示
	public function printHTML() {
		global $HTML_TITLE;
		global $HTML_DESCRIPTION;
		global $HTML_KEYWORDS;
		global $HTML_META;
		global $HTML_SCRIPTS;
		global $HTML_LINKS;
		global $HTML_CONTENTS;

		$HTML_TITLE = $this->title;
		$HTML_DESCRIPTION = $this->description;
		$HTML_KEYWORDS = $this->keywords;
		$HTML_META = $this->htmlMeta;

		$HTML_SCRIPTS .= $this->scriptHTML();

		if ($this->dir == "") {
			$HTML_LINKS .= $this->rssTag("http://".HTML_HOME_URL."feed/");
		} else {
			$HTML_LINKS .= $this->rssTag("http://".HTML_HOME_URL.$this->dir."/feed/");
		}
		$HTML_LINKS .= $this->scriptTag("/scripts/jquery-1.9.1.min.js");
		$HTML_LINKS .= $this->scriptTag("/scripts/jquery-ui-1.9.2.custom.min.js");
		$HTML_LINKS .= $this->scriptTag("/scripts/jqueryupload.js");
		$HTML_LINKS .= $this->scriptTag("/scripts/jquery.cookie.js");
		$HTML_LINKS .= $this->scriptTag("/scripts/common.js");
		if ($this->app_id != "") {
			$HTML_LINKS .= $this->scriptTag("/app/scripts/common.js");
			$HTML_LINKS .= $this->scriptTag("/app/".$this->app_id."/scripts/common.js");
			$HTML_LINKS .= $this->scriptTag("/app/".$this->app_id."/scripts/".$this->page_id.".js");
			$HTML_LINKS .= $this->scriptTag("/app/".$this->app_id."/scripts/".$this->page_id."_".$this->type_id.".js");
		}
		$HTML_LINKS .= $this->linkTag("/css/jquery-ui-1.9.2.custom.min.css");
		$HTML_LINKS .= $this->linkTag("/css/style.css");
		if ($this->app_id != "") {
			$HTML_LINKS .= $this->linkTag("/app/".$this->app_id."/css/common.css");
		}
		$HTML_LINKS .= $this->linkTag("/scripts/jquery.cleditor.css");
		$HTML_LINKS .= $this->scriptTag("/scripts/jquery.cleditor.min.js");
		$HTML_LINKS .= $this->styleHTML();
		$HTML_LINKS .= "<link href='https://use.fontawesome.com/releases/v5.7.2/css/all.css' rel='stylesheet'>\n";

		$HTML_CONTENTS .= $this->centerContensHTML();
		$HTML_CONTENTS .= "<div id='main-contents'>";
		$HTML_CONTENTS .= $this->leftContensHTML();
		$HTML_CONTENTS .= $this->rightContensHTML();
		$HTML_CONTENTS .= "</div>";

		$html .= $this->template_html();
		print($html);
	}

	//パラメータチェック
	public function validateParams() {
		$this->validate_on = true;
		foreach ($this->rules as $key => $value){
			$ary_value = explode(",", $value);
			foreach ($ary_value as $value){
				list($val,$set) = explode(":", $value);
				switch ($val) {
					case "required":
						if ($this->posts[$key] == "") {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."を入力してください。";
							return(false);
						}
						break;
					case "equal":
						$col = explode(",", $key);
						if ($this->posts[$col[0]] != $this->posts[$col[1]]) {
							$this->error_params = $key;
							$this->error_message = $this->params[$col[0]]."と".$this->params[$col[1]]."に同じ文字を入力してください。";
							return(false);
						}
						break;
					case "numeric":
						if (!is_numeric($this->posts[$key])) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."に数字を入力してください。";
							return(false);
						}
						break;
					case "alphanumeric":
						if (!preg_match("/^[a-zA-Z0-9_-]+$/",$this->posts[$key])) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."に英数字・ハイフン・アンダースコアを入力してください。";
							return(false);
						}
						break;
					case "date":
						if (!strptime($this->posts[$key],'%Y-%m-%d') && !strptime($this->posts[$key],'%Y/%m/%d')) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."に日付を入力してください。";
							return(false);
						}
						break;
					case "email":
						if (!preg_match('|^[0-9a-z_./?-]+@([0-9a-z-]+\.)+[0-9a-z-]+$|', $this->posts[$key])) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."に正しいメールアドレスを入力してください。";
							return(false);
						}
						break;
					case "url":
						if (!preg_match('/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)$/', $this->posts[$key])) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."に正しいURLを入力してください。";
							return(false);
						}
						break;
					case "length":
						list($min,$max) = explode("-", $set);
						if (strlen($this->posts[$key]) < $min) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."は".$min."文字以上で入力してください。";
							return(false);
						}
						if (strlen($this->posts[$key]) > $max) {
							$this->error_params = $key;
							$this->error_message = $this->params[$key]."は".$max."文字以下で入力してください。";
							return(false);
						}
						break;
				}
			}
		}
		return(true);
	}
	
		//HTMLテンプレート
	private function template_html() {
		global $HTML_SITE_TITLE;
		global $HTML_TITLE;
		global $HTML_DESCRIPTION;
		global $HTML_KEYWORDS;
		global $HTML_META;
		global $HTML_SCRIPTS;
		global $HTML_LINKS;
		global $HTML_CONTENTS;

		$shortcut_icon = $this->shortcutIcon;
		if ($shortcut_icon == "") {
			$shortcut_icon = "/images/favicon.ico";
		}
		$touch_icon = $this->touchIcon;
		if ($touch_icon == "") {
			$touch_icon = "/images/title.png";
		}
		
		
$html .= <<<EOF
<?xml version="1.0" encoding="utf-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>${HTML_TITLE}</title>
<meta name="viewport" content="width=device-width,user-scalable=no,maximum-scale=1">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta http-equiv="Content-Script-Type" content="text/javascript">
<meta name="ROBOTS" content="INDEX,FOLLOW">
<meta name="description" content="${HTML_DESCRIPTION}">
<meta name="keywords" content="${HTML_KEYWORDS}">
${HTML_META}
<link rel="shortcut icon" href="${shortcut_icon}">
<link rel="apple-touch-icon" href="${touch_icon}">
${HTML_LINKS}
<script type="text/javascript">
$(document).ready(function() {
${HTML_SCRIPTS}
});
</script>
</head>
<body>
<div id="container">
${HTML_CONTENTS}
</div>
</body>
</html>
EOF;
		return($html);
	}

}

?>