<?php
	include("./include/config.php");
	include("./include/getdata.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/session.php");
	include("./models/page.php");
	include("./models/site.php");
	include("./models/rss.php");
	include("./models/rssArticle.php");
	include("./models/rssCategory.php");
	include("./models/ngWord.php");
	include("./models/apiChannelItem.php");
	include("./twitter/twitter_oauth.php");

	$_GET["auth_mode"] = "admin";
	initProc();

	//テーブル作成
	createMstTables();
	createTrnTables();

	$url = $_SERVER["REQUEST_URI"];
	$hash = parse_url($url);
	parse_str($hash['query']);
	
	$disp_type = $_GET["type"];

	$sub_dir = getSubDir();

	$htmlRight .= "<div class='align-left'>\n";

	$max_cnt = $design_json["blog_top_count"];
	$page = $_GET["page"];
	if ($page == "") {
		$page = 1;
	}
	$offset = ($page - 1) * $max_cnt;


	switch($disp_type) {
		case "":
			//レイアウト(コンテンツ)
			$htmlRight .= getLayoutHTML(ADMIN_USER_ID,"contents");
			break;

		case "index":
			//ヘッダ広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_header]</div>\n";

			$htmlRight .= getBlogHTML(ADMIN_USER_ID);

			//中央広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_middle]</div>\n";

			//フッター広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_footer]</div>\n";
			break;

		case "rss":
			$rss_id = $_GET["id"];
			$article_id = $_GET["aid"];

			if ($article_id != "") {
				$page = 1;
				$offset = 0;
			}

			//ヘッダ広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_header]</div>\n";

			//RSS記事
			$ModelRssArticle = new ModelRssArticle();
			$data = array(
				"user_id"=>ADMIN_USER_ID,
				"rss_id"=>$rss_id,
				"article_title"=>""
			);
			$orders = array(
				"article_time"=>"desc"
			);
			$rs = $ModelRssArticle->select($data,$orders,$offset,$max_cnt);
			if ($design_json["blog_top_count"] == 0) {
				$htmlRight .= "<div class='btn-rank align-right'>";
				$htmlRight .= "<a href='${sub_dir}/{$user_name}/request/'><span class='page-button' style='background-color:".$h1_color.";'><i class='fas fa-chevron-circle-right'></i> 相互RSS依頼</span></a>";
				$htmlRight .= "</div>";
				break;
			}

			$htmlRight .= "<div class='section-box'>\n";
			$htmlRight .= "<h2><i class='fas fa-exclamation-circle'></i> 新着RSS</h2>\n";
			$htmlRight .= "<table class='cls_tbl_list'>";
			$cnt = 0;
			$page_title = "";
			$dcnt = $ModelRssArticle->count($data);
			while ($item = mysqli_fetch_array($rs)) {
				$htmlRight .= "<tr>";
				$in_count = $item["in_count"];
				if ($in_count == "") {
					$in_count = 0;
				}
				$out_count = $item["out_count"];
				if ($out_count == "") {
					$out_count = 0;
				}

				//サムネイル表示制御
				if ($design_json["rss_contents_thumbnail"] != "") {
					$style = "";
					if (trim($item["article_image"]) != "") {
						$style .= "background-image: url(\"".$item["article_image"]."\");";
						$style .= "background-size:cover;";
					} else if (trim($item["title_image_file"]) != "") {
						$style .= "background-image: url(\"${sub_dir}/home/".$item["user_id"]."/".trim($item["title_image_file"])."\");";
						$style .= "background-size:cover;";
					} else {
						$style .= "background-image: url(\"${sub_dir}/images/noimage.png\");";
						$style .= "background-size:cover;";
					}
					$htmlRight .= "<td width=100>";
					$htmlRight .= "<div class='cls_article_link'><a href='${sub_dir}/{$user_name}/link/".$item["rss_id"]."/".$item["article_id"]."/' target='_blank'><div class='cls_link_box' style='".$style."'></div></div>";
				}

				if ($item["rss_id"] == $rss_id && $item["article_id"] == $article_id) {
					$htmlRight .= "<td class='cls_error'>";
					$page_title = str_replace($ngWords,$replaceWords,$item["article_title"]);
				} else {
					$htmlRight .= "<td>";
				}
				$htmlRight .= "<div class='cls_article_title'>";
				$htmlRight .= "<a href='${sub_dir}/{$user_name}/link/".$item["rss_id"]."/".$item["article_id"]."/' target='_blank' class='article' rss_id='".$item["rss_id"]."' article_id='".$item["article_id"]."'>".substring(str_replace($ngWords,$replaceWords,$item["article_title"]),50)."</a>";
				$htmlRight .= "</div>";
				$htmlRight .= "<div class='cls_article_body'>";
				//本文の表示制御
				if ($design_json["blog_description"] == "") {
					$htmlRight .= mb_strcut(str_replace($ngWords,$replaceWords,$item["article_description"]),0,$design_json["blog_description_count"]*2)."...";
					$htmlRight .= "</div>";
					$htmlRight .= "<div class='cls_article_body'>";
				}
				$htmlRight .= "<i class='fas fa-blog'></i> <a href='${sub_dir}/{$user_name}/rss/".$item["rss_id"]."/'><b>".$item["site_title"]."</b></a>";
				$htmlRight .= "</div>";
				$htmlRight .= "<div class='cls_article_body'>";
				$htmlRight .= "<div class='float-left'>";
				$htmlRight .= "<i class='far fa-clock'></i> ".date("Y.m.d H:i",strtotime($item["article_time"]));
				$htmlRight .= "&nbsp;&nbsp;&nbsp;";
				$htmlRight .= "<i class='far fa-list-alt'></i> <a href='${sub_dir}/{$user_name}/rss_category/".$item["category_id"]."/'><b>".$item["category_name"]."</b></a>";
				$htmlRight .= "</div>";
				$htmlRight .= "</div>";
				$cnt++;
			}
			$htmlRight .= "</table>\n";

			//ページ
			$max_page = ceil($dcnt / $max_cnt);
			if ($search_text == "") {
				if ($disp_type == "") {
					$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/index/",".htm");
				} else {
					$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/rss/".$rss_id."/","/");
				}
			} else {
				$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/article/","/?id_inp_seacrh=".$search_text);
			}
			
			if ($disp_type == "rss") {
				$site_title = $rss_title." - ".$site_title;
			}
			if ($page_title != "") {
				$site_title = $page_title." - ".$site_title;
				$site_description = $page_title."。".$site_description;
			}

			$htmlRight .= "<div class='btn-rank align-right'>";
			$htmlRight .= "<a href='${sub_dir}/{$user_name}/request/'><span class='page-button' style='background-color:".$h1_color.";'><i class='fas fa-chevron-circle-right'></i> 相互RSS依頼</span></a>";
			$htmlRight .= "</div>";
			$htmlRight .= "</div>\n";
			$htmlRight .= "<br>";

			//中央広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_middle]</div>\n";

			//フッター広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_footer]</div>\n";
			break;

		case "rss_category":
			$category_id = $_GET["id"];

			//ヘッダ広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_header]</div>\n";

			//RSS
			$ModelRss = new ModelRss();
			$data = array(
				"user_id"=>ADMIN_USER_ID,
				"category_id"=>$category_id
			);
			$rs = $ModelRss->select($data);
			while ($item = mysqli_fetch_array($rs)) {
				$rss_id_list[] = $item["rss_id"];
			}
			if (!is_array($rss_id_list)) {
				$rss_id_list[] = "xxxxxxx";
			}

			//カテゴリ取得
			$ModelRssCategory = new ModelRssCategory();
			$data = array(
				"user_id"=>ADMIN_USER_ID,
				"category_id"=>$category_id
			);
			$rs = $ModelRssCategory->select($data);
			while ($item = mysqli_fetch_array($rs)) {
				$category_name = $item["category_name"];
			}

			//RSS記事
			$ModelRssArticle = new ModelRssArticle();
			$data = array(
				"user_id"=>ADMIN_USER_ID,
				"rss_id"=>implode(',', $rss_id_list)
			);
			$orders = array(
				"article_time"=>"desc"
			);
			$rs = $ModelRssArticle->select($data,$orders,$offset,$max_cnt);
			$htmlRight .= "<div class='section-box'>\n";
			$htmlRight .= "<h2 style='padding-top:8px;padding-bottom:9px;'><div>".$category_name."";
			$htmlRight .= "<div style='float:right;position:relative;right:0px;top:-8px;'><a href='${sub_dir}/${user_name}/feed/rss/${category_id}/' target='_blank'><img src='${sub_dir}/images/rss.png'></a></div>";
			$htmlRight .= "</div></h2>\n";

			$htmlRight .= "<table class='cls_tbl_list'>";
			$cnt = 0;
			while ($item = mysqli_fetch_array($rs)) {
				$htmlRight .= "<tr>";
				//サムネイル表示制御
				if ($design_json["rss_contents_thumbnail"] != "") {
					$style = "";
					if (trim($item["article_image"]) != "") {
						$style .= "background-image: url(\"".$item["article_image"]."\");";
						$style .= "background-size:cover;";
					} else if (trim($item["title_image_file"]) != "") {
						$style .= "background-image: url(\"${sub_dir}/home/".$item["user_id"]."/".trim($item["title_image_file"])."\");";
						$style .= "background-size:cover;";
					} else {
						$style .= "background-image: url(\"${sub_dir}/images/noimage.png\");";
						$style .= "background-size:cover;";
					}
					$htmlRight .= "<td width=100>";
					$htmlRight .= "<div class='cls_article_link'><a href='${sub_dir}/{$user_name}/link/".$item["rss_id"]."/".$item["article_id"]."/' target='_blank'><div class='cls_link_box' style='".$style."'></div></div>";
				}

				$htmlRight .= "<td>";
				$htmlRight .= "<div class='cls_article_title'>";
				$htmlRight .= "<a href='${sub_dir}/{$user_name}/link/".$item["rss_id"]."/".$item["article_id"]."/' target='_blank' class='article' rss_id='".$item["rss_id"]."' article_id='".$item["article_id"]."'>".substring(str_replace($ngWords,$replaceWords,$item["article_title"]),50)."</a>";
				$htmlRight .= "</div>";
				$htmlRight .= "<div class='cls_article_body'>";
				//本文の表示制御
				if ($design_json["blog_description"] == "") {
					$htmlRight .= mb_strcut(str_replace($ngWords,$replaceWords,$item["article_description"]),0,$design_json["blog_description_count"]*2)."...";
					$htmlRight .= "</div>";
					$htmlRight .= "<div class='cls_article_body'>";
				}
				$htmlRight .= "<i class='fas fa-blog'></i> <a href='${sub_dir}/{$user_name}/rss/".$item["rss_id"]."/'><b>".$item["site_title"]."</b></a>";
				$htmlRight .= "</div>";
				$htmlRight .= "<div class='cls_article_body'>";
				$htmlRight .= "<div class='float-left'>";
				$htmlRight .= "<i class='far fa-clock'></i> ".date("Y.m.d H:i",strtotime($item["article_time"]));
				$htmlRight .= "&nbsp;&nbsp;&nbsp;";
				$htmlRight .= "<i class='far fa-list-alt'></i> <a href='${sub_dir}/{$user_name}/rss_category/".$item["category_id"]."/'><b>".$item["category_name"]."</b></a>";
				$htmlRight .= "</div>";
//				$htmlRight .= "<div class='float-left'>";
//				$htmlRight .= "<a href='/".$item["user_name"]."/'>".$item["user_site_title"]."</a>";
//				$htmlRight .= "</div>";
				$htmlRight .= "</div>";
				$cnt++;
			}
			$htmlRight .= "</table>\n";

			$dcnt = $ModelRssArticle->count($data);
			
			//ページ
			$max_page = ceil($dcnt / $max_cnt);
			$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/rss_category/".$category_id."/","/");

			$htmlRight .= "<div class='btn-rank align-right'>";
			$htmlRight .= "<a href='${sub_dir}/{$user_name}/request/'><span class='page-button' style='background-color:".$h1_color.";'><i class='fas fa-chevron-circle-right'></i> 相互RSS依頼</span></a>";
			$htmlRight .= "</div>";
			$htmlRight .= "</div>\n";
			$htmlRight .= "<br>";

			//中央広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_middle]</div>\n";

			//フッター広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_footer]</div>\n";

			$site_title = $category_name." - ".$site_title;
			break;

		case "channel":
			$api_channel_id = $_GET["channel"];

			$rs = getApiChannel(ADMIN_USER_ID,$api_channel_id);
			while ($item = mysqli_fetch_array($rs)) {
				$api_channel_title = $item['api_channel_title'];

				$htmlRight .= "<div class='section-box'>\n";
				$htmlRight .= "<h1><i class='fas fa-podcast'></i> ".$item['api_channel_title']."</h1>\n";
				//チャンネルヘッダー
				if ($item['api_channel_header'] != "") {
					$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($item['api_channel_header']))."</div>\n";
				}
				$htmlRight .= "<table width=100% class='channel-box'>";
				$htmlRight .= "<tr>";
				$htmlRight .= "<td class='link-box-medium' style='width:220px;vertical-align:top;'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/'><div class='link-box link-box-medium' style='background-image: url(\"".$item['small_image_url']."\");'></div></a>";
				$htmlRight .= "<div style='padding-left:20px;margin-top:10px;'><a href='https://www.youtube.com/channel/".$item['api_channel_id']."?sub_confirmation=1' target='_blank' style='text-decoration:none;'><div class='page-button' style='background-color:#333;width:130px;'><i class='fas fa-plus-circle'></i> チャンネル登録</div></a></div>";
				$htmlRight .= "<td>";
				$htmlRight .= "<div class='cls_article_title'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/'><i class='fas fa-podcast'></i> <b>".$item['api_channel_title']."</b></a></div>";
				$htmlRight .= "<div>".$item['api_channel_description']."</div>";
				$htmlRight .= "<br>\n";
				$htmlRight .= "<div><i class='far fa-eye'></i> 総視聴回数：".number_format($item['view_count'])."回</div>";
				$htmlRight .= "<div><i class='fas fa-video'></i> 動画数：".number_format($item['video_count'])."</div>";
				$htmlRight .= "<div><i class='fas fa-user-friends'></i> チャンネル登録者数：".number_format($item['subscriber_count'])."人</div>";
				$htmlRight .= "</table>\n";
				$htmlRight .= "<br>\n";
				//チャンネルコンテンツ
				if ($item['api_channel_contents'] != "") {
					$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($item['api_channel_contents']))."</div><br>\n";
				}
				$htmlRight .= "<h3><i class='fas fa-video'></i> 人気の動画 (".$item['api_channel_title'].")</h3>\n";
				$htmlRight .= "<table class='cls_tbl_list'>";
				$rs2 = getApiChannelItem(ADMIN_USER_ID,$api_channel_id,"",$offset,$max_cnt);
				while ($item2 = mysqli_fetch_array($rs2)) {
					$htmlRight .= "<tr>";
					$htmlRight .= "<td width=100px style='vertical-align:top;'>";
					$htmlRight .= "<div class='cls_article_link' style='padding-bottom:4px'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html'><div class='link-box link-box-medium' style='background-image: url(\"".$item2['small_image_url']."\");'></div></a></div>";
					$htmlRight .= "<a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html' style='text-decoration:none;'><div class='page-button' style='background-color:".$h1_color.";margin-left:12px;'><i class='fas fa-chevron-circle-right'></i> 動画詳細へ</div></a>";
					$htmlRight .= "<td style='vertical-align:top;'>";
					$htmlRight .= "<div class='cls_article_title'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html'>".mb_strimwidth(strip_tags($item2['item_title']), 0, 90, "...", 'UTF-8')."</a></div>";
					$htmlRight .= "<div class='cls_article_body'>".mb_strimwidth(strip_tags($item2['item_description']), 0, 120, "...", 'UTF-8')."</div>";
					$htmlRight .= "<br>";
					$htmlRight .= "<div style='width:100%;text-align:right;'>投稿日：".date("Y.m.d H:i",strtotime($item2['publish_datime']))."</div>";
					$htmlRight .= "<div style='width:100%;text-align:right;'><i class='fas fa-play-circle'></i> 視聴時間：".$item2['duration'];
					$htmlRight .= "　<i class='far fa-eye'></i> 視聴回数：".number_format($item2['view_count'])."回</div>";
					$htmlRight .= "<div style='width:100%;text-align:right;'><i class='far fa-thumbs-up'></i> いいね：".number_format($item2['like_count'])."件";
					$htmlRight .= "　<i class='far fa-star'></i> お気に入り：".number_format($item2['favorite_count'])."件";
					$htmlRight .= "　<i class='far fa-comment'></i> コメント：".number_format($item2['comment_count'])."件<div>";
				}
				$htmlRight .= "</table>\n";

				$ModelApiChannelItem = new ModelApiChannelItem();
				$data = array(
					"user_id"=>ADMIN_USER_ID,
					"api_channel_id"=>$api_channel_id
				);
				$dcnt = $ModelApiChannelItem->count($data);
				
				//ページ
				$max_page = ceil($dcnt / $max_cnt);
				$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/channel/".$api_channel_id."/","/");
				$htmlRight .= "<br>";

				//チャンネルヘッダー
				if ($item['api_channel_footer'] != "") {
					$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($item['api_channel_footer']))."</div><br>\n";
				}
				$htmlRight .= "</div>\n";
			}
			$htmlRight = str_replace("[index_contents]","",$htmlRight);
			$htmlRight = str_replace("//channel","/channel",$htmlRight);

			//中央広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_middle]</div>\n";

			//フッター広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_footer]</div>\n";

			$site_title = $api_channel_title." - ".$site_title;
			break;

		case "channel_item":
			$api_channel_id = $_GET["channel"];
			$api_item_id = $_GET["id"];
			$item_image .= <<<EOF
<div id="player"></div>
<script>
var tag = document.createElement('script');

tag.src = "https://www.youtube.com/iframe_api";
var firstScriptTag = document.getElementsByTagName('script')[0];
firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

var player;
function onYouTubeIframeAPIReady() {
	player = new YT.Player('player', {
		height: '400',
		width: '95%',
		videoId: '$api_item_id',
	});
}
</script>
EOF;

			$rs = getApiChannel(ADMIN_USER_ID,$api_channel_id);
			while ($item = mysqli_fetch_array($rs)) {
				$api_channel_title = $item['api_channel_title'];
				$api_contents_header = $item['api_contents_header'];
				$api_contents_footer = $item['api_contents_footer'];
				$video_contents = $item['video_contents'];
				$cushion_flag = $item['cushion_flag'];
			}
		
			$rs2 = getApiChannelItem(ADMIN_USER_ID,$api_channel_id,$api_item_id,$offset,$max_cnt);
			while ($item2 = mysqli_fetch_array($rs2)) {
				$item_description = $item2['item_description'];
				$item_description = str_replace("\n","<br>",$item_description);
				$item_description = str_replace("。","。<br>",$item_description);

				$item_title = $item2['item_title'];

				if ($cushion_flag == "Y") {
					$url = "${sub_dir}/link/channel/".$api_channel_id."/".$api_item_id."/";
				} else {
					$url = "https://www.youtube.com/watch?v=".$api_item_id;
				}

				$htmlRight .= "<div class='section-box'>\n";
				$htmlRight .= "<h1><i class='fas fa-video'></i> ".$item2['item_title']."</h1>\n";
				$htmlRight .= "<br>";
				if (trim($video_contents) != "") {
					$htmlRight .= "<div class='contents-overlay-wrap cls_none'>";
					$htmlRight .= "<div class='contents-overlay'>".unEscapeHTML(unCrLfHTML($video_contents));
					$htmlRight .= "<div class='contents-overlay-close'><i class='fas fa-times-circle'></i></div>";
					$htmlRight .= "</div>";
					$htmlRight .= "</div>";
				}
				$htmlRight .= "<div class='item_image' style='position:relative;'>".$item_image."</div><br>";
				$htmlRight .= "<b style='font-size:130%;'><a href='".$url."' target='_blank'>".$item2['item_title']."</a></b>\n";
				$htmlRight .= "<br><br>";
				//詳細ページヘッダー
				if ($api_contents_header != "") {
					$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($api_contents_header))."</div><br>\n";
				}
				$htmlRight .= "<table width=100%>";
				$htmlRight .= "<tr>";
				$htmlRight .= "<td>";
				$htmlRight .= "<div>".$item_description."</div>";
				$htmlRight .= "<br>";
				$htmlRight .= "<b style='font-size:110%;'>チャンネル：<a href='${sub_dir}/{$user_name}/channel/".$api_channel_id."/'><i class='fas fa-podcast'></i> <b>".$api_channel_title."</b></a></b><br>";
				$htmlRight .= "<br>";
				$htmlRight .= "<b style='font-size:130%;'><a href='".$url."' target='_blank'>".$item2['item_title']."</a></b><br>\n";
				$htmlRight .= "<div style='width:100%;text-align:right;'>投稿日：".date("Y.m.d H:i",strtotime($item2['publish_datime']))."</div>";
				$htmlRight .= "<div style='width:100%;text-align:right;'><i class='fas fa-play-circle'></i> 視聴時間：".$item2['duration'];
				$htmlRight .= "　<i class='far fa-eye'></i> 視聴回数：".number_format($item2['view_count'])."回</div>";
				$htmlRight .= "<div style='width:100%;text-align:right;'><i class='far fa-thumbs-up'></i> いいね：".number_format($item2['like_count'])."件";
				$htmlRight .= "　<i class='far fa-star'></i> お気に入り：".number_format($item2['favorite_count'])."件";
				$htmlRight .= "　<i class='far fa-comment'></i> コメント：".number_format($item2['comment_count'])."件<div>";
				$htmlRight .= "</table>\n";
				$htmlRight .= "<br><br>";
				//詳細ページフッター
				if ($api_contents_footer != "") {
					$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($api_contents_footer))."</div><br>\n";
				}
				$htmlRight .= <<<EOF
<script type="text/javascript">
$(document).ready(function() {
	$(".contents-overlay-wrap").fadeIn(1000);
});
$(document).on("click", ".contents-overlay-close", function(){
	$(this).parent().parent().html("");
});
$(window).on('scroll load',function(){
	var top = $(window).scrollTop();
	$(".contents-overlay-wrap").css("top",top);
});
</script>
</script>
EOF;
			}

			$rs = getApiChannel(ADMIN_USER_ID,$api_channel_id);
			while ($item = mysqli_fetch_array($rs)) {
				$htmlRight .= "<h2><i class='fas fa-podcast'></i> ".$item['api_channel_title']."</h2>\n";
				//チャンネルヘッダー
				//if ($item['api_channel_header'] != "") {
				//	$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($item['api_channel_header']))."</div>\n";
				//}
				$htmlRight .= "<table width=100% class='channel-box'>";
				$htmlRight .= "<tr>";
				$htmlRight .= "<td class='link-box-medium' style='width:220px;vertical-align:top;'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/'><div class='link-box link-box-medium' style='background-image: url(\"".$item['small_image_url']."\");'></div></a>";
				$htmlRight .= "<div style='padding-left:20px;margin-top:10px;'><a href='https://www.youtube.com/channel/".$item['api_channel_id']."?sub_confirmation=1' target='_blank' style='text-decoration:none;'><div class='page-button' style='background-color:#333;width:130px;'><i class='fas fa-plus-circle'></i> チャンネル登録</div></a></div>";
				$htmlRight .= "<td style='vertical-align:top;'>";
				$htmlRight .= "<div class='cls_article_title'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/'><i class='fas fa-podcast'></i> ".$item['api_channel_title']."</a></div>";
				$htmlRight .= "<div>".$item['api_channel_description']."</div>";
				$htmlRight .= "<br>\n";
				$htmlRight .= "<div><i class='far fa-eye'></i> 総視聴回数：".number_format($item['view_count'])."回</div>";
				$htmlRight .= "<div><i class='fas fa-video'></i> 動画数：".number_format($item['video_count'])."</div>";
				$htmlRight .= "<div><i class='fas fa-user-friends'></i> チャンネル登録者数：".number_format($item['subscriber_count'])."人</div>";
				$htmlRight .= "</table>\n";
				$htmlRight .= "<br>\n";
				$htmlRight .= "<h3><i class='fas fa-video'></i> 人気の動画 (".$item['api_channel_title'].")</h3>\n";
				$htmlRight .= "<table class='cls_tbl_list'>";
				$rs2 = getApiChannelItem(ADMIN_USER_ID,$api_channel_id,"",0,$design_json["blog_top_count"]);
				while ($item2 = mysqli_fetch_array($rs2)) {
					$htmlRight .= "<tr>";
					$htmlRight .= "<td width=100px>";
					$htmlRight .= "<div class='cls_article_link' style='padding-bottom:4px'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html'><div class='link-box link-box-medium' style='background-image: url(\"".$item2['small_image_url']."\");'></div></a></div>";
					$htmlRight .= "<a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html' style='text-decoration:none;'><div class='page-button' style='background-color:".$h1_color.";margin-left:12px;'><i class='fas fa-chevron-circle-right'></i> 動画詳細へ</div></a>";
					$htmlRight .= "<td>";
					$htmlRight .= "<div class='cls_article_title'><a href='${sub_dir}/{$user_name}/channel/".$item['api_channel_id']."/".$item2['api_item_id'].".html'>".mb_strimwidth(strip_tags($item2['item_title']), 0, 90, "...", 'UTF-8')."</a></div>";
					$htmlRight .= "<div class='cls_article_body'>".mb_strimwidth(strip_tags($item2['item_description']), 0, 120, "...", 'UTF-8')."</div>";
					$htmlRight .= "<div style='width:100%;text-align:right;'>投稿日：".date("Y.m.d H:i",strtotime($item2['publish_datime']))."</div>";
					$htmlRight .= "<div style='width:100%;text-align:right;'><i class='fas fa-play-circle'></i> 視聴時間：".$item2['duration'];
					$htmlRight .= "　<i class='far fa-eye'></i> 視聴回数：".number_format($item2['view_count'])."回</div>";
					$htmlRight .= "<div style='width:100%;text-align:right;'><i class='far fa-thumbs-up'></i> いいね：".number_format($item2['like_count'])."件";
					$htmlRight .= "　<i class='far fa-star'></i> お気に入り：".number_format($item2['favorite_count'])."件";
					$htmlRight .= "　<i class='far fa-comment'></i> コメント：".number_format($item2['comment_count'])."件<div>";
				}
				$htmlRight .= "</table>\n";

				$ModelApiChannelItem = new ModelApiChannelItem();
				$data = array(
					"user_id"=>ADMIN_USER_ID,
					"api_channel_id"=>$api_channel_id
				);
				$dcnt = $ModelApiChannelItem->count($data);
				
				//ページ
				$max_page = ceil($dcnt / $max_cnt);
				$htmlRight .= getPagerHtml($page,$max_page,"${sub_dir}/{$user_name}/channel/".$api_channel_id."/","/");
				$htmlRight .= "<br>";

				//チャンネルフッター
				//if ($item['api_channel_footer'] != "") {
				//	$htmlRight .= "<div>".unEscapeHTML(unCrLfHTML($item['api_channel_header']))."</div><br>\n";
				//}
			}
			$htmlRight .= "</div>\n";

			$htmlRight = str_replace("[index_contents]","",$htmlRight);
			$htmlRight = str_replace("//channel","/channel",$htmlRight);

			//中央広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_middle]</div>\n";

			//フッター広告
//			$htmlRight .= "<div class='section-box'>[tag_contents_footer]</div>\n";

			$site_title = $item_title." - ".$site_title;
			break;
	}

	$htmlRight .= "</div>";

	//トップページ編集(ヘッダー)
	$rs = getIndexPage(ADMIN_USER_ID);
	$index_contents = "";
	while ($item = mysqli_fetch_array($rs)) {
		//$url = SETTING_URL;
		$url = "";
		$item['page_body'] = str_replace("/home/admin/",$url."/home/admin/",$item['page_body']);
		$index_contents .= "<div class='section-box index-contents'>".unEscapeHTML(unCrLfHTML($item['page_body']))."</div>\n";
		break;
	}
	$htmlRight = str_replace("[index_contents]",$index_contents,$htmlRight);

	//トップページ編集(中央)
	$rs = getIndexPage(ADMIN_USER_ID,"index_m");
	$index_contents = "";
	while ($item = mysqli_fetch_array($rs)) {
		//$url = SETTING_URL;
		$url = "";
		$item['page_body'] = str_replace("/home/admin/",$url."/home/admin/",$item['page_body']);
		$index_contents .= "<div class='section-box index-contents'>".unEscapeHTML(unCrLfHTML($item['page_body']))."</div>\n";
		break;
	}
	$htmlRight = str_replace("[index_contents_middle]",$index_contents,$htmlRight);

	//トップページ編集(フッター)
	$rs = getIndexPage(ADMIN_USER_ID,"index_b");
	$index_contents = "";
	while ($item = mysqli_fetch_array($rs)) {
		//$url = SETTING_URL;
		$url = "";
		$item['page_body'] = str_replace("/home/admin/",$url."/home/admin/",$item['page_body']);
		$index_contents .= "<div class='section-box index-contents'>".unEscapeHTML(unCrLfHTML($item['page_body']))."</div>\n";
		break;
	}
	$htmlRight = str_replace("[index_contents_footer]",$index_contents,$htmlRight);

	$htmlRight = str_replace("[admin_info_contents]","",$htmlRight);

	$htmlRight .= "</div>";

	$htmlRight = str_replace("//index/","/index/",$htmlRight);
	$htmlRight = str_replace("//link/","/link/",$htmlRight);
	$htmlRight = str_replace("//rss/","/rss/",$htmlRight);
	$htmlRight = str_replace("//feed/","/feed/",$htmlRight);
	$htmlRight = str_replace("//request/","/request/",$htmlRight);
	$htmlRight = str_replace("//rss_category/","/rss_category/",$htmlRight);
	
	$htmlRight = cnvContents($htmlRight);

	$html_script .= <<<EOF
$(document).on("click", "#btn_entry", function(){
	$("#frmEntry").submit();
});
EOF;

	//ヘッダ部
	$title = "";
	$description = "";
	$keywords = "";
	getHeaderHTML($title,$description,$keywords);

	print $htmlRight;

	//メニュー
	getMenuHTML(ADMIN_USER_ID);

	//フッター
	getFooterHTML();

	endProc();
?>
