var _baseOptions = {
	chart: {
		type: 'line',
		marginTop: 40,
		marginBottom: 30,
		zoomType: 'x'
	},
	credits: {
		enabled: false
	},
	title: {
		text: null
	},
	yAxis: {
		title: {
			text: null
		},
		plotLines: [
			{
				value: 0,
				width: 1,
				color: '#808080'
			}
		]
	},
	plotOptions: {
		line: {
			marker: {
				enabled: false
			}
		}
	},
	tooltip: {
		formatter: function() {
			return this.x +'<br>'+ this.series.name + ': ' +  this.y +'円';
		}
	},
	legend: {
		layout: 'vertical',
		align: 'right',
		verticalAlign: 'top',
		borderWidth: 0,
		floating: true,
		x: -20
	},
};

var _baseHighcharts = {
	credits: {
		enabled: false
	},
	title: {
		text: null
	},
	chart: {
		marginTop: 36
	},
	rangeSelector: {
		selected: 0,
		buttonSpacing: 6,
		inputDateFormat: '%Y/%m/%d',
		inputEditDateFormat: '%Y/%m/%d',
		buttons : [{
			type : 'day',
			count : 1,
			text : '1日'
		}, {
			type : 'year',
			count : 1,
			text : '1年'
		}, {
			type : 'all',
			count : 1,
			text : '全期間'
		}]
	},
	legend: {
		enabled :true,
		layout: 'horizontal',
		align: 'right',
		verticalAlign: 'top',
		borderWidth: 1,
		backgroundColor: '#f6f6f6',
		floating: true,
		y: -10
	},
	tooltip: {
		dateTimeLabelFormats: {
			minute: "%Y/%m/%d %H:%M"
		}
	},
/*
	xAxis: [{
		dateTimeLabelFormats: {
			day: "%Y/%m/%d"
		}
	}],
*/
	yAxis: {
		labels: {
			align: 'right',
			x: -2
		},
		lineWidth: 1
	}
};


function initHighcharts() {
	Highcharts.setOptions({
		global: {
			useUTC: false
		},
		lang: {
			rangeSelectorZoom: '表示範囲：',
			resetZoom: '表示期間をリセット',
			resetZoomTitle: '表示期間をリセット',
			rangeSelectorFrom: '表示期間：',
			rangeSelectorTo: '〜',
			months: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
			weekdays: ['日', '月', '火', '水', '木', '金', '土'],
			numericSymbols: null
		}
	});
}

function utc2dateString(utc_msec) {
	d=new Date();
	d.setTime(utc_msec);
	return d.getFullYear()+'/'+(d.getMonth()+1)+'/'+d.getDate();
}