<?php
	include("./include/config.php");
	include("./include/getdata.php");
	//include("getlocal.php");

	use \FeedWriter\RSS2;	// エイリアスの作成

function html_feed() {
	global $design_json;
	global $site_title;
	global $site_url;
	global $site_description;

	setSiteInfo();

	// デフォルトのタイムゾーンをセット
	date_default_timezone_set( "Asia/Tokyo" );

	$feed = new RSS2;

	// チャンネル情報の登録
	$feed->setTitle($site_title);											// チャンネル名
	$feed->setLink($site_url);												// URLアドレス
	$feed->setDescription($site_description);								// チャンネル紹介テキスト
//	$feed->setImage($site_title,$site_url,$site_url."/images/title.png");	// ロゴなどの画像
	$feed->setDate(date("Y-m-d H:i:s"));									// フィードの更新時刻
	$feed->setChannelElement("language","ja-JP");							// 言語
	$feed->setChannelElement("pubDate",date(DATE_RFC822));					// フィードの変更時刻
	$feed->setChannelElement("category","Blog");							// カテゴリー

	//最新世代取得
	$mdate = getGeneration();

	//指数データ表示
	$rs = getIndexDailyAll($mdate);
	while ($item = mysqli_fetch_array($rs)) {
		$end_value = $item['end_value'];
		$diff_value = $item['diff_value'];
		$diff_rate = $item['diff_rate'];
		$mcode = $item['m_code'];
		$mname = getMcodeName($mcode);
		
		if ($mname != "") {
			$feed_title = $mname."(".$mname."/JPY)【最新終値】";
			$context = "";
			$context .= $mname."(".$mname."/JPY)の終値は".number_format($end_value,2)."です。";
			$context .= "前日比は".number_format($diff_value,2)."(".number_format($diff_rate*100,2)."%)です。";
			$context .= "(".str_replace("-","/",$mdate)."現在)";

			// インスタンスの作成
			$feedItem = $feed->createNewItem();
			
			// アイテムの情報
			$feedItem->setTitle($feed_title);							// タイトル
			$feedItem->setLink("/index/".$mcode.".htm");				// リンク
			$feedItem->setDescription($context);						// 紹介テキスト
			$feedItem->setDate(strtotime($mdate));						// 更新日時
			$feedItem->setId($site_url,true);							// 一意のID(第1引数にURLアドレス、第2引数にtrueで通常は大丈夫)

			// アイテムの追加
			$feed->addItem($feedItem);
		}
	}

	// コードの生成
	$xml = $feed->generateFeed();

	// ファイルの保存場所を設定
	//$file = SITE_PATH."home/".$user_id."/rss.xml" ;

	// ファイルの保存を実行
	//file_put_contents($file,$xml ) ;

	header('Content-type:application/rss+xml;charset=UTF-8');
	$contents .= $xml;

	return($contents);
}
?>


