<?php

class ModelApiChannel extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_API_CHANNEL";
		$this->columns = array(
			"user_id"=>"index",
			"api_channel_id"=>"index",
			"api_service"=>"",
			"api_channel_title"=>"",
			"api_channel_description"=>"",
			"small_image_url"=>"",
			"medium_image_url"=>"",
			"large_image_url"=>"",
			"view_count"=>"",
			"comment_count"=>"",
			"subscriber_count"=>"",
			"video_count"=>"",
			"publish_datime"=>"",
			"api_contents_header"=>"",
			"api_contents_footer"=>"",
			"api_time_stamp"=>"",
			"time_stamp"=>"",
			"api_channel_view"=>"",
			"api_channel_header"=>"",
			"api_channel_footer"=>"",
			"cushion_flag"=>"",
			"cushion_contents_header"=>"",
			"cushion_contents_footer"=>"",
			"video_contents"=>"",
			"api_channel_contents"=>""
		);
	}
	// メイン処理(insertControl)
	function insertControl() {
		$this->posts["api_time_stamp"] = date('Y-m-d H:i:s', strtotime("23 hours"));
		$rtn = parent::insertControl();
		return($rtn);
	}
	// メイン処理(searchChannel)
	function searchChannel($keys,$params) {
		global $design_json;

		$api_id = $design_json["youtube_api_id"];
		$search_keyword = $this->gets["search_keyword"];
		$api_service = $this->gets["api_service"];
		$api_sort = $this->gets["api_sort"];
		//print $api_id."===<br>";
		//print $search_keyword."===<br>";
		//print $api_service."===<br>";
		//print $api_sort."===<br>";

		$querys = array(
			"type" => "channel",
			"part" => "snippet",
			"maxResults" => 50,
			'regionCode' => 'JP',
			'order' => $api_sort,	//date,viewCount
			'q'=> $search_keyword,
			"key" => $api_id
		);
		$query = "";
		foreach ($querys as $key => $value) {
			$query .= $key . "=" . $value . "&";
		}
		$query = substr($query, 0, -1);
		$url = "https://www.googleapis.com/youtube/v3/search?".$query;
		//print "url=".$url."<br>";

		$data = file_get_contents($url);
		$response = json_decode($data);

		//print_r($response);

		$data = [];
		$cnt = 0;
		foreach ($response->items as $key => $value) {
			$rec = [];
			$rec["api_service"] = $api_service;
			$rec["api_channel_id"] = $value->snippet->channelId;
			$rec["api_channel_title"] = $value->snippet->title;
			$rec["api_channel_description"] = $value->snippet->description;
			$rec["small_image_url"] = $value->snippet->thumbnails->default->url;
			$rec["medium_image_url"] = $value->snippet->thumbnails->medium->url;
			$rec["large_image_url"] = $value->snippet->thumbnails->high->url;
			$rec["publish_datime"] = $value->snippet->publishedAt;
			$data[] = $rec;
		}
		$tmp = [];
		$tmp["data"] = $data;
		$json = json_encode($tmp);
		print($json);
		//return($json);
	}
	// メイン処理(Common)
	function commonControl($func) {
		$rtn = "";
		switch ($func) {
			case "searchChannel":
				$params = $this->getParams();
				$keys = $this->getIndexes();
				$this->searchChannel($keys,$params);
				break;
		}
		return($rtn);
	}
}
?>