<?php

class ModelRss extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_RSS";
		$this->columns = array(
			"user_id"=>"index",
			"rss_id"=>"index",
			"rss_url"=>"",
			"site_url"=>"",
			"site_title"=>"",
			"category_id"=>"",
			"sort_no"=>"",
			"article_time"=>"",
			"time_stamp"=>""
		);
	}
	// メイン処理(select)
	function selectControl() {
		$this->columns["rss_url"] = "index";
		$this->columns["site_url"] = "index";
		$sql = "select a.*,b.category_name from ".$this->tblname." a";
		$sql .= " left join ".TABLE_PREFIX."_RSS_CATEGORY b on b.user_id = a.user_id and b.category_id = a.category_id";
		$sql .= " where ".$this->getConds($this->getIndexes(),"a");
		$sql .= " order by a.rss_id";
		$json = $this->query($sql);
		return($json);
	}
	// メイン処理(count)
	function countControl() {
		$this->columns["rss_url"] = "index";
		$this->columns["site_url"] = "index";
		$rtn = parent::countControl();
		return($rtn);
	}
	// メイン処理(insert)
	function insertControl() {
		$this->posts["rss_id"] = createID();
		$rtn = parent::insertControl();
		if ($this->posts["rss_url"] != "") {
			$sub_dir = getSubDir();
			//RSS-XML取得
			//exec("nohup php -c '' '".SITE_PATH."/cron_rss.php?user_id=".$this->posts["user_id"]."&rss_id=".$this->posts["rss_id"]."' > /dev/null &");	//動作不可
			header("Location:${sub_dir}/local/cron_rss.php?user_id=".$this->posts["user_id"]."&rss_id=".$this->posts["rss_id"]);

		}
		return($rtn);
	}
	// メイン処理(update)
	function updateControl() {
		$rtn = parent::updateControl();
		if ($this->posts["rss_url"] != "") {
			$sub_dir = getSubDir();
			//RSS-XML取得
			//exec("nohup php -c '' '".SITE_PATH."cron_rss.php?user_id=".$this->posts["user_id"]."&rss_id=".$this->posts["rss_id"]."' > /dev/null &");	//動作不可
			header("Location:${sub_dir}/local/cron_rss.php?user_id=".$this->posts["user_id"]."&rss_id=".$this->posts["rss_id"]);
		}
		return($rtn);
	}
}
?>