<?php
	include("./include/config.php");
	include("./include/getdata.php");
	include("./include/modelDatabase.php");
	include("./models/page.php");
	include("./models/rss.php");
	include("./models/rssArticle.php");
	include("./models/rssCategory.php");
	include("./models/ngWord.php");
	include("./models/pageComment.php");
	include("./twitter/twitter_oauth.php");
	
	//パラメータ取得
	$page_id = $_GET["pageid"];
	$page_name = $_GET["pagename"];
	$page = $_GET["page"];

	//DB接続
	connect_db();

	$sub_dir = getSubDir();

	setSiteInfo();

	//ユーザ取得
	$user_id = getUserID();

	//page_id取得
	if ($page_name != "") {
		$rs = getPageIdFromName($page_name);
		while ($item = mysqli_fetch_array($rs)) {
			$page_id = $item["page_id"];
		}
		if ($page_id == "") {
			$page_id = $page_name;
		}
	} else {
		$rs = getPageIdFromName($page_id);
		while ($item = mysqli_fetch_array($rs)) {
			$page_id = $item["page_id"];
			$page_name = $item["page_name"];
		}
	}

	//ページ内容
	$data_type = "";
	$rs = getPrivatePage($user_id,$page_id,"all");
	$item = mysqli_fetch_array($rs);
	if ($item['data_type'] == "item") {
		$rs = getRakutenItemPage($user_id,$page_id);
		$item = mysqli_fetch_array($rs);
	} else if ($item['data_type'] == "") {
		$rs = getRakutenRankingItem($user_id,$page_id);
		$item = mysqli_fetch_array($rs);
	}
	if ($item['shop_name'] == "楽天ブックス" && $item['shop_url'] == "") {
		$item['shop_url'] = "https://books.rakuten.co.jp/";
	}

	$page_description = "";
	$html = "";

	if ($item['data_type'] == "page") {
		$html .= "<h1>".$item['page_title']."</h1>\n";
		$html .= getSNSLinkHTML();
		$page_title = $item['page_title'];
		$page_keyword = $item['page_keyword'];
		$page_description = $item['page_description'];
		//$time_stamp = new DateTime($item['time_stamp']);
		$time_stamp = date('Y/m/d', strtotime($item['time_stamp']));

		//オーバレイ広告
		if (trim($item['overlay_tag']) != "") {
			$html .= "<div id='' class='contents-overlay-wrap'>";
			$html .= "<div class='contents-overlay'>".unEscapeHTML(unCrLfHTML($item['overlay_tag']));
			$html .= "<div class='contents-overlay-close'><i class='fas fa-times-circle'></i></div>";
			$html .= "</div>";
			$html .= "</div>";
			$html .= <<<EOF
<script type="text/javascript">
$(document).ready(function() {
	$(".contents-overlay-wrap").fadeIn(1000);
});
$(document).on("click", ".contents-overlay-close", function(){
	$(this).parent().parent().html("");
});
$(window).on('scroll load',function(){
	var top = $(window).scrollTop();
	$(".contents-overlay-wrap").css("top",top);
});
</script>
EOF;
		}

		//ヘッダ広告
		$html .= $tag_contents_header;
		
		$url = "";

		//目次追加
		$item['page_body'] = add_index(unEscapeHTML(unCrLfHTML($item['page_body'])));

		$item['page_body'] = str_replace("/home/admin/",$url."/home/admin/",$item['page_body']);
		$item['page_body'] = str_replace("../../","",$item['page_body']);
		$html .= "<div class='index-content pagelink'>".unEscapeHTML(unCrLfHTML($item['page_body']))."</div><br>\n";
		if ($design_json["page_time_stamp"] != "") {
			//$html .= "<span><i class='far fa-clock'></i> ".$time_stamp->format('Y.m.d')."</span>\n";
			$html .= "<span class='pagelink'><i class='far fa-clock'></i> ".$time_stamp."</span>\n";
		}
		if ($item['category_name'] != "") {
			$html .= "<span class='pagelink'><a href='${sub_dir}/category/".$item['category_id'].".html'><i class='fas fa-tags'></i> ".$item['category_name']."</a></span>";
		}

		//画像リンク取得
		$image_file = "";
		$str = unEscapeHTML(unCrLfHTML($item['page_body']));
		$searchPattern = '/<img.*?src=(["\'])(.+?)\1.*?>/i';
		if(preg_match($searchPattern, $str, $imgurl)){
			$image_file = $imgurl[2];
			$image_file = str_replace("./../../../",$sub_dir,$image_file);
		}
		if ($image_file != "") {
			if (strpos($image_file,"http") === false) {
				if ($sub_dir != "") {
					$image_file = str_replace($sub_dir."/","",$image_file);
				}
				$image_file = $admin_site_url.$image_file;
			}
		}
		if ($image_file == "") {
			$image_file = str_replace($sub_dir,"",$site_url).$title_image_file;
		}

		$url = $admin_site_url."page/".$page_id.".html";
		if ($_GET["account"] != "") {
			$url = $admin_site_url.$_GET["account"]."/page/".$page_id.".html";
		}

		if ($page_description == "") {
			$page_description = strip_tags(unEscapeHTML2($item['page_body']));
		}

		$header_tag .= "<meta property='og:url' content='${url}' />\n";
		$header_tag .= "<meta property='og:title' content='${page_title}' />\n";
		$header_tag .= "<meta property='og:description' content='${page_description}' />\n";
		$header_tag .= "<meta property='og:image' content='${image_file}' />\n";
		//$html .= $header_tag;

		//記事アクセス数
		$ModelPage = new ModelPage();
		$data = array(
			"user_id"=>$user_id,
			"page_id"=>$page_id,
		);
		$params = array(
			"page_access_cnt"=>$item['page_access_cnt']+1,
		);
		$rtn = $ModelPage->update($params,$data);

	} else if ($item['data_type'] == "item") {
		$data_type = "item";
		$html .= "<h1>".$item['item_name']."</h1>\n";
		$html .= getSNSLinkHTML();

		//オーバレイ広告
		if (trim($item2['overlay_tag']) != "") {
			$html .= "<div class='contents-overlay-wrap'>";
			$html .= "<div class='contents-overlay'>".unEscapeHTML(unCrLfHTML($item2['overlay_tag']));
			$html .= "<div class='contents-overlay-close'><i class='fas fa-times-circle'></i></div>";
			$html .= "</div>";
			$html .= "</div>";
			$html .= <<<EOF
<script type="text/javascript">
$(document).ready(function() {
	$(".contents-overlay-wrap").fadeIn(1000);
});
$(document).on("click", ".contents-overlay-close", function(){
	$(this).parent().parent().html("");
});
$(window).on('scroll load',function(){
	var top = $(window).scrollTop();
	$(".contents-overlay-wrap").css("top",top);
});
</script>
EOF;
		}

		$page_title = $item['item_name'];
		$page_keyword = $item['item_keyword'];
		//$time_stamp = new DateTime($item['time_stamp']);
		$time_stamp = date('Y/m/d', strtotime($item['time_stamp']));
	
		//ヘッダ広告
		$html .= $tag_contents_header;

		//ランキング
		$html .= getItemRankingHtml($page_id);

		//APIヘッダ
		if ($item["api_contents_header"] != "") {
			$html .= "<div class='pagelink'>".unEscapeHTML(unCrLfHTML($item['api_contents_header']))."</div>\n";
		}

		$html .= "<br>\n";
		if ($item['medium_image_url'] != "") {
			$html .= "<table>";
			$html .= "<tr><td style='padding-right:20px;'><div><a href='".$item['item_url']."' target='_blank'><img src='".$item['medium_image_url']."' style='width:180px;'></a></div><br>\n";
			$html .= "<td style='vertical-align:top;'><div style='font-size:120%;margin-bottom:16px;'><b>".$item['item_name']."</b></div>";
			$html .= "<div>ショップ：<a href='".$item['shop_url']."' target='_blank'>".$item['shop_name']."</a></div>\n";
			if ($item['item_price'] > 0) {
				$html .= "<div class='price'>価格：".number_format($item['item_price'])." 円</div>\n";
			}
			$html .= "</table>";
		}

		$item_caption = getItemCaption(unEscapeHTML(unCrLfHTML($item['item_caption'])));
//		$html .= "<td><div>".$item_caption."</div><br><br>\n";
		
		$html2 = "<br><br><table><tr>";
		if ($item['small_image_url'] != "") {
			$html2 .= "<td style='padding-right:20px;'><div><a href='".$item['item_url']."' target='_blank'><img src='".str_replace("http://","https://",$item['small_image_url'])."' style='width:90px;'></a></div><br>\n";
		} else if ($item['medium_image_url'] != "") {
			$html2 .= "<td style='padding-right:20px;'><div><a href='".$item['item_url']."' target='_blank'><img src='".str_replace("http://","https://",$item['medium_image_url'])."' style='width:90px;'></a></div><br>\n";
		}
		$html2 .= "<td style='padding-right:20px;vertical-align:top;'>";
		$html2 .= "<div style='font-size:120%;margin-bottom:16px;'><b><a href='".$item['item_url']."' target='_blank'>".$item['item_name']."</a></b></div>";
		if ($item['shop_name'] != "YouTube" && $item['shop_name'] != "DMM") {
			$html2 .= "<div>ショップ：<a href='".$item['shop_url']."' target='_blank'>".$item['shop_name']."</a></div>\n";
		}
		if ($item['item_price'] > 0) {
			$html2 .= "<div class='price'>価格：".number_format($item['item_price'])." 円</div>\n";
		}
		$html2 .= "</table>\n";
		$html2 .= "<br>\n";
		if (strpos($html,"<div class='item_image2'></div>") !== false) {
			$html = str_replace("<div class='item_image2'></div>",$html2,$html);
		} else {
			$html = $html."\n".$html2."\n";
		}

		if ($design_json["page_time_stamp"] != "") {
			//$html .= "<span><i class='far fa-clock'></i> ".$time_stamp->format('Y.m.d')."</span>\n";
			$html .= "<span><i class='far fa-clock'></i> ".$time_stamp."</span>\n";
		}
		if ($item['category_name'] != "") {
			$html .= "<span><a href='${sub_dir}/category/".$item['category_id'].".html'><i class='fas fa-tags'></i> ".$item['category_name']."</a></span>";
		}

		//ランキンググラフ
		$html .= getItemChartHtml($page_id);

		//ランキング
		$html .= getItemRankingHtml($page_id);

		//APIフッタ
		if ($item["api_contents_footer"] != "") {
			$html .= "<br>\n";
			$html .= "<div>".unEscapeHTML(unCrLfHTML($item['api_contents_footer']))."</div>\n";
		}
	} else {
		$html .= "<h1>".$item['item_name']."</h1>\n";
		$html .= getSNSLinkHTML();

		//オーバレイ広告
		if (trim($item['overlay_tag']) != "") {
			$html .= "<div class='contents-overlay-wrap'>";
			$html .= "<div class='contents-overlay'>".unEscapeHTML(unCrLfHTML($item['overlay_tag']));
			$html .= "<div class='contents-overlay-close'><i class='fas fa-times-circle'></i></div>";
			$html .= "</div>";
			$html .= "</div>";
			$html .= <<<EOF
<script type="text/javascript">
$(document).ready(function() {
	$(".contents-overlay-wrap").fadeIn(1000);
});
$(document).on("click", ".contents-overlay-close", function(){
	$(this).parent().parent().html("");
});
$(window).on('scroll load',function(){
	var top = $(window).scrollTop();
	$(".contents-overlay-wrap").css("top",top);
});
</script>
EOF;
		}

		$page_title = $item['item_name'];
		//$time_stamp = new DateTime($item['time_stamp']);
		$time_stamp = date('Y/m/d', strtotime($item['time_stamp']));
	
		//ヘッダ広告
		$html .= $tag_contents_header;

		//ランキング
		$html .= getItemRankingHtml($page_id);

		//APIヘッダ
		if ($item["api_contents_header"] != "") {
			$html .= "<div>".unEscapeHTML(unCrLfHTML($item['api_contents_header']))."</div>\n";
		}
		$html .= "<br>\n";

		$item_image = "";
		if ($item['medium_image_url'] != "") {
			$item_image .= "<table>";
			$item_image .= "<tr><td style='padding-right:20px;'><div><a href='".$item['item_url']."' target='_blank'><img src='".$item['medium_image_url']."' style='width:180px;'></a></div><br>\n";
			$item_image .= "<td style='vertical-align:top;'><div style='font-size:120%;margin-bottom:16px;'><b>".$item['item_name']."</b></div>";
			if ($item['shop_name'] != "YouTube" && $item['shop_name'] != "DMM") {
				$item_image .= "<div>ショップ：<a href='".$item['shop_url']."' target='_blank'>".$item['shop_name']."</a></div>\n";
			}
			if ($item['item_price'] > 0) {
				$item_image .= "<div class='price'>価格：".number_format($item['item_price'])." 円</div>\n";
			}
			$item_image .= "</table>";
		}

		if ($item['shop_name'] == "YouTube") {
			$videoId =$item['item_url'];
			$videoId = substr($videoId,strpos($videoId,"v=")+2);
			$item_image .= <<<EOF
<br><br>
<div id="player"></div>
<script>
var tag = document.createElement('script');

tag.src = "https://www.youtube.com/iframe_api";
var firstScriptTag = document.getElementsByTagName('script')[0];
firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

var player;
function onYouTubeIframeAPIReady() {
	player = new YT.Player('player', {
		height: '400',
		width: '95%',
		videoId: '$videoId',
	});
}
</script>
EOF;
		}

		$item_caption = getItemCaption(unEscapeHTML(unCrLfHTML($item['item_caption'])));
		$item_caption = str_replace("<h1></h1>","",$item_caption);
		$item_caption = str_replace("<h2></h2>","",$item_caption);
		$item_caption = str_replace("<h3></h3>","",$item_caption);
		$item_caption = str_replace("<h4></h4>","",$item_caption);
		$item_caption = str_replace("<h5></h5>","",$item_caption);
		$item_caption = str_replace("<h6></h6>","",$item_caption);
		$item_caption = str_replace("<p></p>","",$item_caption);
		$item_caption = str_replace("<br />","",$item_caption);
		$item_caption = str_replace("<div></div>","",$item_caption);
		$item_caption = str_replace("<p></p>","",$item_caption);

		if (strpos($item_caption,"class='item_large_image'") !== false) {
			$item_image = "";
		} else if (strpos($item_caption,"<div class='item_image'></div>") !== false) {
			$item_caption = str_replace("<div class='item_image'></div>","<div class='item_image'>".$item_image."</div>",$item_caption);
		} else if (strpos($item_caption,"<div>#item_image#</div>") !== false) {
			$item_caption = str_replace("<div>#item_image#</div>","<div class='item_image'>".$item_image."</div>",$item_caption);
		} else {
			$item_caption = $item_image."<div>".$item_caption."</div>\n";
		}
		$html .= "<div>".$item_caption."</div>\n";

		$html2 = "<br><br><table><tr>";
		if ($item['small_image_url'] != "") {
			$html2 .= "<td style='padding-right:20px;'><div><a href='".$item['item_url']."' target='_blank'><img src='".str_replace("http://","https://",$item['small_image_url'])."' style='width:90px;'></a></div><br>\n";
		}
		$html2 .= "<td style='padding-right:20px;'>";
		$html2 .= "<div style='font-size:120%;margin-bottom:16px;'><b><a href='".$item['item_url']."' target='_blank'>".$item['item_name']."</a></b></div>";
		if ($item['shop_name'] != "YouTube" && $item['shop_name'] != "DMM") {
			$html2 .= "<div>ショップ：<a href='".$item['shop_url']."' target='_blank'>".$item['shop_name']."</a></div>\n";
		}
		if ($item['item_price'] > 0) {
			$html2 .= "<div class='price'>価格：".number_format($item['item_price'])." 円</div>\n";
		}
		$html2 .= "</table>\n";
		$html2 .= "<br>\n";

		if (strpos($html,"<div class='item_image2'></div>") !== false) {
			$html = str_replace("<div class='item_image2'></div>",$html2,$html);
		} else if (strpos($html,"<div>#item_image2#</div>") !== false) {
			$html = str_replace("<div>#item_image2#</div>",$html2,$html);
		} else {
			$html = $html."\n".$html2."\n";
		}

		//if ($design_json["page_time_stamp"] != "") {
		//	$html .= "<span><i class='far fa-clock'></i> ".$time_stamp."</span>\n";
		//}
		if ($item['category_name'] != "") {
			$html .= "<span><a href='${sub_dir}/category/".$item['category_id'].".html'><i class='fas fa-tags'></i> ".$item['category_name']."</a></span>";
			$html .= "<br>\n";
		}

		$html .= "<div style='text-align:center;'><a href='".$item['item_url']."' style='text-decoration:none;display:inline-block;' target='_blank'><div class='link-button' style='background-color:".$h1_color.";'>詳細はこちら</div></a></div>";

		//ランキンググラフ
		$html .= getItemChartHtml($page_id);

		//ランキング
		$html .= getItemRankingHtml($page_id);

		//APIフッタ
		if ($item["api_contents_footer"] != "") {
			$html .= "<br>\n";
			$html .= "<div>".unEscapeHTML(unCrLfHTML($item['api_contents_footer']))."</div>\n";
		}
	}

	$html .= "<br>\n";

	$user_name = $_GET["account"];
	if ($user_name != "") {
		$html = str_replace("href='${sub_dir}/","href='${sub_dir}/${user_name}/",$html);
	}

	$html .= "<br><br>\n";

	//コメント
	if ($item['page_comment_flag'] != "N") {
		$html .= getPageCommentbox($user_id,$page_id);
		$html .= "<form></form>\n";
		$html .= "<form id='frmEntry' action='./${page_id}.html' method='post'>";
		$html .= "<table cellpadding=5 style='font-size:85%;'>\n";
		$html .= "<tr><td style='vertical-align:top;'>名前：<td><input type='text' id='comment_user' name='comment_user' style='font-size:100%;min-width:580px;border-radius:0px;'>\n";
		$html .= "<tr><td style='vertical-align:top;'>コメント：<td><textarea id='comment_body' name='comment_body' style='font-size:100%;min-width:580px;'></textarea>\n";
		$html .= "<tr><td><td><div><input type='button' id='btn_entry' name='btn_entry' value='コメントを登録する' style='font-size:100%;background-color:#0088cc;'></div>";

		if ($_POST["comment_body"] != "") {
			$comment_id = createID();
			//コメント登録
			$ModelPageComment = new ModelPageComment();
			$data = array(
				"user_id"=>$user_id,
				"page_id"=>$page_id,
				"comment_id"=>$comment_id,
				"comment_user"=>$_POST["comment_user"],
				"comment_body"=>$_POST["comment_body"],
				"enable_flag"=>"N",
				"time_stamp"=>date("Y-m-d H:i:s")
			);
			$ModelPageComment->insert($data);

			$html .= "<tr><td><td><br><b>コメントが登録されました。掲載までしばらくお待ちください。</b>\n";
		}

		$html .= "</table>\n";
		$html .= "</form>";
		$html .= "<br>\n";

		$html .= <<<EOF
<script type="text/javascript">
$(document).on("click", "#btn_entry", function(){
	$("#comment_body").val(escapeHTML($("#comment_body").val()));
	if ($("#comment_body").val().trim() == "") {
		alert("コメントを入力してください。");
		return;
	}
	$("#frmEntry").submit();
});
</script>
EOF;
	}


	$html = str_replace("section-box","",$html);
	$html = str_replace("#item_image2#","",$html);
	$html = "<div class='section-box'>\n".$html."</div>\n";

	//ヘッダ部
	$title = $page_title;
	if ($page_description == "") {
		$description = $page_title."。".$site_description;
	} else {
		$description = $page_description;
	}
	$keywords = $page_keyword;
	getHeaderHTML($title,$description,$keywords);

	$html = str_replace("■<br>■","■■",$html);
	$html = str_replace("■<br>■","■■",$html);
	$html = str_replace("▼<br>▼","▼▼",$html);
	$html = str_replace("▼<br>▼","▼▼",$html);
	$html = str_replace("●<br>●","●●",$html);
	$html = str_replace("●<br>●","●●",$html);

	$html = str_replace("■ ","■<br>",$html);
	$html = str_replace(" ■","<br>■",$html);
	$html = str_replace("▼ ","▼<br>",$html);
	$html = str_replace(" ▼","<br>▼",$html);
	$html = str_replace("● ","●<br>",$html);
	$html = str_replace(" ●","<br>●",$html);

	$html = str_replace("＜p＞","",$html);
	$html = str_replace("＜/p＞","",$html);
	$html = str_replace("＜br /＞","",$html);

	print $html;

	//中央広告
	print "<div class='section-box'>".$tag_contents_middle."</div>\n";

	/*
	if ($design_json["page_disp_bitcoin"] != "") {
		if ($design_json["local_db"] == "") {
			//APIコンテンツ取得
			$contents = apiContents("/html_page/");
		} else {
			//ローカルコンテンツ取得
			$contents = html_page();
			$contents = cnvContents($contents);
		}
	
		print $contents;
		print "<br><br>\n";
	}
	*/

	if ($design_json["page_contents_list"] != "") {
		//ページリンク
		print getPageLinkBox($user_id,"",$data_type);

		//ページャ
		$cnt = getPrivatePageCount($user_id,"","",$data_type);
		print getPagePagination(1,$cnt,$data_type);
	}


	if ($item['data_type'] != "page") {
		$html = "";
		//楽天ランキングAPI表示
		if ($design_json["page_rank"] != "") {
			$rank_genre_id = [];
			for ($i = 1; $i <= 5; $i++) {
				if ($design_json["page_rank_genre_".$i] != "") {
					$rank_genre_id[] = $design_json["page_rank_genre_id_".$i];
				}
			}
			foreach ($rank_genre_id as $key => $value) {
				switch ($design_json["page_rank_genre_type_".($key+1)]) {
					case "5×1":
						$html .= getPageRankingHTML_5_1($user_id,$value,$genre_json[$value],"");
						break;
					case "5×2":
						$html .= getPageRankingHTML_5_2($user_id,$value,$genre_json[$value],"");
						break;
					case "5×4":
						$html .= getPageRankingHTML_5_4($user_id,$value,$genre_json[$value],"");
						break;
					case "4×1":
						$html .= getPageRankingHTML_4_1($user_id,$value,$genre_json[$value],"");
						break;
					case "4×2":
						$html .= getPageRankingHTML_4_2($user_id,$value,$genre_json[$value],"");
						break;
					case "4×3":
						$html .= getPageRankingHTML_4_3($user_id,$value,$genre_json[$value],"");
						break;
					case "2×5":
						$html .= getPageRankingHTML_2_5($user_id,$value,$genre_json[$value],"");
						break;
					case "3×2":
						$html .= getPageRankingHTML_3_2($user_id,$value,$genre_json[$value],"");
						break;
					case "3×3":
						$html .= getPageRankingHTML_3_3($user_id,$value,$genre_json[$value],"");
						break;
					case "1×5":
						$html .= getPageRankingHTML_1_5($user_id,$value,$genre_json[$value],"");
						break;
				}
			}
		}

		//楽天ブックスランキングAPI表示
		if ($design_json["page_rank_rakuten_books"] != "") {
			$rank_rakuten_books_genre_id = [];
			for ($i = 1; $i <= 5; $i++) {
				if ($design_json["page_rank_rakuten_books_genre_".$i] != "") {
					$rank_rakuten_books_genre_id[] = $design_json["page_rank_rakuten_books_genre_id_".$i];
				}
			}
			foreach ($rank_genre_rakuten_books_json_genre_id as $key => $value) {
				switch ($design_json["page_rank_rakuten_books_genre_type_".($key+1)]) {
					case "5×1":
						$html .= getPageRankingHTML_5_1($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "5×2":
						$html .= getPageRankingHTML_5_2($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "5×4":
						$html .= getPageRankingHTML_5_4($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "4×1":
						$html .= getPageRankingHTML_4_1($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "4×2":
						$html .= getPageRankingHTML_4_2($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "4×3":
						$html .= getPageRankingHTML_4_3($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "2×5":
						$html .= getPageRankingHTML_2_5($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "3×2":
						$html .= getPageRankingHTML_3_2($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "3×3":
						$html .= getPageRankingHTML_3_3($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
					case "1×5":
						$html .= getPageRankingHTML_1_5($user_id,$value,$genre_rakuten_books_json[$value],"");
						break;
				}
			}
		}

		//DMMランキングAPI表示
		if ($design_json["page_rank_dmm"] != "") {
			$rank_dmm_genre_id = [];
			for ($i = 1; $i <= 5; $i++) {
				if ($design_json["page_rank_dmm_genre_".$i] != "") {
					$rank_dmm_genre_id[] = $design_json["page_rank_dmm_genre_id_".$i];
				}
			}
			foreach ($rank_dmm_genre_id as $key => $value) {
				switch ($design_json["page_rank_dmm_genre_type_".($key+1)]) {
					case "5×1":
						$html .= getPageRankingHTML_5_1($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "5×2":
						$html .= getPageRankingHTML_5_2($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "5×4":
						$html .= getPageRankingHTML_5_4($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "4×1":
						$html .= getPageRankingHTML_4_1($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "4×2":
						$html .= getPageRankingHTML_4_2($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "4×3":
						$html .= getPageRankingHTML_4_3($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "2×5":
						$html .= getPageRankingHTML_2_5($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "3×2":
						$html .= getPageRankingHTML_3_2($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "3×3":
						$html .= getPageRankingHTML_3_3($user_id,$value,$genre_dmm_json[$value],"");
						break;
					case "1×5":
						$html .= getPageRankingHTML_1_5($user_id,$value,$genre_dmm_json[$value],"");
						break;
				}
			}
		}

		//APEXランキングAPI表示
		if ($design_json["page_rank_apex"] != "") {
			$rank_apex_genre_id = [];
			for ($i = 1; $i <= 5; $i++) {
				if ($design_json["page_rank_apex_genre_".$i] != "") {
					$rank_apex_genre_id[] = $design_json["page_rank_apex_genre_id_".$i];
				}
			}
			foreach ($rank_apex_genre_id as $key => $value) {
				switch ($design_json["page_rank_apex_genre_type_".($key+1)]) {
					case "5×1":
						$html .= getPageRankingHTML_5_1($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "5×2":
						$html .= getPageRankingHTML_5_2($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "5×4":
						$html .= getPageRankingHTML_5_4($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "4×1":
						$html .= getPageRankingHTML_4_1($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "4×2":
						$html .= getPageRankingHTML_4_2($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "4×3":
						$html .= getPageRankingHTML_4_3($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "2×5":
						$html .= getPageRankingHTML_2_5($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "3×2":
						$html .= getPageRankingHTML_3_2($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "3×3":
						$html .= getPageRankingHTML_3_3($user_id,$value,$genre_apex_json[$value],"");
						break;
					case "1×5":
						$html .= getPageRankingHTML_1_5($user_id,$value,$genre_apex_json[$value],"");
						break;
				}
			}
		}

		//AmazonランキングAPI表示
		if ($design_json["page_rank_amazon"] != "") {
			$rank_amazon_genre_id = [];
			for ($i = 1; $i <= 5; $i++) {
				if ($design_json["page_rank_amazon_genre_".$i] != "") {
					$rank_amazon_genre_id[] = $design_json["page_rank_amazon_genre_id_".$i];
				}
			}
			foreach ($rank_amazon_genre_id as $key => $value) {
				switch ($design_json["page_rank_amazon_genre_type_".($key+1)]) {
					case "5×1":
						$html .= getPageRankingHTML_5_1($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "5×2":
						$html .= getPageRankingHTML_5_2($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "5×4":
						$html .= getPageRankingHTML_5_4($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "4×1":
						$html .= getPageRankingHTML_4_1($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "4×2":
						$html .= getPageRankingHTML_4_2($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "4×3":
						$html .= getPageRankingHTML_4_3($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "2×5":
						$html .= getPageRankingHTML_2_5($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "3×2":
						$html .= getPageRankingHTML_3_2($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "3×3":
						$html .= getPageRankingHTML_3_3($user_id,$value,$genre_amazon_json[$value],"");
						break;
					case "1×5":
						$html .= getPageRankingHTML_1_5($user_id,$value,$genre_amazon_json[$value],"");
						break;
				}
			}
		}

		//楽天ランキング(テキスト)
		if ($design_json["page_rank"] != "") {
			if ($design_json["page_rank_text"] != "") {
				foreach ($rank_genre_id as $key => $value) {
					$html .= getPageRankingListHTML($user_id,$value,$genre_json[$value],"",$design_json["page_rank_text_count"]);
				}
			}
		}

		//楽天ブックスランキング(テキスト)
		if ($design_json["page_rank_rakuten_books"] != "") {
			if ($design_json["page_rank_text"] != "") {
				foreach ($rank_dmm_genre_id as $key => $value) {
					$html .= getPageRankingListHTML($user_id,$value,$genre_rakuten_books_json[$value],"",$design_json["page_rank_text_count"]);
				}
			}
		}

		//DMMランキング(テキスト)
		if ($design_json["page_rank_dmm"] != "") {
			if ($design_json["page_rank_text"] != "") {
				foreach ($rank_dmm_genre_id as $key => $value) {
					$html .= getPageRankingListHTML($user_id,$value,$genre_dmm_json[$value],"",$design_json["page_rank_text_count"]);
				}
			}
		}

		//APEXランキング(テキスト)
		if ($design_json["page_rank_apex"] != "") {
			if ($design_json["page_rank_text"] != "") {
				foreach ($rank_apex_genre_id as $key => $value) {
					$html .= getPageRankingListHTML($user_id,$value,$genre_apex_json[$value],"",$design_json["page_rank_text_count"]);
				}
			}
		}

		//Amaxonランキング(テキスト)
		if ($design_json["page_rank_amazon"] != "") {
			if ($design_json["page_rank_text"] != "") {
				foreach ($rank_amazon_genre_id as $key => $value) {
					$html .= getPageRankingListHTML($user_id,$value,$genre_amazon_json[$value],"",$design_json["page_rank_text_count"]);
				}
			}
		}

		print $html;
	}

	
	//フッター広告
	print "<div class='section-box'>".$tag_contents_footer."</div>\n";

	print "</div>\n";

	//メニュー
	getMenuHTML($user_id);

	//フッター
	getFooterHTML();

	//DB切断
	deconnect_db();

function getItemCaption($caption) {
	$item_caption = $caption;
	$item_caption = str_replace("【","<br>【",$item_caption);
	$item_caption = str_replace("】","】<br>",$item_caption);
	//$item_caption = str_replace("・","<br>・",$item_caption);

	$item_caption = str_replace(" 年","年",$item_caption);
	$item_caption = str_replace(" 月","月",$item_caption);
	$item_caption = str_replace(" 日","日",$item_caption);
	//分割(改行)
	$lines = explode("<br>", $item_caption);
	for ($i = 0; $i < count($lines); $i++) {
		if (strpos($lines[$i],"】") !== false) {
			$lines[$i] = "<b>".$lines[$i]."</b>";
		}
		if (strpos($lines[$i],"＜") !== false && strpos($lines[$i],"＞") !== false) {
			$lines[$i] = str_replace("＜","<br><br><b>＜",$lines[$i]);
			$lines[$i] = str_replace("＞","＞</b><br>",$lines[$i]);
		}
	}
	$item_caption = implode("<br>", $lines);
	//分割(空白)
	$lines = explode(" ", $item_caption);
	for ($i = 0; $i < count($lines); $i++) {
		if (strpos($lines[$i],"：") !== false) {
			$lines[$i] = "<br>".$lines[$i];
		}
		if (preg_match('/^[0-9]{2}[.]/',$lines[$i])) {
			$lines[$i] = "<br>".$lines[$i];
		}
		if (preg_match('/^[0-9][.]/',$lines[$i])) {
			$lines[$i] = "<br>".$lines[$i];
		}
		if (preg_match('/^[0-9]{2}$/',$lines[$i])) {
			$lines[$i] = "<br>".$lines[$i];
		}
	}
	$item_caption = implode(" ", $lines);

	$item_caption = str_replace("<br> <br>","<br><br>",$item_caption);
	$item_caption = str_replace("】</b><br><br>","】</b><br>",$item_caption);
	$item_caption = str_replace("＞</b><br><br>","＞</b><br>",$item_caption);
	$item_caption = str_replace("。<br><br>」","。」<br>",$item_caption);
	$item_caption = str_replace("。<br><br><br>※","。<br>※",$item_caption);
	$item_caption = str_replace("<td <br>nowrap>","<td nowrap>",$item_caption);

	//デザイン変更(PRO版)
	if (file_exists(SITE_PATH."/style_pro.css")) {
		$item_caption = str_replace("<table>","<table class='item-caption'>",$item_caption);
		$item_caption = str_replace("<tr><td nowrap>","<tr><th nowrap>",$item_caption);
	}

	$item_caption = str_replace("<div class='review0'>","<div class='review0'><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i> ",$item_caption);
	$item_caption = str_replace("<div class='review1'>","<div class='review0'><i class='far fa-star on-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i> ",$item_caption);
	$item_caption = str_replace("<div class='review2'>","<div class='review0'><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i> ",$item_caption);
	$item_caption = str_replace("<div class='review3'>","<div class='review0'><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star off-star'></i><i class='far fa-star off-star'></i> ",$item_caption);
	$item_caption = str_replace("<div class='review3'>","<div class='review0'><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star off-star'></i> ",$item_caption);
	$item_caption = str_replace("<div class='review5'>","<div class='review0'><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i><i class='far fa-star on-star'></i> ",$item_caption);

	$item_caption = str_replace(" <br>class="," class=",$item_caption);

	return($item_caption);
}

function getItemRankingHtml($item_code) {
	global $genre_json;
	global $genre_dmm_json;
	$html = "";
	$rs = getRakutenItemLatestRanking($item_code);
	while ($item = mysqli_fetch_array($rs)) {
		$rank_name = $genre_json[$item['rank_genre_id']];
		if ($rank_name == "") {
			$rank_name = $genre_dmm_json[$item['rank_genre_id']];
		}
		$html .= "<tr><td style='padding-right:16px;'><span class='rank'><i class='fas fa-chart-line'></i>&nbsp;".$rank_name."ランキング</span><td class='align-right'><span class='rank'>".$item['rank_num']."<span>位</span></span>\n";
	}
	if ($html != "") {
		$html = "<div class='rank-box'><table collspacing=3>".$html."</table></div>";
	}
	return($html);
}

function getItemChartHtml($item_code) {
	global $genre_json;
	$date1 = [];
	$value1 = [];
	$rank1 = [];
	$last_date1 = [];
	$last_updown1 = [];
	$rs = getRakutenItemRanking($item_code,"",0,100);
	while ($item2 = mysqli_fetch_array($rs)) {
		if ($value1[$item2['rank_genre_id']] != "") {
			$value1[$item2['rank_genre_id']] .= ",";
			$date1[$item2['rank_genre_id']] .= ",";
		}

		$day_diff = day_diff($item2['rank_date'],$last_date1[$item2['rank_genre_id']]);
		if ($day_diff > 1 && $last_date1[$item2['rank_genre_id']] != "") {
			$tmp_date = $last_date1[$item2['rank_genre_id']];
			for ($i = 1; $i < $day_diff; $i++) {
				$tmp_date = date('Y-m-d', strtotime('+1 day '. $tmp_date));
				$date1[$item2['rank_genre_id']] .= "'".$tmp_date."',";
				$value1[$item2['rank_genre_id']] .= "1000,";
			}
		}

		$date1[$item2['rank_genre_id']] .= "'".$item2['rank_date']."'";
		$value1[$item2['rank_genre_id']] .= $item2['rank_num'];
		if ($item2['rank_num'] > $rank1[$item2['rank_genre_id']]) {
			$last_updown1[$item2['rank_genre_id']] = "down";
		} else if ($item2['rank_num'] < $rank1[$item2['rank_genre_id']]) {
			$last_updown1[$item2['rank_genre_id']] = "up";
		} else {
			$last_updown1[$item2['rank_genre_id']] = "right";
		}
		$rank1[$item2['rank_genre_id']] = $item2['rank_num'];
		$last_date1[$item2['rank_genre_id']] = $item2['rank_date'];
	}

	$html .= <<<EOF
		<script type="text/javascript" src="../../js/chart.js"></script>
		<script type="text/javascript" src="../../js/highcharts.js"></script>
EOF;

	foreach ($date1 as $key => $value) {
		$rank_name = $genre_json[$key];
		$date = $date1[$key];
		$value = $value1[$key];
		$rank = $rank1[$key];
		$last_date = $last_date1[$key];
		$last_updown = $last_updown1[$key];

		$html .= "<h2><i class='fas fa-chart-line'></i> ".$rank_name."ランキング</h2>\n";
		$html .= "<div class='rank'>&nbsp;".$rank."<span>位</span> <i class='fas fa-arrow-".$last_updown."'></i> <span> (".$last_date.")</span></div>";
		$html .= "<div id='chart_$key' style='width:100%;height:300px;'></div><br><br>\n";
		$html .= <<<EOF
			<script type="text/javascript">
			<!--
			$(document).ready(function() {
				var chartOptions = {
						chart: {
							renderTo: 'chart_$key'
						},
						xAxis: {
							tickInterval: 5,
							labels :{
								rotation:90
							},
							categories: [$date]
						},
						yAxis: [{
								labels: {
									formatter: function() {
										return (this.value);
									},
									style: {
										color: Highcharts.getOptions().colors[2]
									}
								},
								title: {
									text: null,
								},
							},
							{
								labels: {
									formatter: function() {
										if (this.value == 0) {
											this.value = 1;
										}
										return (this.value + "位");
									},
									style: {
										color: Highcharts.getOptions().colors[1]
									}
								},
								title: {
									text: null,
								},
								min:1,
								max:1000,
								tickInterval:100,
								reversed:true
							}
						],
						plotOptions: {
							line: {
								color: '#bf0000'
							}
						},
						tooltip: {
							shared: true,
							crosshairs: true,
							formatter: null
						},
						series: [
							{
								name: '${rank_name}ランキング',
								yAxis: 1,
								data: [$value]
							}
						]
				};
				var chart = new Highcharts.Chart(Highcharts.merge(_baseHighcharts,chartOptions));
			});
			//-->
			</script>
EOF;
	}
	return($html);
}

function day_diff($date1, $date2) { 
	// 日付をUNIXタイムスタンプに変換
	$timestamp1 = strtotime($date1);
	$timestamp2 = strtotime($date2);
	// 何秒離れているかを計算
	$seconddiff = abs($timestamp2 - $timestamp1);
	// 日数に変換
	$daydiff = $seconddiff / (60 * 60 * 24);
	// 戻り値
	return $daydiff;
}

function getSNSLinkHTML() {
	$url = empty($_SERVER["HTTPS"])?"http://":"https://";
	$url = $url.$_SERVER["HTTP_HOST"].$_SERVER["REQUEST_URI"];
	$html = "";
	$html .= "<div class='btn-sns-group'>\n";
	$html .= "<div class='btn-sns btn-hateb'>";
	$html .= "<a href='http://b.hatena.ne.jp/add?mode=confirm&amp;url=".$url."&amp;title=".$item['page_title']."' target='_blank' rel='nofollow'><i class='fas fa-bold'></i><i class='fas fa-exclamation'></i> はてブ</a>";
	$html .= "</div>\n";
	$html .= "<div class='btn-sns btn-facebook'>";
	$html .= "<a href='http://www.facebook.com/share.php?u=".$url."' rel='nofollow' target='_blank'><i class='fab fa-facebook-f'></i> Facebook</a>";
	$html .= "</div>\n";
	$html .= "<div class='btn-sns btn-twitter'>";
	$html .= "<a href='https://twitter.com/share?url=".$url."&amp;&amp;text=".$item['page_title']."' rel='nofollow' target='_blank'><i class='fab fa-twitter'></i> Twitter</a>";
	$html .= "</div>\n";
	$html .= "<div class='btn-sns btn-line'>";
	$html .= "<a href='https://social-plugins.line.me/lineit/share?url=".$url."&amp;title=".$item['page_title']."' target='_blank' rel='nofollow'><i class='fab fa-line'></i> LINE</a>";
	$html .= "</div>\n";
	$html .= "<div class='btn-sns btn-pocket'>";
	$html .= "<a href='http://getpocket.com/edit?url=".$url."&amp;title=".$item['page_title']."' target='_blank' rel='nofollow'></i><i class='fab fa-get-pocket'></i> Pocket</a>";
	$html .= "</div>\n";
	$html .= "</div>\n";
	return($html);
}

function unEscapeHTML2($str) {
	$tmp = unEscapeHTML($str);
	$tmp = str_replace("&amp","&",$tmp);
	$tmp = str_replace("&lt;","<",$tmp);
	$tmp = str_replace("&gt;",">",$tmp);
	$tmp = str_replace("\n","",$tmp);
	return($tmp);
}

//目次追加
function  add_index($content) {
	$index = $content;
	if (strpos($content,"<h2") !== false) {
		$pattern = '/<h[1-6]>(.+?)<\/h[1-6]>/s';
		preg_match_all($pattern, $content, $elements, PREG_SET_ORDER);
		if (count($elements) >= 1) {
			$toc = '';
			$i = 0;
			$currentlevel = 0;
			$id  = 'chapter-';

			foreach ($elements as $element) {
				$id .= $i + 1;
				$regex = '/'.preg_quote($element[0], '/').'/su';
				$replace_title = preg_replace('/<(h[1-6])>(.+?)<\/(h[1-6])>/s', "<$1 id='".$id."'>$2</$3>", $element[0], 1);
				$content = preg_replace($regex, $replace_title, $content, 1);

				if (strpos($element[0], '<h2') !== false) {
					$level = 1;
				} elseif (strpos($element[0], '<h3') !== false) {
					$level = 2;
				} elseif (strpos($element[0], '<h4') !== false) {
					$level = 3;
				} elseif (strpos($element[0], '<h5') !== false) {
					$level = 4;
				} elseif (strpos($element[0], '<h6') !== false) {
					$level = 5;
				}

				while ($currentlevel < $level) {
					if (0 === $currentlevel) {
						$toc .= "<ol class='index-list'>";
					} else {
						$toc .= "<ol class='index-list-child'>";
					}
					$currentlevel++;
				}

				while ($currentlevel > $level) {
					$toc .= "</li></ol>";
					$currentlevel--;
				}

				// 目次の項目で使用する要素を指定
				$toc .= "<li class='index-item'><a href='#".$id."' class='index-link'>".$element[1]."</a>";
				$i++;
				$id = "chapter-";
			}

			// 目次の最後の項目をどの要素から作成したかによりタグの閉じ方を変更
			while ($currentlevel > 0) {
				$toc .= '</li></ol>';
				$currentlevel--;
			}

	//		$index = '<div class="single__index index" id="toc"><div class="index__title">目次<button class="index__button">閉じる</button></div>'.$toc.'</div>';
			$index = "<div class='index-box'><div class='index-title'><i class='fas fa-list'></i> 目次</div>".$toc."</div>\n";
			$index .= $content;
			$h2 = '/<h2.*?>/i';

//			if (preg_match($h2, $content, $h2s) && $index != "") {
//				$content = $index.$content;
//				$content = preg_replace($h2, $index.$h2s[0], $content, 1);
//			}
		}
	}
	return $index;
}

?>
