<?php
	include("./include/config.php");
	include("./include/getdata.php");
	include("./include/modelDatabase.php");
	include("./models/rss.php");
	include("./models/rssArticle.php");
	include("./models/rssCategory.php");
	include("./models/ngWord.php");
	include("./twitter/twitter_oauth.php");

	//パラメータ取得
	$proc = $_GET["proc"];
	$page = $_GET["cpage"];
	$category_id = $_GET["category_id"];

	$url = $_SERVER["REQUEST_URI"];
	$hash = parse_url($url);
	parse_str($hash['query']);
	if ($search_text == "") {
		$search_text = $_POST["id_inp_seacrh"];
	}

	//DB接続
	connect_db();

	setSiteInfo();

	//ユーザ取得
	$user_id = getUserID();

	//ヘッダ広告
	$html .= $tag_contents_header."\n";

	//ページ内容
	if ($proc == "page") {
		$page_title = "記事一覧 ".$page."ページ";
		//ページ内容
		$html .= getPageLinkBox($user_id,"",$page,"",$search_text);
		//ページャ
		$cnt = getPrivatePageCount($user_id,"","","",$search_text);
		$html .= getPagePagination($page,$cnt,"",$search_text);

		//中央広告
		$html .= $tag_contents_middle."<br>\n";
	} else if ($proc == "page_api") {
		$page_title = $design_json["item_link_title"]." ".$page."ページ";
		//ページ内容
		$html .= getPageLinkBox($user_id,"",$page,"item",$search_text);
		//ページャ
		$cnt = getPrivatePageCount($user_id,"","","item",$search_text);
		$html .= getPagePagination($page,$cnt,"item",$search_text);

		//中央広告
		$html .= $tag_contents_middle."<br>\n";
	} else if ($proc == "category") {
		$rs = getPrivatePageFromCategory($user_id,$category_id,"");
		while ($item = mysqli_fetch_array($rs)) {
			$page_title = $item['category_name']." ".$page."ページ";
			break;
		}
		//ページ内容
		$html .= getCategoryPageLinkbox($user_id,$category_id,$page);
		//ページャ
		$cnt = getPrivatePageCount($user_id,"",$category_id,"all");
		$html .= getCategoryPagination($category_id,$page,$cnt);
		//中央広告
		$html .= $tag_contents_middle."<br>\n";
	} else {
		$page_title = "検索結果(".search_text.") ".$page."ページ";
		//ページ内容
		$html .= getPageLinkBox($user_id,"",$page,"",$search_text);
		//ページャ
		$cnt = getPrivatePageCount($user_id,"","","",$search_text);
		$html .= getPagePagination($page,$cnt,"",$search_text);
		$html .= "<br><br>\n";

		//中央広告
		$html .= $tag_contents_middle."<br>\n";

		//ページ内容
		$html .= getPageLinkBox($user_id,"",$page,"item",$search_text);
		//ページャ
		$cnt = getPrivatePageCount($user_id,"","","item",$search_text);
		$html .= getPagePagination($page,$cnt,"item",$search_text);
		$html .= "<br><br>\n";
	}

	//記事リンク
	$links_contents_page = getNewPageLinkbox($user_id,$design_json["page_link_count"]);
	$html .= "<h2><i class='fas fa-edit'></i> 最新記事</h2>\n";
	$html .= $links_contents_page;	
	//ページャ
	$cnt = getPrivatePageCount($user_id,"","","");
	$html .=  getPagePagination(1,$cnt,"");
	$html .= "<br><br>\n";

	//楽天ランキングAPI表示
	$rank_genre_id = [];
	for ($i = 1; $i <= 5; $i++) {
		if ($design_json["page_rank_genre_".$i] != "") {
			$rank_genre_id[] = $design_json["page_rank_genre_id_".$i];
		}
	}
	foreach ($rank_genre_id as $key => $value) {
		$htmlRight .= getPageRankingHTML($user_id,$value,$genre_json[$value],"",$design_json["page_rank_genre_type_".($key+1)]);
	}

	//楽天ブックスランキングAPI表示
	$rank_rakuten_books_genre_id = [];
	for ($i = 1; $i <= 5; $i++) {
		if ($design_json["page_rank_rakuten_books_genre_".$i] != "") {
			$rank_rakuten_books_genre_id[] = $design_json["page_rank_rakuten_books_genre_id_".$i];
		}
	}
	foreach ($rank_rakuten_books_genre_id as $key => $value) {
		$htmlRight .= getPageRankingHTML($user_id,$value,$genre_rakuten_books_json[$value],"",$design_json["page_rank_rakuten_books_genre_type_".($key+1)]);
	}

	//DMMランキングAPI表示
	$rank_dmm_genre_id = [];
	for ($i = 1; $i <= 5; $i++) {
		if ($design_json["page_rank_dmm_genre_".$i] != "") {
			$rank_dmm_genre_id[] = $design_json["page_rank_dmm_genre_id_".$i];
		}
	}
	foreach ($rank_dmm_genre_id as $key => $value) {
		$htmlRight .= getPageRankingHTML($user_id,$value,$genre_dmm_json[$value],"",$design_json["page_rank_dmm_genre_type_".($key+1)]);
	}

	//APEXランキングAPI表示
	$rank_apex_genre_id = [];
	for ($i = 1; $i <= 5; $i++) {
		if ($design_json["page_rank_apex_genre_".$i] != "") {
			$rank_apex_genre_id[] = $design_json["page_rank_apex_genre_id_".$i];
		}
	}
	foreach ($rank_apex_genre_id as $key => $value) {
		$htmlRight .= getPageRankingHTML($user_id,$value,$genre_apex_json[$value],"",$design_json["page_rank_apex_genre_type_".($key+1)]);
	}

	//フッター広告
	$html .= "<br>\n".$tag_contents_footer."\n";

	//ヘッダ部
	$title = $page_title;
	$description = $page_title."。".$site_description;
	$keywords = "";
	getHeaderHTML($title,$description,$keywords);

	//$html = cnvContents($html);
	print $html;

	print "</div>\n";

	//メニュー
	getMenuHTML($user_id);

	//フッター
	getFooterHTML();

	//DB切断
	deconnect_db();

echo <<<EOF
</body>
</html>
EOF;

?>


