<?php
	include("../include/config.php");
	include("../include/getdata.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/session.php");

	initProc();

	if (!is_authenticated("admin")) {
		//loginページへ
		header("Location:${sub_dir}/setting/admin/login/?err=timeout");
	}
	if (!is_admin()) {
		//loginページへ
		header("Location:${sub_dir}/setting/admin/login/?err=timeout");
	}

	$app_id = $_GET["app"];
	if ($app_id == "") {
		$app_id = "admin";
	}
	$page_id = $_GET["page"];
	if ($page_id == "") {
		$page_id = "index";
	}

	switch ($app_id) {
		case "admin":
		case "account":
		case "mail_form":
		case "page_faq":
		case "page_info":
		case "contact":
		case "support":
		case "site":
		case "design":
		case "layout":
		case "page_index":
		case "page_contents":
		case "page_comment":
		case "category":
		case "tag_contents":
		case "tag_menu":
		case "api_user":
		case "api":
		case "api_item":
		case "api_title":
		case "api_body":
		case "api_category":
		case "api_channel":
		case "ranking_item":
		case "ranking_body":
		case "rss":
		case "rss_category":
		case "ng_word":
		case "counter":
		case "request":
		case "random_contents":
		case "page_thumbnail":
		case "distribute":
		case "twitter":
			break;
		default:
			header("Location:${sub_dir}/setting/admin/login/");
	}

	//design.jsonをコピー
	$user_id = "";
	if (is_admin()) {
		$user_id = $_SESSION["admin_id"];
	}
	$site_path = SITE_PATH;
	if (!file_exists($site_path."home/".$user_id."/design.json")) {
		copy($site_path."design_template_admin.json", $site_path."home/".$user_id."/design.json");
	}
	if (!file_exists($site_path."home/".$user_id."/layout.json")) {
		copy($site_path."layout_template_admin.json", $site_path."home/".$user_id."/layout.json");
	}

	$htmlCenter .= getAdminHeaderHtml();
	$htmlLeft .= getAdminMenuHtml();

	$htmlRight .= "<div class='cls_main align-left'>\n";
	$htmlRight .= "<div id='id_div_PageContens' class='cls_div_Page'></div>\n";
	$htmlRight .= "</div>\n";
	$htmlRight .= "<br>";

	if ($app_id == "admin") {
		//zipダウンロード
		downloadSystemZip("orochi_black");

		//zipダウンロード
		$multi = "";
		if (file_exists($site_path."option_multi.json")) {
			downloadSystemZip("orochi_black_multi");
			$multi = " (マルチ)";
		}

		$version = getNewSystemversion("orochi_black");

		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>バージョン情報</h2>";
		$htmlRight .= "現在のバージョンは <b>ver".$ycms_version.$multi."</b> です。<br>";
		$htmlRight .= "最新のバージョンは <b>ver".$version.$multi."</b>  です。<br>";
		if ($ycms_version != $version) {
			$htmlRight .= "<input type='button' id='id_btn_system_update' value='システムを更新する'>";
		}
		$htmlRight .= "</div>";
		$htmlRight .= "<br>";

		$url = str_replace("//sitemap.xml","/sitemap.xml",$site_url."/sitemap.xml");
		$path = realpath($__FILE__);
		$path = str_replace("setting","local",$path);
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>よくあるお問い合わせ</h2>";
		$htmlRight .= "<ul>";
		$htmlRight .= "<li>TOPページが表示できない場合<br>";
		$htmlRight .= "<div style='padding-left:12px'>";
		$htmlRight .= "PHPのバージョンを <b>7.3</b> または <b>7.4</b> に変更してください。<br>";
		$htmlRight .= "レンタルサーバの管理者画面で変更可能ですが、MIXHOST・XSERVERの場合はcPanelで変更可能です。<br>";
		$htmlRight .= "詳細は各レンタルサーバのQ&Aをご確認ください。<br>";
		$htmlRight .= "</div>";
		$htmlRight .= "<br>";

		$htmlRight .= "<li>サイトマップURL<br>";
		$htmlRight .= "<div style='padding-left:12px'>";
		$htmlRight .= "Google Search Consoleなどに登録可能なサイトマップ(xml)のURLです。<br>";
		$htmlRight .= "<a href='".$url."' target='_blank'>".$url."</a><br>";
		$htmlRight .= "</div>";
		$htmlRight .= "<br>";

		$htmlRight .= "<li>cron設定";
		$htmlRight .= "<div style='padding-left:12px'>";
		$htmlRight .= "cronコマンド設定のパスです。<br>";
		$htmlRight .= $path."/cron_rank.php<br>";
		$htmlRight .= $path."/cron_api.php<br>";
		$htmlRight .= "<br>";
		$htmlRight .= "レンタルサーバによってはcronコマンド設定の前に半角スペースを空けて <b>/usr/bin/php</b> の指定が必要な場合があります。<br>";
		$htmlRight .= "詳細は各レンタルサーバのQ&Aをご確認ください。<br>";
		$htmlRight .= "<br>";
		$htmlRight .= "<b>MIXHOST・XSERVER</b><br>/usr/bin/php7.3 ".$path."/cron_rank.php<br>";
		$htmlRight .= "<b>FUTOKA</b><br>/usr/bin/php ".$path."/cron_rank.php<br>";
		$htmlRight .= "</div>";
		$htmlRight .= "</ul>";
		$htmlRight .= "<br>";
	}

	$html_script .= <<<EOF
	function reloadPage() {
		$.get(window.location.href, function(data){
			//console.log(window.location.href);
		});
	}
	setInterval(reloadPage,10*60*1000);
EOF;

	//Viewモデル
	$modelView = new ModelView();

	$modelView->app_id = $app_id;
	$modelView->page_id = $page_id;
	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "管理者";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();
?>
