<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/session.php");
	include("../models/site.php");

	initProc();

	if (!is_authenticated("admin")) {
		//loginページへ
		header("Location:${sub_dir}/setting/admin/login/?err=timeout");
	}
	if (!is_admin()) {
		//loginページへ
		header("Location:${sub_dir}/setting/admin/login/?err=timeout");
	}

	//パラメータ定義
	$params = array(
		'txt_name'=>'名前',
		'txt_mail_address'=>'メールアドレス',
		'txt_service_name'=>'サービス名',
		'txt_content_text'=>'内容',
		'txt_detail_text'=>'本文',
	);
	//ルール定義
	$rules = array(
		'txt_name'=>'required',
		'txt_mail_address'=>'required,email',
		//'txt_service_name'=>'required',
		'txt_content_text'=>'required',
		'txt_detail_text'=>'required',
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	if ($_POST["proc_type"] == "entry") {
		if ($modelView->validateParams()){
			$params = [];
			$params["name"] = $modelView->posts["txt_name"];
			$params["mail_address"] = $modelView->posts["txt_mail_address"];
			$params["service_name"] = $modelView->posts["txt_service_name"];
			$params["content_text"] = crLfHTML($modelView->posts["txt_content_text"]);
			$params["detail_text"] = $modelView->posts["txt_detail_text"];
			$params["api_key"] = $api_key;
			//API認証取得
			$contents = apiAuth("/users/html_contact/",$params);

			print $contents;
			$json = json_decode($contents,true);

			if ($json["error_code"] != "0") {
				$htmlRight .= "<div id='login-contents' class='align-center'>";
				$htmlRight .= "<div class='align-left'>";
				$htmlRight .= "メールアドレスに誤りがあります。";
				$htmlRight .= "</div>";
				$htmlRight .= "</div>";
				//$modelView->error_params = "txt_mail_address";
				//$modelView->error_message = "メールアドレスに誤りがあります。";
			} else {
				$htmlRight .= "<div id='login-contents' class='align-center'>";
				$htmlRight .= "<div class='align-left'>";
				$htmlRight .= "お問い合わせを受け付けしました。";
				$htmlRight .= "</div>";
				$htmlRight .= "</div>";
			}
		}
	}

	$htmlCenter .= getAdminHeaderHtml();
	$htmlLeft .= getAdminMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {

		$htmlRight .= "<div class='cls_main align-left'>\n";

		$htmlRight .= "<h2>連絡フォーム</h2>\n";
		$htmlRight .= "";
		
		$htmlRight .= "<form id='frmEntry' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>名前</div>";
		$htmlRight .= "<div><input type='text' id='txt_name' name='txt_name' size=40></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<input type='hidden' name='txt_service_name' value=''>";
		$htmlRight .= "<div class='cls_section'>内容</div>";
		$htmlRight .= "<div><select id='txt_content_text' name='txt_content_text'>";
		$htmlRight .= "<option value=''>選択してください";
		$htmlRight .= "<option value='お問い合わせ'>お問い合わせ";
		$htmlRight .= "<option value='不具合報告'>不具合報告";
		$htmlRight .= "<option value='要望'>要望";
		$htmlRight .= "<option value='その他'>その他";
		$htmlRight .= "</select></div>";
		$htmlRight .= "<div class='cls_section'>本文</div>";
		$htmlRight .= "<div><textarea rows=10 cols=60 id='txt_detail_text' name='txt_detail_text'></textarea></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='entry'>";
		$htmlRight .= "<br><br>";

		$htmlRight .= "<div><input type='button' id='btn_entry' name='btn_entry' value='連絡する'></div>";
		$htmlRight .= "<br>";
		$htmlRight .= "</form>";

		$htmlRight .= "</div>\n";

		$html_script .= <<<EOF
$(document).on("click", "#btn_entry", function(){
	$("#txt_detail_text").val(escapeHTML($("#txt_detail_text").val()));
	$("#frmEntry").submit();
});
EOF;
	} else {
		$htmlRight .= "<div class='cls_main align-left'>\n";
		$htmlRight .= "<h2>連絡フォーム</h2>\n";
		$htmlRight .= "ありがとうございます。<br>";
		$htmlRight .= "連絡フォームを受け付けました。<br>";
		$htmlRight .= "<br>\n";
		$htmlRight .= "</div>\n";
	}

	//スタイルを設定
	$htmlStyle = "";


	//メタタグ
	$htmlMeta = "";
	if ($tag_meta_google != "") {
		$htmlMeta .= "<meta name=\"google-site-verification\" content=\"".$tag_meta_google."\" />\n";
	}

	$modelView->app_id = "";
	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->htmlStyle = $htmlStyle;
	$modelView->htmlMeta = $htmlMeta;
	$modelView->title = SITE_TITLE." - ".SITE_DESCRIPTION;
	$modelView->description = SITE_DESCRIPTION;
	$modelView->keywords = KEY_WORDS;
	$modelView->printHTML();

	endProc();

?>
