<?php
	if (!file_exists("../../include/config.php")) {
		//config.php初期作成
		createConfig("サーバ","ユーザ","パスワード","データベース名");
	}

	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../../include/modelView.php");
	include("../../include/modelDatabase.php");
	include("../models/session.php");
	//include("../models/page.php");
	include("../models/site.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_host_name'=>'サーバ',
		'txt_user_name'=>'ユーザ',
		'txt_pass_word'=>'パスワード',
		'txt_db_name'=>'データベース名'
	);
	//ルール定義
	$rules = array(
		'txt_host_name'=>'required',
		'txt_user_name'=>'required',
		'txt_pass_word'=>'required',
		'txt_db_name'=>'required'
	);

	//POSTデータ取得
	$posts = postToArray();
	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "login") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$txt_host_name = $modelView->posts["txt_host_name"];
			$txt_user_name = $modelView->posts["txt_user_name"];
			$txt_pass_word = $modelView->posts["txt_pass_word"];
			$txt_db_name = $modelView->posts["txt_db_name"];

			createConfig($txt_host_name,$txt_user_name,$txt_pass_word,$txt_db_name);

			if (check_db($txt_host_name,$txt_user_name,$txt_pass_word,$txt_db_name)) {
				//ログイン画面ページへ
				header("Location:${sub_dir}/setting/admin/login/");
			} else {
				$modelView->error_params = "txt_host_name,txt_user_name,txt_pass_word,txt_db_name";
				$modelView->error_message = "データベースに接続できません。入力内容に誤りがあります。";
			}
		}
	} else {
		$txt_host_name = CONNECT_HOST;
		$txt_user_name = CONNECT_USER;
		$txt_pass_word = CONNECT_PASS;
		$txt_db_name = CONNECT_DB;
	}

	$htmlCenter .= getAdminHeaderHtml();

	$htmlLeft .= "";	//getAdminMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$url = $_SERVER["REQUEST_URI"];
		$hash = parse_url($url);
		parse_str($hash['query'],$query);

		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<td class='align-left'><h2 class='setting'>DB接続設定</h2>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>".$params["txt_host_name"]."</div>";
		$htmlRight .= "<div><input type='text' id='txt_host_name' name='txt_host_name' size=40 value='$txt_host_name'></div>";
		$htmlRight .= "<div class='cls_section'>".$params["txt_user_name"]."</div>";
		$htmlRight .= "<div><input type='text' id='txt_user_name' name='txt_user_name' size=40 value='$txt_user_name'></div>";
		$htmlRight .= "<div class='cls_section'>".$params["txt_pass_word"]."</div>";
		$htmlRight .= "<div><input type='password' id='txt_pass_word' name='txt_pass_word' size=40 value='$txt_pass_word'></div>";
		$htmlRight .= "<div class='cls_section'>".$params["txt_db_name"]."</div>";
		$htmlRight .= "<div><input type='text' id='txt_db_name' name='txt_db_name' size=40 value='$txt_db_name'></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='login'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_login' name='btn_login' value='設定を保存する'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";

		$htmlRight .= $modelView->error_message;

		$html_script .= <<<EOF
$(document).on("click", "#btn_login", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "DB接続設定";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();

//config.php初期作成
function createConfig($host,$user,$pass,$dbname) {
	$text = <<<EOF
<?php
//ユーザ設定
define("CONNECT_HOST","$host");
define("CONNECT_USER","$user");
define("CONNECT_PASS","$pass");
define("CONNECT_DB","$dbname");
?>
EOF;
	file_put_contents("../../include/config.php", $text);
}

// MySQL 接続
function check_db($host,$user,$pass,$dbname) {
	$conn;
	$trycnt = 1;
	for($i=0;$i<10;$i++) {
		$conn = mysqli_connect($host,$user,$pass,$dbname);
		if($conn){
			break;
		} else {
			usleep(1000);
			error_log("mysqli_connect() ${trycnt}回リトライ中\n",3,LOG_PATH . $_SERVER["SCRIPT_NAME"] . "_" . date("YmdHi") . ".log");
		}
		if ($trycnt > 3) {
			error_log("mysqli_connect() ${trycnt}回リトライ後エラー\n",3,LOG_PATH . $_SERVER["SCRIPT_NAME"] . "_" . date("YmdHi") . ".log");
			return(false);
		}
		$trycnt++;
	}
	mysqli_set_charset($conn,"utf8");

	mysqli_close($conn);
	return(true);
}

?>
