<?php
	if (!file_exists("../../include/config.php")) {
		$path = $_SERVER["REQUEST_URI"];
		if (strpos($path,"/setting") !== false) {
			$path = substr($path,0,strpos($path,"/setting"));
		} 
		$path = str_replace("//","/",$path);
		if (substr($path,-1) == "/") {
			$path = substr($path, 0, -1);
		}
		header("Location:${path}/setting/admin/dbconfig/");
	}
//	if (!file_exists("../../design.json")) {
//		copy("../../design_template.json", "../../home/admin/design.json");
//	}

	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/session.php");
	include("../models/site.php");
	include("../models/user.php");

	initProc();

	if (!connect_db()) {
		header("Location:${sub_dir}/setting/admin/dbconfig/");
	}

	//マスターテーブル作成
	createMstTables();
	//トランザクションテーブル作成
	createTrnTables();

	$ModelSite = new ModelSite();
	$keys = array(
		"user_id"=>ADMIN_USER_ID
	);
	$rs = $ModelSite->select($keys);
	$api_key = "";
	while ($item = mysqli_fetch_array($rs)) {
		$api_key = $item["api_key"];
	}
	if ($api_key == "") {
		header("Location:${sub_dir}/setting/admin/sign_up/");
	}

	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'メールアドレス',
		'txt_pass_word'=>'パスワード'
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required',
		'txt_pass_word'=>'required'
	);

	//POSTデータ取得
	$posts = postToArray();
	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	$htmlRight .= "<style>\n";
	$htmlRight .= "#header-contents {background-color:#111;}\n";
	$htmlRight .= "#footer-contents {background-color:#111;}\n";
	$htmlRight .= "</style>\n";

	if ($_POST["proc_type"] == "login") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$params = [];
			$params["mail_address"] = $modelView->posts["txt_mail_address"];
			$params["pass_word"] = $modelView->posts["txt_pass_word"];
			//API認証取得
			$contents = apiAuth("/users/html_login/",$params);
			$json = json_decode($contents,true);

			//管理者ログイン
			if ($json["error_code"] == "0") {
				$user_id = ADMIN_USER_ID;
			}
			//ユーザIDチェック、ログインファイルチェック
			if ($user_id == "" || !loginFileCheck($modelView->posts["txt_mail_address"])) {
				$modelView->error_params = "txt_mail_address,txt_pass_word";
				$modelView->error_message = "メールアドレスまたはパスワードに誤りがあります。";
				$login_fail_count = 0;
			} else {
				//ログイン処理
				loginProc($user_id);
				//管理画面ページへ
				header("Location:${sub_dir}/setting/xpp/admin/");
			}
		}
	}

	$htmlCenter .= getAdminHeaderHtml();

	$htmlLeft .= "";	//getAdminMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$url = $_SERVER["REQUEST_URI"];
		$hash = parse_url($url);
		parse_str($hash['query'],$query);

		if ($query["err"] == "timeout") {
			$modelView->validate_on = true;
			$modelView->error_params = "txt_mail_address,txt_pass_word";
			$modelView->error_message = "一定期間、操作がなかったため、タイムアウトしました。";
		}
		if ($query["proc_type"] == "logout") {
			$modelView->validate_on = true;
			$modelView->error_params = "txt_mail_address,txt_pass_word";
			$modelView->error_message = "ログアウトしました。";
		}

		$htmlRight .= "<div id='login-contents' class='align-center' style='background-color:#fff;margin-top:40px;margin-bottom:0px;padding-bottom:8px;'>";
		if (file_exists(SITE_PATH."images/title_login.jpg")){
			$htmlRight .= "<img src='${sub_dir}/images/title_login.jpg' width=480><br><br>";
		}
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>管理者ログイン</h2>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "<div id='login-contents' class='align-center' style='margin-top:0px;margin-bottom:0px;'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<table cellpadding=3>";
		$htmlRight .= "<tr><th style='padding-right:20px;'><div class='cls_section'>".$params["txt_mail_address"]."</div>";
		$htmlRight .= "<td><div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<tr><th style='padding-right:20px;'><div class='cls_section'>".$params["txt_pass_word"]."</div>";
		$htmlRight .= "<td><div><input type='password' id='txt_pass_word' name='txt_pass_word' size=40></div>";
		$htmlRight .= "</table>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='login'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_login' name='btn_login' value='　ログイン　'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "<div id='login-contents' class='align-center' style='background-color:#fff;margin-top:0px;'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<table cellpadding=3>";
		$htmlRight .= "<tr><td><div class='btn-normal'><i class='fas fa-chevron-circle-right' style='color:#fff;'></i> <a href='${sub_dir}/setting/admin/password_reset/'>パスワード再発行</a></div><td>パスワードを忘れた方はこちら";
		$htmlRight .= "<tr><td><div class='btn-normal'><i class='fas fa-chevron-circle-right' style='color:#fff;'></i> <a href='${sub_dir}/setting/admin/password_update/'>パスワード変更</a></div><td>パスワードの変更はこちら";
		$htmlRight .= "<tr><td><div class='btn-normal'><i class='fas fa-chevron-circle-right' style='color:#fff;'></i> <a href='${sub_dir}/setting/admin/mail_update/'>メールアドレス変更</a></div><td>メールアドレスの変更はこちら";
		$htmlRight .= "</table>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= $modelView->error_message;

		$html_script .= <<<EOF
$(document).on("click", "#btn_login", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "ログイン";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();
?>
