<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/session.php");
	include("../models/site.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'新メールアドレス',
		'txt_mail_address_old'=>'現在のメールアドレス',
		'txt_pass_word'=>'パスワード'
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required',
		'txt_mail_address_old'=>'required',
		'txt_pass_word'=>'required'
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	$login_key = $_GET["sid"];

	if ($_POST["proc_type"] == "reset") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$mail_address = $modelView->posts["txt_mail_address"];
			$mail_address_old = $modelView->posts["txt_mail_address_old"];
			$pass_word = $modelView->posts["txt_pass_word"];
			$login_key = $_POST["sid"];

			if (loginFileCheck($mail_address_old)) {
				$params = [];
				$params["mail_address"] = $mail_address;
				$params["mail_address_old"] = $mail_address_old;
				$params["pass_word"] = $pass_word;
				//API認証取得
				$contents = apiAuth("/users/html_mail_update/",$params);
				$json = json_decode($contents,true);

				if ($json["error_code"] == "0") {
					$htmlRight .= "<div id='login-contents'>";
					$htmlRight .= "<div>メールアドレスの更新が完了しました。</div>";
					$htmlRight .= "<br>";
					$htmlRight .= "<div><a href='${sub_dir}/setting/admin/login/'>ログイン画面へ</a><div>";
					$htmlRight .= "</div>";
					//ログインファイルクリア
					loginFileClear($modelView->posts["txt_mail_address"]);
				} else {
					$modelView->error_params = "txt_mail_address,txt_mail_address_old,txt_pass_word";
					$modelView->error_message = "現在のメールアドレスまたはパスワードに誤りがあります。";
					$modelView->error_message .= "<br>".$json["error_message"];
				} 
			} else {
				$modelView->error_params = "txt_mail_address,txt_mail_address_old,txt_pass_word";
				$modelView->error_message = "現在のメールアドレスまたはパスワードに誤りがあります。";
				$modelView->error_message .= "<br>".$json["error_message"];
			} 
		}
	}

	$htmlCenter .= getAdminHeaderHtml();

	$htmlLeft .= "";	//getAdminMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<div class='cls_header'>新しいメールアドレスを設定してください</div>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>現在のメールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address_old' name='txt_mail_address_old' size=40></div>";
		$htmlRight .= "<div class='cls_section'>現在のパスワード</div>";
		$htmlRight .= "<div><input type='text' id='txt_pass_word' name='txt_pass_word' size=40></div>";
		$htmlRight .= "<div class='cls_section'>新しいメールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='reset'>";
		$htmlRight .= "<input type='hidden' id='sid' name='sid' value='$login_key'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_reset' name='btn_reset' value='登録する'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "<div>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";

		$html_script .= <<<EOF
$(document).on("click", "#btn_reset", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "メールアドレス更新";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();
?>
