<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/session.php");
	include("../models/site.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'メールアドレス'
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required,email'
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "reset") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$params = [];
			$params["mail_address"] = $modelView->posts["txt_mail_address"];
			//API認証取得
			$contents = apiAuth("/users/html_password_reset/",$params);
			$json = json_decode($contents,true);

			if ($json["error_code"] == "0") {
				$htmlRight .= "<div id='login-contents' class='align-center'>";
				$htmlRight .= "<b>パスワードの再発行が完了しました。</b><br>";
				$htmlRight .= "<br>";
				$htmlRight .= "入力されたメールアドレス宛に、新しいパスワードを送信しました。<br>";
				$htmlRight .= "※メールが来ない場合は、迷惑メールボックスに振り分けられていないか確認してください。<br>";
				$htmlRight .= "<br>";
				$htmlRight .= "<div><a href='${sub_dir}/setting/admin/login/'>ログイン画面へ</a><div>";
				$htmlRight .= "</div>";
			} else {
				$modelView->error_params = "txt_mail_address";
				$modelView->error_message = "メールアドレスに誤りがあります。(".$json["error_code"].")";
			} 
		}
	}

	$htmlCenter .= getAdminHeaderHtml();

	$htmlLeft .= "";	//getAdminMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>パスワード再発行</h2>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='reset'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_login' name='btn_login' value='送信'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";

		$html_script .= <<<EOF
$(document).on("click", "#btn_login", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "パスワードリセット";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();
?>
