<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/session.php");
	include("../models/site.php");
	include("../models/user.php");

	initProc();

	if (!connect_db()) {
		header("Location:${sub_dir}/setting/admin/dbconfig/");
	}
	if (!file_exists("../../design.json")) {
		copy("../../design_template.json", "../../design.json");
	}

	//マスターテーブル作成
	createMstTables();
	//トランザクションテーブル作成
	createTrnTables();

	$ModelSite = new ModelSite();
	$keys = array(
		"user_id"=>ADMIN_USER_ID
	);
	$rs = $ModelSite->select($keys);
	$api_key = "";
	while ($item = mysqli_fetch_array($rs)) {
		$api_key = $item["api_key"];
	}
	if ($api_key != "") {
		header("Location:${sub_dir}/setting/admin/login/");
	}
	
	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'メールアドレス',
		'txt_pass_word'=>'パスワード',
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required,email',
		'txt_pass_word'=>'required,alphanumeric'
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "entry") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$params = [];
			$params["mail_address"] = $modelView->posts["txt_mail_address"];
			$params["pass_word"] = $modelView->posts["txt_pass_word"];
			//API認証取得
			$contents = apiAuth("/users/html_sign_up/",$params);
			$json = json_decode($contents,true);

			$api_key = $json["api_key"];

			//APIキー更新
			$ModelSite = new ModelSite();
			$data = array(
				"api_key"=>$api_key
			);
			$keys = array(
				"user_id"=>ADMIN_USER_ID
			);
			$ModelSite->update($data,$keys);

			if ($json["error_code"] == 0 && $api_key != "") {
				$htmlRight .= "<div id='login-contents' class='align-center'>";
				$htmlRight .= "<b>本登録が完了しました。</b><br>";
				$htmlRight .= "<br>";
				$htmlRight .= "入力されたメールアドレス宛に、案内を送信しました。<br>";
				$htmlRight .= "※メールが来ない場合は、迷惑メールボックスに振り分けられていないか確認してください。<br>";
				$htmlRight .= "<br>";
				$htmlRight .= "<div><a href='${sub_dir}/setting/admin/login/'>こちらからログインを行ってください</a></div>";
				$htmlRight .= "</div>";
			} else {
				if ($api_key == "") {
					$json["error_message"] = "認証サイトへのアクセスに失敗しました。<br><br>";
					if (!ini_get("allow_url_fopen")) {
						$$json["error_message"] .= "php.iniの設定が「allow_url_fopen=off」になっています。<br>";
						$version = phpversion();
						if (strpos($version,"5.") !== false) {
							$$json["error_message"] .= "phpのバージョンを7.0に変更してください。<br><br>";
						} else {
							$$json["error_message"] .= "phpのバージョンを5.6に変更してください。<br><br>";
						}
						$$json["error_message"] .= "事象が変わらない場合は、<br>php.iniの設定を「allow_url_fopen=on」に変更してください。<br>";
						$$json["error_message"] .= "php.iniの変更については、各レンタルサーバのヘルプをご参考ください。<br>";
					}
				}
				$htmlRight .= "<div id='login-contents' class='align-center'>";
				$htmlRight .= "<b>新規登録に失敗しました。</b><br>";
				$htmlRight .= "<br>";
				$htmlRight .= "<div class='align-left'>".$json["error_message"]."</div>";
				$htmlRight .= "<br>";
				$htmlRight .= "<div><a href='${sub_dir}/setting/admin/login/'>ログイン画面</a></div>";
				$htmlRight .= "</div>";
			}
		}
	}

	$htmlCenter .= getAdminHeaderHtml();

	$htmlLeft .= "";	//getHomeMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>新規登録</h2>";
		$htmlRight .= "<form id='frmEntry' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<div class='cls_section'>パスワード</div>";
		$htmlRight .= "<div><input type='password' id='txt_pass_word' name='txt_pass_word' size=40></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='entry'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_entry' name='btn_entry' class='large-button' value='アカウントを作成する'></div>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><a href='${sub_dir}/setting/admin/login/'>既にアカウントをお持ちの方はこちら</a></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>\n";

		$html_script .= <<<EOF
$(document).on("click", "#btn_entry", function(){
	$("#frmEntry").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "ユーザ登録";
	$modelView->description = "";
	$modelView->keywords = "";
	$modelView->printHTML();

	endProc();
?>
