var params = {};
//ルール定義
var rules = {};

var _version = "";
var _option = "";

var _api_service = {
	"rakuten_market":"楽天市場",
	"rakuten_books":"楽天ブックス",
	"rakuten_travel":"楽天トラベル",
	"rakuten_kobo":"楽天Kobo",
	"dmm_general":"DMM一般",
	"dmm_adult":"DMMアダルト",
	"amazon":"Amazon",
	"youtube":"Youtube",
/*	"apex_general":"APEX(DUGA)一般",*/
	"apex_adult":"APEX(DUGA)アダルト",
};

var _sort_name = [];
_sort_name["rakuten_market"] = {
	"standard":"人気",
	"-updateTimestamp":"新着",
	"+reviewAverage":"評価",
}
_sort_name["rakuten_books"] = {
	"sales":"人気",
	"-releaseDate":"新着",
	"reviewAverage":"評価",
}
_sort_name["rakuten_travel"] = {
	"standard":"人気",
	"+roomCharge":"料金(安い順)",
	"-roomCharge":"料金(高い順)",
}
_sort_name["rakuten_kobo"] = {
	"standard":"人気",
	"-releaseDate":"新着",
	"reviewAverage":"評価",
}
_sort_name["dmm_general"] = {
	"rank":"人気",
	"date":"新着",
	"review":"評価",
};
_sort_name["dmm_adult"] = {
	"rank":"人気",
	"date":"新着",
	"review":"評価",
};
_sort_name["amazon"] = {
	"relevancerank":"新着",
	"salesrank":"人気",
	"rating":"評価",
	"+price":"料金(安い順)",
	"-price":"料金(高い順)",
};
_sort_name["youtube"] = {
	"viewCount":"人気",
	"date":"新着",
	"rating":"評価",
};
_sort_name["apex_general"] = {
	"favorite":"人気",
	"delease":"発売日順",
	"new":"新着順",
	"price":"価格順",
	"rating":"評価順",
};
_sort_name["apex_adult"] = {
	"favorite":"人気",
	"delease":"発売日順",
	"new":"新着順",
	"price":"価格順",
	"rating":"評価順",
};

//ジャンルJSON取得
var _genre_list = [];
var keys = Object.keys(_api_service);
$.ajaxSetup({async: false});
for (var i in keys){
	$.getJSON("./" + keys[i] + ".json", function(objJSON){
		_genre_list[keys[i]] = objJSON;
	});
}

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>API登録</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";
	strHTML += "<div id='id_dialog2' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML);

	createHTML_List();
	createHTML_templateDialog();
	createHTML_supportDialog();
	createHTML_imageDialog();

	//ダイアログ
	$('#id_dialog').dialog({
		title: "API編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"登録": function(){
				//パラメータ定義
			 	params = {
					"id_inp_keyword":"キーワード"
				};
				//ルール定義
				rules = {
					"id_inp_keyword":"required"
				};

				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	$('#id_dialog2').dialog({
		title: "API編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"設定": function(){
				var pid = $("#id_inp_pid").val();
				$("#" + pid).val(CKEDITOR.instances['id_inp_page_body'].getData());
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//APIサービス選択
	$(document).on("click", "input.btn-api-service", function() {
		$("#id_inp_api_service").val($(this).val());
		$("#id_inp_sort").children().remove();
		$("#api_service").html(_api_service[$(this).val()]);
		var keys = Object.keys(_sort_name[$(this).val()]);
		for (var key in keys) {
			$("#id_inp_sort").append("<option value='" + keys[key] + "'>" + _sort_name[$(this).val()][keys[key]] + "</option>");
		}
		$("#id_inp_genre_id").children().remove();
		$("#id_inp_genre_id").append("<option value=' '>指定なし</option>");
		for (var i = 0; i < _genre_list[$(this).val()].genre.length; i++){
			$("#id_inp_genre_id").append("<option value='" + _genre_list[$(this).val()].genre[i].genreId + "'>" + _genre_list[$(this).val()].genre[i].genreName + "</option>");
		}
		if ($(this).val() == "rakuten_market") {
			$(".cls_tbl_input").find("tr[col=title_min_price]").show();
			$(".cls_tbl_input").find("tr[col=title_max_price]").show();
		} else {
			$(".cls_tbl_input").find("tr[col=title_min_price]").hide();
			$(".cls_tbl_input").find("tr[col=title_max_price]").hide();
		}
		if ($(this).val() == "youtube") {
			$(".cls_tbl_input").find("tr[col=genre_id]").hide();
		} else {
			$(".cls_tbl_input").find("tr[col=genre_id]").show();
		}
	});

	//ビジュアルエディタ
	$(document).on("click", "button.cls_btn_dialog", function() {
		createHTML_dialog2();

		var objTr = $(this).closest("tr");
		setInputFromList2(objTr);
		$("#id_dialog2").dialog("open");
	});

	//画像挿入ボタン
	$(document).on("click", "#id_inp_btn_image", function () {
		$("#id_image_dialog").attr("editor", "id_inp_page_body");
		$("#id_image_dialog").dialog("open");
	});
	//入力補助挿入ボタン
	$(document).on("click", "#id_inp_btn_support", function () {
		$("#id_support_dialog").attr("editor", "id_inp_page_body");
		$("#id_support_dialog").dialog("open");
	});
	//テンプレート挿入ボタン
	$(document).on("click", "#id_inp_btn_template", function () {
		$("#id_template_dialog").attr("editor", "id_inp_page_body");
		$("#id_template_dialog").dialog("open");
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>APIサービス";
	strHTML += "<th>カテゴリ";
	strHTML += "<th>キーワード";
	//strHTML += "<th>除外キーワード";
	strHTML += "<th>ソート";
	strHTML += "<th>ジャンル";
	strHTML += "<th class='cls_none'>最低価格";
	strHTML += "<th class='cls_none'>最高価格";
	strHTML += "<th>取得件数(日)";
	strHTML += "<th class='cls_none'>ページヘッダー";
	strHTML += "<th class='cls_none'>ページフッター";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/api/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			var genre_name = "";
			for (var j = 0; j < _genre_list[objJSON.data[i].api_service].genre.length; j++){
				if (_genre_list[objJSON.data[i].api_service].genre[j].genreId == objJSON.data[i].genre_id) {
					genre_name = _genre_list[objJSON.data[i].api_service].genre[j].genreName;
					break;
				}
			}

			strHTML += "<tr key='"+ objJSON.data[i].api_id + "'>";
			strHTML += "<td dtype='' col='api_id'>" + (i+1);
			strHTML += "<td dtype='' col='api_service' class='cls_none'>" + objJSON.data[i].api_service;
			strHTML += "<td dtype='' col='api_service_name'>" + _api_service[objJSON.data[i].api_service];
			strHTML += "<td dtype='' col='category_id' class='cls_none'>" + objJSON.data[i].category_id;
			strHTML += "<td dtype='' col='category_name'>" + objJSON.data[i].category_name;
			strHTML += "<td dtype='' col='keyword'>" + objJSON.data[i].keyword;
			//strHTML += "<td dtype='' col='exclude_keyword'>" + objJSON.data[i].exclude_keyword;
			strHTML += "<td dtype='' col='sort' class='cls_none'>" + objJSON.data[i].sort;
			strHTML += "<td>" + _sort_name[objJSON.data[i].api_service][objJSON.data[i].sort];
			strHTML += "<td dtype='' col='genre_id' class='cls_none'>" + objJSON.data[i].genre_id;
			strHTML += "<td>" + genre_name;
			strHTML += "<td dtype='' col='min_price' class='cls_none'>" + objJSON.data[i].min_price;
			strHTML += "<td dtype='' col='max_price' class='cls_none'>" + objJSON.data[i].max_price;
			strHTML += "<td dtype='' col='add_count'>" + objJSON.data[i].add_count;
			strHTML += "<td dtype='' col='api_contents_header' class='cls_none'>" + objJSON.data[i].api_contents_header;
			strHTML += "<td dtype='' col='api_contents_footer' class='cls_none'>" + objJSON.data[i].api_contents_footer;
			strHTML += "<td dtype='' col='overlay_tag' class='cls_none'>" + objJSON.data[i].overlay_tag;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	var setData =  {
		api_id: $("#id_inp_api_id").val(),
		api_service: $("#id_inp_api_service").val(),
		keyword: $("#id_inp_keyword").val(),
		exclude_keyword: $("#id_inp_exclude_keyword").val(),
		sort: $("#id_inp_sort").val(),
		genre_id: $("#id_inp_genre_id").val(),
		min_price: $("#id_inp_min_price").val(),
		max_price: $("#id_inp_max_price").val(),
		add_count: $("#id_inp_add_count").val(),
		api_contents_header: escapeHTML($("#id_inp_api_contents_header").val()),
		api_contents_footer: escapeHTML($("#id_inp_api_contents_footer").val()),
		overlay_tag: escapeHTML($("#id_inp_overlay_tag").val()),
		category_id: $("#id_inp_category_id").val(),
	};
	if (setData["min_price"] == "") {
		setData["min_price"] = "0";
	}
	if (setData["max_price"] == "") {
		setData["max_price"] = "0";
	}
	if (setData["add_count"] == "") {
		setData["add_count"] = "0";
	}
	if (setData["overlay_tag"] == "") {
		setData["overlay_tag"] = " ";
	}
	if ($("#id_inp_api_id").val() == "-1") {
		$.post("./insert/api/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["api_id"] = $("#id_inp_api_id").val();
		$.post("./update/api/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
	return true;
}

function deleteCategory(objTr) {
	var setData =  {
		api_id: $(objTr).attr("key")
	};

	$.post("./delete/api/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			//alert("削除が完了しました。");
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_api_service").val($(obj).find("td[col=api_service]").html());
	$("#id_inp_keyword").val($(obj).find("td[col=keyword]").html());
	$("#id_inp_exclude_keyword").val($(obj).find("td[col=exclude_keyword]").html());
	$("#id_inp_sort").val($(obj).find("td[col=sort]").html());
	$("#id_inp_genre_id").val($(obj).find("td[col=genre_id]").html());
	$("#id_inp_min_price").val($(obj).find("td[col=min_price]").html());
	$("#id_inp_max_price").val($(obj).find("td[col=max_price]").html());
	$("#id_inp_add_count").val($(obj).find("td[col=add_count]").html());
	$("#id_inp_api_contents_header").val(unEscapeHTML($(obj).find("td[col=api_contents_header]").text()));
	$("#id_inp_api_contents_footer").val(unEscapeHTML($(obj).find("td[col=api_contents_footer]").text()));
	$("#id_inp_overlay_tag").val(unEscapeHTML($(obj).find("td[col=overlay_tag]").html()));
	$("#id_inp_api_id").val($(obj).attr("key"));
	$("#id_inp_category_id").val($(obj).find("td[col=category_id]").html());

	$("input.btn-api-service").each(function() {
		if ($(this).val() == $(obj).find("td[col=api_service]").html()) {
			$(this).trigger("click");
		}
	});
	$("#id_inp_sort").find("option[value='" + $(obj).find("td[col=sort]").html() + "']").prop("selected",true);
	$("#id_inp_genre_id").find("option[value=" + $(obj).find("td[col=genre_id]").html() + "]").prop("selected",true);
	$("#api_service").show();
	$(".btn-api-service").hide();
}

function setInputFromList2(obj) {
	var pid = $(obj).find("button.cls_btn_dialog").attr("col");
	$("#id_inp_page_body").val((($("#" + pid).val())));
	$("#id_inp_pid").val(pid);
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>APIサービス：";
	strHTML += "<td><div id='api_service'></div>";
	strHTML += "<div class='btn-api-service'>";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='rakuten_market' checked> 楽天市場 　";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='rakuten_books'> 楽天ブックス　";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='rakuten_travel'> 楽天トラベル　";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='rakuten_kobo'> 楽天KOBO　";
	strHTML += "<br>";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='amazon'> Amazon　";
	strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='youtube'> Youtube　";
	if (_option != "noadult") {
		strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='dmm_general'> DMM一般　";
		strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='dmm_adult'> DMMアダルト　";
		strHTML += "<br>";
//		strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='apex_general'> APEX(DUGA)一般　";
		strHTML += "<input type='radio' name='chk_api_service' class='btn-api-service' value='apex_adult'> APEX(DUGA)アダルト　";
	}
	strHTML += "</div>";
	strHTML += "<tr>";
	strHTML += "<th>キーワード：";
	strHTML += "<td><input type='text' id='id_inp_keyword' dtype='' col='keyword' size=30>";
	strHTML += "<tr>";
//	strHTML += "<th>除外キーワード：";
//	strHTML += "<td><input type='text' id='id_inp_exclude_keyword' dtype='' col='exclude_keyword' size=30>";
	strHTML += "<tr>";
	strHTML += "<th>ソート：";
	strHTML += "<td><select id='id_inp_sort'></select>";
	strHTML += "<tr col='genre_id'>";
	strHTML += "<th>ジャンル：";
	strHTML += "<td><select id='id_inp_genre_id'></select>";
	strHTML += "<tr col='title_min_price'>";
	strHTML += "<th>最低価格：";
	strHTML += "<td><input type='text' id='id_inp_min_price' dtype='' col='min_price' size=30>";
	strHTML += "<tr col='title_max_price'>";
	strHTML += "<th>最高価格：";
	strHTML += "<td><input type='text' id='id_inp_max_price' dtype='' col='max_price' size=30>";
	strHTML += "<tr>";
	strHTML += "<th>取得件数(1日)：";
	strHTML += "<td><input type='text' id='id_inp_add_count' dtype='' col='add_count' size=30 value='1'>";
	strHTML += " ※1日の取得件数は最大10件です。";
	strHTML += "<tr>";
	strHTML += "<th>ページヘッダー：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_api_contents_header'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_api_contents_header' dtype='' col='api_contents_header' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>ページフッター：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_api_contents_footer'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_api_contents_footer' dtype='' col='api_contents_footer' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>コンテンツ<br>オーバーキャッシュ<br>(オーバレイ広告)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_overlay_tag'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_overlay_tag' dtype='' col='overlay_tag' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>カテゴリ：";
	strHTML += "<td><select id='id_inp_category_id'>";
	$.ajaxSetup({async: false});
	$.getJSON("./select/api_category/", function(objJSON){
		strHTML += "<option value=''>未設定";
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<option value='" + objJSON.data[i].category_id + "'>" + objJSON.data[i].category_name;
		}
	});
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_api_id' value='-1'>";
	strHTML += "<input type='hidden' id='id_inp_api_service' value=''>";
	
	$("#id_dialog").html(strHTML);

	$("#id_inp_category_id").find("option").eq(1).attr("selected",true)
	$("#api_service").hide();
	$("input.btn-api-service").eq(0).trigger("click");
}

function createHTML_dialog2() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<td><textarea id='id_inp_page_body' class='ckeditor' dtype='' col='page_body'></textarea>";
	strHTML += "</table>";
	strHTML += "<br>";
	
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_image'><i class='fas fa-image'></i> 画像挿入</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_support'><i class='fas fa-pencil-alt'></i> 入力補助</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_template'><i class='fas fa-list'></i> テンプレート挿入</button>　";
	strHTML += "<input type='hidden' id='id_inp_pid' value='-1'>";
	
	$("#id_dialog2").html(strHTML);
	
	CKEDITOR.replace("id_inp_page_body", {
		height: 300,
		toolbar: [
			["Bold", "Italic", "Underline", "Strike", "TextColor", "BGColor"],
			["JustifyLeft", "JustifyCenter", "JustifyRight"],
			["Link", "Image", "Table", "HorizontalRule"],
			["Styles", "Format", "FontSize"],
			["Maximize"],
			["Source"],
			["code"],
			["Recommend"],
		],
		uiColor: '#EEEEEE',
		enterMode: 2,
		shiftEnterMode: 2,
		allowedContent: true,
		fillEmptyBlocks: false,
		contentsCss: [_sub_dir + '/css/style.css', 'https://use.fontawesome.com/releases/v5.7.2/css/all.css'],
		tabSpaces: 0
	});
}
