//パラメータ定義
var params = {
};
//ルール定義
var rules = {
};

var _api_service = {
	"rakuten_market":"楽天市場",
	"rakuten_books":"楽天ブックス",
	"rakuten_travel":"楽天トラベル",
	"rakuten_kobo":"楽天Kobo",
	"dmm_general":"DMM一般",
	"dmm_adult":"DMMアダルト",
	"amazon":"Amazon",
	"youtube": "Youtube",
/*	"apex_general":"APEX(DUGA)一般",*/
	"apex_adult": "APEX(DUGA)アダルト",
};

var _sort_name = {
	"standard": "人気",
	"-updateTimestamp": "新着",
	"+reviewAverage": "評価",
	"rank": "人気",
	"date": "新着",
	"review": "評価",
	"sales": "人気",
	"standard": "人気",
	"+roomCharge": "料金(安い順)",
	"-roomCharge": "料金(高い順)",
	"viewCount": "人気",
	"favorite": "人気",
	"delease": "発売日",
	"new": "新着",
	"price": "価格",
	"rating": "評価",
	"relevancerank":"新着",
	"salesrank":"人気",
	"rating":"評価",
	"+price":"価格(安い順)",
	"-price":"価格(高い順)",
};

var _body_type = {
	"header":"ヘッダ(1)",
	"header2":"ヘッダ(2)",
	"footer":"フッタ(1)",
	"footer2":"フッタ(2)",
};

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>APIページ(ページのランダム編集)</h2>";
	strHTML += "APIで取得したページ内容の前後にランダムでコンテンツを追加します。<br>";
	strHTML += "ヘッダ(1)、ヘッダ(2)、ページ内容、フッタ(1)、フッタ(2)の順で追加します。<br>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();
	createHTML_templateDialog();
	createHTML_supportDialog();
	createHTML_imageDialog();
	
	//ダイアログ
	$('#id_dialog').dialog({
		title: "APIページ編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();
		if ($("#id_inp_api_id").children().size() == 0) {
			alert("「API登録」でキーワードを設定してください。")
			return;
		}

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//画像挿入ボタン
	$(document).on("click", "#id_inp_btn_image", function () {
		$("#id_image_dialog").attr("editor", "id_inp_body_text");
		$("#id_image_dialog").dialog("open");
	});
	//入力補助挿入ボタン
	$(document).on("click", "#id_inp_btn_support", function () {
		$("#id_support_dialog").attr("editor", "id_inp_body_text");
		$("#id_support_dialog").dialog("open");
	});
	//テンプレート挿入ボタン
	$(document).on("click", "#id_inp_btn_template", function () {
		$("#id_template_dialog").attr("editor", "id_inp_body_text");
		$("#id_template_dialog").dialog("open");
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th nowrap>APIサービス";
	strHTML += "<th nowrap>キーワード";
	strHTML += "<th nowrap>ソート";
	strHTML += "<th nowrap>挿入位置";
	strHTML += "<th>挿入内容";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/api_body/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<tr key='"+ objJSON.data[i].body_id + "'>";
			strHTML += "<td dtype='' col='body_id'>" + (i+1);
			strHTML += "<td dtype='' col='api_id' class='cls_none'>" + objJSON.data[i].api_id;
			strHTML += "<td dtype='' nowrap>" + _api_service[objJSON.data[i].api_service];
			strHTML += "<td dtype=''>" + objJSON.data[i].keyword;
			strHTML += "<td dtype=''>" + _sort_name[objJSON.data[i].sort];
			strHTML += "<td dtype='' nowrap>" + _body_type[objJSON.data[i].body_type];
			strHTML += "<td dtype=''>" + objJSON.data[i].body_text;
			strHTML += "<td class='cls_none' col='body_type'>" + objJSON.data[i].body_type;
			strHTML += "<td class='cls_none' col='body_text'>" + escapeHTML(unEscapeHTML(objJSON.data[i].body_text,'"'));
			strHTML += "<td class='cls_right' nowrap><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";

	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	var setData =  {
		body_id: $("#id_inp_body_id").val(),
		api_id: $("#id_inp_api_id").val(),
		body_type: $("#id_inp_body_type").val(),
		body_text: escapeHTML(CKEDITOR.instances['id_inp_body_text'].getData()),
	};
	if ($("#id_inp_body_id").val() == "-1") {
		$.post("./insert/api_body/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["body_id"] = $("#id_inp_body_id").val();
		$.post("./update/api_body/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
	return true;
}

function deleteCategory(objTr) {
	var setData =  {
		body_id: $(objTr).attr("key")
	};

	$.post("./delete/api_body/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			//alert("削除が完了しました。");
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_api_id").val($(obj).find("td[col=api_id]").html());
	$("#id_inp_body_type").val($(obj).find("td[col=body_type]").html());
	$("#id_inp_body_text").val(unEscapeHTML($(obj).find("td[col=body_text]").html()));
	$("#id_inp_body_id").val($(obj).attr("key"));
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>API：";
	strHTML += "<td><select id='id_inp_api_id'>";
	$.ajaxSetup({async: false});
	$.getJSON("./select/api/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<option value='" + objJSON.data[i].api_id + "'>" + _api_service[objJSON.data[i].api_service] + "(" + objJSON.data[i].keyword + "、" + _sort_name[objJSON.data[i].sort] + ")";
		}
	});
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>挿入位置：";
	strHTML += "<td><select id='id_inp_body_type'>";
	for (var key in _body_type) {
		strHTML += "<option value='" + key + "'>" + _body_type[key] + "</option>";
	}
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>挿入内容：";
	strHTML += "<td><textarea id='id_inp_body_text' name='id_inp_body_text' class='ckeditor' dtype='' col='body_text'></textarea>";
	strHTML += "</table>";
	
	strHTML += "<br>";

	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_image'><i class='fas fa-image'></i> 画像挿入</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_support'><i class='fas fa-pencil-alt'></i> 入力補助</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_template'><i class='fas fa-list'></i> テンプレート挿入</button>　";

	strHTML += "<input type='hidden' id='id_inp_body_id' value='-1'>";
	strHTML += "<input type='hidden' id='id_inp_api_id' value=''>";
	
	$("#id_dialog").html(strHTML);

	$("#api_id").hide();
	$("input.btn-api-service").eq(0).trigger("click");

	CKEDITOR.replace("id_inp_body_text", {
		height: 300,
		toolbar: [
			["Bold", "Italic", "Underline", "Strike", "TextColor", "BGColor"],
			["JustifyLeft", "JustifyCenter", "JustifyRight"],
			["Link", "Image", "Table", "HorizontalRule"],
			["Styles", "Format", "FontSize"],
			["Maximize"],
			["Source"],
			["code"],
			["Recommend"],
		],
		uiColor: '#EEEEEE',
		enterMode: 2,
		shiftEnterMode: 2,
		allowedContent: true,
		fillEmptyBlocks: false,
		tabSpaces: 0
	});
}

