//パラメータ定義
var params = {
};
//ルール定義
var rules = {
};

var _api_service = {
	"rakuten_market":"楽天市場",
	"rakuten_books":"楽天ブックス",
	"rakuten_travel":"楽天トラベル",
	"rakuten_kobo":"楽天Kobo",
	"dmm_general":"DMM一般",
	"dmm_adult":"DMMアダルト",
	"amazon":"Amazon",
	"youtube":"Youtube",
/*	"apex_general":"APEX(DUGA)一般",*/
	"apex_adult":"APEX(DUGA)アダルト",
};

var _sort_name = {
	"standard":"人気",
	"-updateTimestamp":"新着",
	"+reviewAverage":"評価",
	"rank":"人気",
	"date":"新着",
	"review":"評価",
	"sales":"人気",
	"standard":"人気",
	"+roomCharge":"料金(安い順)",
	"-roomCharge":"料金(高い順)",
	"viewCount":"人気",
	"favorite":"人気",
	"delease":"発売日",
	"new":"新着",
	"price":"価格",
	"rating":"評価",
	"relevancerank":"新着",
	"salesrank":"人気",
	"rating":"評価",
	"+price":"価格(安い順)",
	"-price":"価格(高い順)",
};

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>APIページ(タイトルのランダム編集)</h2>";
	strHTML += "APIで取得したページタイトルの前後にランダム文字を追加します。<br>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();
	
	//ダイアログ
	$('#id_dialog').dialog({
		title: "APIタイトル編集",
		modal: true,
		height: 'auto',
		width: 600,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();
		if ($("#id_inp_api_id").children().size() == 0) {
			alert("「API登録」でキーワードを設定してください。")
			return;
		}

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>APIサービス";
	strHTML += "<th>キーワード";
	strHTML += "<th>ソート";
	strHTML += "<th>タイトル前に追加";
	strHTML += "<th>タイトル後に追加";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/api_title/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<tr key='"+ objJSON.data[i].title_id + "'>";
			strHTML += "<td dtype='' col='title_id'>" + (i+1);
			strHTML += "<td dtype='' col='api_id' class='cls_none'>" + objJSON.data[i].api_id;
			strHTML += "<td dtype=''>" + _api_service[objJSON.data[i].api_service];
			strHTML += "<td dtype=''>" + objJSON.data[i].keyword;
			strHTML += "<td dtype=''>" + _sort_name[objJSON.data[i].sort];
			strHTML += "<td dtype='' col='title_header'>" + objJSON.data[i].title_header;
			strHTML += "<td dtype='' col='title_footer'>" + objJSON.data[i].title_footer;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	var setData =  {
		title_id: $("#id_inp_title_id").val(),
		api_id: $("#id_inp_api_id").val(),
		title_header: $("#id_inp_title_header").val(),
		title_footer: $("#id_inp_title_footer").val(),
	};
	if ($("#id_inp_title_id").val() == "-1") {
		$.post("./insert/api_title/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["title_id"] = $("#id_inp_title_id").val();
		$.post("./update/api_title/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
	return true;
}

function deleteCategory(objTr) {
	var setData =  {
		title_id: $(objTr).attr("key")
	};

	$.post("./delete/api_title/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			//alert("削除が完了しました。");
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_api_id").val($(obj).find("td[col=api_id]").html());
	$("#id_inp_title_header").val($(obj).find("td[col=title_header]").html());
	$("#id_inp_title_footer").val($(obj).find("td[col=title_footer]").html());
	$("#id_inp_title_id").val($(obj).attr("key"));
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>API：";
	strHTML += "<td><select id='id_inp_api_id'>";
	$.ajaxSetup({async: false});
	$.getJSON("./select/api/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<option value='" + objJSON.data[i].api_id + "'>" + _api_service[objJSON.data[i].api_service] + "(" + objJSON.data[i].keyword + "、" + _sort_name[objJSON.data[i].sort] + ")";
		}
	});
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>タイトル前に追加：";
	strHTML += "<td><input type='text' id='id_inp_title_header' dtype='' col='title_header' size=40>";
	strHTML += "<tr>";
	strHTML += "<th>タイトル後に追加：";
	strHTML += "<td><input type='text' id='id_inp_title_footer' dtype='' col='title_footer' size=40>";
	strHTML += "<tr>";
	strHTML += "<th>";
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_title_id' value='-1'>";
	strHTML += "<input type='hidden' id='id_inp_api_id' value=''>";
	
	$("#id_dialog").html(strHTML);

	$("#api_id").hide();
	$("input.btn-api-service").eq(0).trigger("click");
}

