//パラメータ定義
var params = {
	"id_inp_distribute_title":"配信タイトル",
	"id_inp_distribute_contents":"配信内容"
};
//ルール定義
var rules = {
	"id_inp_distribute_title":"required",
	"id_inp_distribute_contents":"required"
};

var _max_cnt = 50;

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2  class='setting'>Twitter配信ページ登録</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_pager'></div>";
	strHTML += "<input type='hidden' id='id_search_page' value=1>";
	strHTML += "<input type='hidden' id='id_search_maxpage' value=1>";
	strHTML += "<br>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<br>";
	strHTML += "<h2 class='setting'>使用方法</h2>";
	strHTML += "<div class='cls_block'>";
	strHTML += "<a href='https://developer.twitter.com/en/apps/' target='_blank'>Twitter Developer</a> サイトで「Consumer Keys」→「API Key and Secret 」より <b>APIキーとシークレットキー</b> を発行し、「サイト設定」→「デザイン設定」で登録ください。<br><br>"
	strHTML += "<h2 class='setting'>Twitter Developer設定</h2>";
	strHTML += "<a href='https://developer.twitter.com/en/apps/' target='_blank'>Twitter Developer</a> サイトの「User authentication settings」で以下を設定ください。<br>";
	strHTML += "<table>";
	strHTML += "<tr><td><b>App permissions</b>:<td>Read and write";
	strHTML += "<tr><td><b>Callback URI</b>:<td>" + $("#footer-contents").find("a").attr("href") + "twitter/twitter_callback/";
	strHTML += "</table>";
	strHTML += "</div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";
	strHTML += "<div id='id_dialog2' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();	
	createHTML_imageDialog();
	createHTML_templateDialog();
	createHTML_supportDialog();

	//ダイアログ
	$('#id_dialog').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 960,
		autoOpen: false,
		buttons: {
			"登録": function(){
				//if (!validateParams()) {
				//	return(false);
				//}
				if (updatePage()) {
					$("div.cls_div_option").hide();
					$(this).dialog('close');
					createHTML_List();
				}
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	$('#id_dialog2').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"設定": function(){
				var pid = $("#id_inp_pid").val();
				$("#" + pid).val(CKEDITOR.instances['id_inp_distribute_body2'].getData());
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deletePage(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//ページャボタン
	$(document).on("click", "div.cls_distribute_box", function() {
		$("#id_search_page").val($(this).attr("page"));
		createHTML_List();
	});

	//ビジュアルエディタ
	$(document).on("click", "button.cls_btn_dialog", function() {
		createHTML_dialog2();

		var objTr = $(this).closest("tr");
		setInputFromList2(objTr);
		$("#id_dialog2").dialog("open");
	});

	//画像挿入ボタン
	$(document).on("click", "#id_inp_btn_image", function() {
		$("#id_image_dialog").attr("editor","id_inp_distribute_body2");
		$("#id_image_dialog").dialog("open");
	});
	//入力補助挿入ボタン
	$(document).on("click", "#id_inp_btn_support", function () {
		$("#id_support_dialog").attr("editor", "id_inp_page_body");
		$("#id_support_dialog").dialog("open");
	});
	//テンプレート挿入ボタン
	$(document).on("click", "#id_inp_btn_template", function () {
		$("#id_template_dialog").attr("editor", "id_inp_page_body");
		$("#id_template_dialog").dialog("open");
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50px>No";
	strHTML += "<th>配信タイトル";
	strHTML += "<th>管理者テスト用";
	strHTML += "<th width=200px>有効期限";
	strHTML += "<th width=80px>ツイート";
//	strHTML += "<th width=80px>アクセス数";
	strHTML += "<th width=200px>更新日時";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/distribute/", function(objJSON){
		var start_row = (parseInt($("#id_search_page").val())-1) * _max_cnt;
		var end_row = start_row + _max_cnt;
		if  (end_row > objJSON.data.length) {
			end_row = objJSON.data.length;
		}
		var cnt = start_row + 1;
		if (objJSON.data != "") {
			var url = $("#left-contents").find("a").eq(0).attr("href");
			for (var i = start_row; i < end_row; i++){
				strHTML += "<tr key='"+ objJSON.data[i].distribute_id + "'>";
				strHTML += "<td>" + cnt;
				strHTML += "<td col='distribute_title'><a href='../../../distribute/" + objJSON.data[i].distribute_id + "/' target='_blank'>" + objJSON.data[i].distribute_title + "</a>";
				strHTML += "<td><a href='../../../distribute/" + objJSON.data[i].distribute_id + "/?mode=test' target='_blank'>[管理者テスト用]</a>";
				strHTML += "<td col='distribute_header' class='cls_none'>" + objJSON.data[i].distribute_header;
				strHTML += "<td col='distribute_contents' class='cls_none'>" + objJSON.data[i].distribute_contents;
				strHTML += "<td col='distribute_footer' class='cls_none'>" + objJSON.data[i].distribute_footer;
				strHTML += "<td col='distribute_downroad' class='cls_none'>" + objJSON.data[i].distribute_downroad;
				strHTML += "<td col='expired_date'>" + objJSON.data[i].expired_date;
				strHTML += "<td col='tweet_account' class='cls_none'><a href='https://twitter.com/" + objJSON.data[i].tweet_account + "' target='_blank'>" + objJSON.data[i].tweet_account + "</a>";
				strHTML += "<td col='tweet_id'><a href='https://twitter.com/intent/retweet?tweet_id=" + objJSON.data[i].tweet_id + "' target='_blank'>" + objJSON.data[i].tweet_id + "</a>";
				strHTML += "<td col='distribute_access_cnt' class='cls_none'>" + objJSON.data[i].distribute_access_cnt;
				strHTML += "<td col='time_stamp'>" + objJSON.data[i].time_stamp;
				strHTML += "<td col='retweet_flag' class='cls_none'>" + objJSON.data[i].retweet_flag;
				strHTML += "<td col='like_flag' class='cls_none'>" + objJSON.data[i].like_flag;
				strHTML += "<td col='follow_flag' class='cls_none'>" + objJSON.data[i].follow_flag;
				strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
				strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
				cnt++;
			}
		}
		var maxpage = Math.ceil(objJSON.data.length / _max_cnt);
		$("#id_search_maxpage").val(maxpage);
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	create_PagerHtml();

	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updatePage() {
	var setData =  {
		distribute_id: $("#id_inp_distribute_id").val(),
		distribute_title: $("#id_inp_distribute_title").val(),
		distribute_header: $("#id_inp_distribute_header").val(),
		distribute_contents: $("#id_inp_distribute_contents").val(),
		distribute_footer: $("#id_inp_distribute_footer").val(),
		distribute_downroad: $("#id_inp_distribute_downroad").val(),
		expired_date: $("#id_inp_expired_date").val(),
		tweet_account: $("#id_inp_tweet_account").val(),
		tweet_id: $("#id_inp_tweet_id").val(),
		retweet_flag: "N",
		like_flag: "N",
		follow_flag: "N",
	};
	if (setData["distribute_header"] == "") {
		setData["distribute_header"] = " ";
	}
	if (setData["distribute_contents"] == "") {
		setData["distribute_contents"] = " ";
	}
	if (setData["distribute_footer"] == "") {
		setData["distribute_footer"] = " ";
	}
	if (setData["distribute_downroad"] == "") {
		setData["distribute_downroad"] = " ";
	}
	if ($("#id_inp_retweet_flag").prop("checked")) {
		setData["retweet_flag"] = "Y";
	}
	if ($("#id_inp_like_flag").prop("checked")) {
		setData["like_flag"] = "Y";
	}
	if ($("#id_inp_follow_flag").prop("checked")) {
		setData["follow_flag"] = "Y";
	}
	if ($("#id_inp_distribute_id").val() == "-1") {
		setData["distribute_access_cnt"] = "0";
	}

	if (setData["distribute_title"] == "") {
		alert("配信タイトルを入力してください。");
		return(false);
	}
	if (setData["distribute_header"] == "") {
		alert("配信内容(ヘッダ)を入力してください。");
		return(false);
	}
	if (setData["distribute_contents"] == "") {
		alert("配信内容(コンテンツ)を入力してください。");
		return(false);
	}
	if (setData["expired_date"] == "") {
		alert("有効期限を入力してください。");
		return(false);
	}
//	if (setData["tweet_account"] == "") {
//		alert("twitterアカウントを入力してください。");
//		return(false);
//	}
	if (setData["tweet_id"] == "") {
		alert("ツイートIDを入力してください。");
		return(false);
	}
	if ($("#id_inp_distribute_id").val() == "-1") {
		$.post("./insert/distribute/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
			}
		);
		//distribute_idを取得
		$.getJSON("./select/distribute/", function(objJSON){
			var cnt = 1;
			$("#id_inp_distribute_id").val(objJSON.data[0].distribute_id);
		});
	} else {
		setData["distribute_id"] = $("#id_inp_distribute_id").val();
		$.post("./update/distribute/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
			}
		);
	}

	return(true);
}

function deletePage(objTr) {
	var setData =  {
		distribute_id: $(objTr).attr("key")
	};

	$.post("./delete/distribute/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_distribute_title").val($(obj).find("td[col=distribute_title]").text());
	$("#id_inp_distribute_header").val($(obj).find("td[col=distribute_header]").html());
	$("#id_inp_distribute_contents").val($(obj).find("td[col=distribute_contents]").html());
	$("#id_inp_distribute_footer").val($(obj).find("td[col=distribute_footer]").html());
	$("#id_inp_distribute_downroad").val($(obj).find("td[col=distribute_downroad]").html());
	$("#id_inp_distribute_access_cnt").val($(obj).find("td[col=distribute_access_cnt]").html());
	$("#id_inp_expired_date").val($(obj).find("td[col=expired_date]").html());
	$("#id_inp_tweet_account").val($(obj).find("td[col=tweet_account]").text());
	$("#id_inp_tweet_id").val($(obj).find("td[col=tweet_id]").text());
	if ($(obj).find("td[col=retweet_flag]").html() == "N") {
		$("#id_inp_retweet_flag").prop("checked",false);
	}
	if ($(obj).find("td[col=like_flag]").html() == "N") {
		$("#id_inp_like_flag").prop("checked",false);
	}
	if ($(obj).find("td[col=follow_flag]").html() == "N") {
		$("#id_inp_follow_flag").prop("checked",false);
	}
	$("#id_inp_distribute_id").val($(obj).attr("key"));
}

function setInputFromList2(obj) {
	var pid = $(obj).find("button.cls_btn_dialog").attr("col");
	$("#id_inp_distribute_body2").val((($("#" + pid).val())));
	$("#id_inp_pid").val(pid);
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>配信タイトル：";
	strHTML += "<td><input type='text' id='id_inp_distribute_title' col='distribute_title' size=80>";
	strHTML += "<tr>";
	strHTML += "<th>配信内容<br>(ヘッダー)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_distribute_header'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_distribute_header' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>配信内容<br>(コンテンツ)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_distribute_contents'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_distribute_contents' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>配信内容<br>(フッター)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_distribute_footer'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_distribute_footer' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>配信内容<br>(配布コンテンツ)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_distribute_downroad'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_distribute_downroad' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>有効期限：";
	strHTML += "<td>";
	strHTML += "<input type='text' id='id_inp_expired_date' col='expired_date' size=10>";
	strHTML += "<tr class='cls_none'>";
	strHTML += "<th>twitterアカウント：";
	strHTML += "<td>";
	strHTML += "<input type='text' id='id_inp_tweet_account' col='tweet_account' size=24>";
	strHTML += "<tr>";
	strHTML += "<th>ツイートID：";
	strHTML += "<td>";
	strHTML += "<input type='text' id='id_inp_tweet_id' col='tweet_id' size=24>";
	strHTML += "<tr class='cls_none'>";
	strHTML += "<th>アクセス数：";
	strHTML += "<td><input type='text' id='id_inp_distribute_access_cnt' col='distribute_access_cnt' size=10 value=1>";
	strHTML += "<tr>";
	strHTML += "<th>配布条件：";
	strHTML += "<td>";
	strHTML += "<input type='checkbox' id='id_inp_retweet_flag' value='Y' checked> リツイート ";
	strHTML += "<input type='checkbox' id='id_inp_like_flag' value='Y' checked> いいね ";
	strHTML += "<input type='checkbox' id='id_inp_follow_flag' value='Y' checked> フォロー ";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<input type='hidden' id='id_inp_distribute_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);

	$("#id_inp_expired_date").val(moment().add(2,"M").endOf('month').format('YYYY-MM-DD'));

	//入力補助挿入ボタン
	$(document).on("click", "#id_inp_btn_support", function () {
		$("#id_support_dialog").attr("editor", "id_inp_page_body");
		$("#id_support_dialog").dialog("open");
	});
	//テンプレート挿入ボタン
	$(document).on("click", "#id_inp_btn_template", function () {
		$("#id_template_dialog").attr("editor", "id_inp_page_body");
		$("#id_template_dialog").dialog("open");
	});
}

function createHTML_dialog2() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<td><textarea id='id_inp_distribute_body2' class='ckeditor' col='distribute_body2'></textarea>";
	strHTML += "</table>";
	strHTML += "<br>";
	
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_image'><i class='fas fa-image'></i> 画像挿入</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_support'><i class='fas fa-pencil-alt'></i> 入力補助</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_template'><i class='fas fa-list'></i> テンプレート挿入</button>　";
	strHTML += "<input type='hidden' id='id_inp_pid' value='-1'>";
	
	$("#id_dialog2").html(strHTML);

	CKEDITOR.replace("id_inp_distribute_body2", {
		height: 300,
		toolbar: [
			["Bold", "Italic", "Underline", "Strike", "TextColor", "BGColor"],
			["JustifyLeft", "JustifyCenter", "JustifyRight"],
			["Link", "Image", "Table", "HorizontalRule"],
			["Styles", "Format", "FontSize"],
			["Maximize"],
			["Source"],
			["code"],
			["Recommend"],
		],
		uiColor: '#EEEEEE',
		enterMode: 2,
		shiftEnterMode: 2,
		allowedContent: true,
		fillEmptyBlocks: false,
		contentsCss: [_sub_dir + '/css/style.css', 'https://use.fontawesome.com/releases/v5.7.2/css/all.css'],
		tabSpaces: 0
	});
}
