//パラメータ定義
var params = {
	"id_inp_question_text":"質問",
	"id_inp_answer_text":"回答"
};
//ルール定義
var rules = {
	"id_inp_question_text":"required",
	"id_inp_answer_text":"required"
};

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2  class='setting'>よくある質問登録</h2>";
	strHTML += "ここで設定した内容は、" + "<a href='/" + $("#site_url").attr("user_name") + "/faq/' target='_blank'>よくある質問</a> に追加されます。";
	
	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();
	
	//ダイアログ
	$('#id_dialog').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 480,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updatePage();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deletePage(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>質問";
	strHTML += "<th>回答";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/faq/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<tr key='"+ objJSON.data[i].faq_id + "'>";
			strHTML += "<td dtype='' col='faq_id'>" + (i+1);
			strHTML += "<td dtype='' col='question_text'>" + objJSON.data[i].question_text;
			strHTML += "<td dtype='' col='answer_text'>" + objJSON.data[i].answer_text;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updatePage() {
	var setData =  {
		faq_id: $("#id_inp_faq_id").val(),
		question_text: escapeHTML($("#id_inp_question_text").val()),
		answer_text: escapeHTML($("#id_inp_answer_text").val())
	};

	if ($("#id_inp_faq_id").val() == "-1") {
		$.post("./insert/faq/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["faq_id"] = $("#id_inp_faq_id").val();
		$.post("./update/faq/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
}

function deletePage(objTr) {
	var setData =  {
		faq_id: $(objTr).attr("key")
	};

	$.post("./delete/faq/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_question_text").val(unEscapeHTML($(obj).find("td[col=question_text]").html()));
	$("#id_inp_answer_text").val(unEscapeHTML($(obj).find("td[col=answer_text]").html()));
	$("#id_inp_faq_id").val($(obj).attr("key"));
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>質問";
	strHTML += "<tr>";
	strHTML += "<td><textarea id='id_inp_question_text' dtype='' col='question_text'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>回答";
	strHTML += "<tr>";
	strHTML += "<td><textarea id='id_inp_answer_text' dtype='' col='answer_text'></textarea>";
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_faq_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);
}

