//パラメータ定義
var params = {
	"id_inp_ng_word":"NGワード"
};
//ルール定義
var rules = {
	"id_inp_ng_word":"required"
};

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>NGワード登録</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();
	
	//ダイアログ
	$('#id_dialog').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 400,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>NGワード";
	strHTML += "<th>置換ワード";
	strHTML += "<th>更新日時";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/ng_word/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<tr key='"+ objJSON.data[i].word_id + "'>";
			strHTML += "<td dtype='' col='word_id'>" + (i+1);
			strHTML += "<td dtype='' col='ng_word'>" + objJSON.data[i].ng_word;
			strHTML += "<td dtype='' col='replace_word'>" + objJSON.data[i].replace_word;
			strHTML += "<td dtype='' col=' time_stamp'>" + objJSON.data[i].time_stamp;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});
	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	if ($("#id_inp_replace_word").val().trim() == "") {
		$("#id_inp_replace_word").val(" ");
	}
	var setData =  {
		word_id: $("#id_inp_word_id").val(),
		ng_word: $("#id_inp_ng_word").val(),
		replace_word: $("#id_inp_replace_word").val()
	};

	if ($("#id_inp_word_id").val() == "-1") {
		$.post("./insert/ng_word/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["word_id"] = $("#id_inp_word_id").val();
		$.post("./update/ng_word/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
}

function deleteCategory(objTr) {
	var setData =  {
		word_id: $(objTr).attr("key")
	};

	$.post("./delete/ng_word/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_ng_word").val($(obj).find("td[col=ng_word]").html().trim());
	$("#id_inp_replace_word").val($(obj).find("td[col=replace_word]").html().trim());
	$("#id_inp_word_id").val($(obj).attr("key"));
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>NGワード：";
	strHTML += "<td><input type='text' id='id_inp_ng_word' dtype='' col='ng_word' size=30>";
	strHTML += "<tr>";
	strHTML += "<th>置換ワード：";
	strHTML += "<td><input type='text' id='id_inp_replace_word' dtype='' col='replace_word' size=30>";
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_word_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);
}

