//パラメータ定義
var params = {
	"id_inp_thumbnail_title":"記事カテゴリリンクタイトル"
};
//ルール定義
var rules = {
	"id_inp_thumbnail_title":"required"
};

var def_thumbnail_sort_type = {};
def_thumbnail_sort_type["update"] = "更新日";
def_thumbnail_sort_type["create"] = "作成日";

var def_thumbnail_position = {};
def_thumbnail_position["contents_top"] = "コンテンツ";
def_thumbnail_position["menu_top"] = "サイドバー";

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>記事リンク登録</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();
	
	//ダイアログ
	$('#id_dialog').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 560,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//ファイル選択ボタン
	$(document).on("change", "#id_inp_thumbnail_default_image_file", function() {
		var file = $(this)[0].files[0];

		// 画像以外は処理を停止
		if (! file.type.match("image.*")) {
			// クリア
			$(this).val("");
			return;
		}
		$(this).attr("filename",getHash(12) + file.name.substr(file.name.lastIndexOf(".")));
		$("#id_inp_" + $(this).attr("col") + "_del").show();

		var imgObj = $("#id_img_" + $(this).attr("col"));

		// 画像表示
		var reader = new FileReader();
		reader.onload = function() {
			$(imgObj).attr("src",reader.result);
			//alert("height="+$(imgObj).height());
			//alert("width="+$(imgObj).width());
			//alert("src="+$(imgObj).attr("src"));
		};
		reader.readAsDataURL(file);
	});

	//画像削除ボタン
	$(document).on("click", "#id_inp_thumbnail_default_image_file_del", function() {
		var imgObj = $("#id_img_" + $(this).attr("col"));
		$(imgObj).attr("src","./../../../images/noimage.png");

		var inpObj = $("#id_inp_" + $(this).attr("col"));
		$(inpObj).val("");
		$(inpObj).attr("filename"," ");
		$(inpObj).replaceWith($(inpObj).clone());
		
		$(this).hide();
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>タイトル";
	strHTML += "<th width=150px>表示位置";
	strHTML += "<th>記事カテゴリ";
	strHTML += "<th width=120px>記事カテゴリ順";
	strHTML += "<th width=120px>記事表示順";
	strHTML += "<th width=60px>記事数";
	strHTML += "<th width=60px>画像";
	strHTML += "<th width=300px>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/page_thumbnail/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<tr key='"+ objJSON.data[i].thumbnail_id + "'>";
			strHTML += "<td dtype=''>" + (i+1);
			strHTML += "<td dtype='' col='thumbnail_title'>" + objJSON.data[i].thumbnail_title;
			strHTML += "<td dtype=''>" + def_thumbnail_position[objJSON.data[i].thumbnail_position];
			strHTML += "<td dtype=''>" + objJSON.data[i].category_name;
			strHTML += "<td dtype='' col='sort_no'>" + objJSON.data[i].sort_no;
			strHTML += "<td dtype=''>" + def_thumbnail_sort_type[objJSON.data[i].thumbnail_sort_type];
			strHTML += "<td dtype='' col='page_cnt'>" + objJSON.data[i].page_cnt;
			strHTML += "<td dtype='' col='thumbnail_image_flag'>" + objJSON.data[i].thumbnail_image_flag;
			strHTML += "<td dtype='' class='cls_none' col='thumbnail_contents_flag'>" + objJSON.data[i].thumbnail_contents_flag;
			strHTML += "<td dtype='' class='cls_none' col='thumbnail_sort_type'>" + objJSON.data[i].thumbnail_sort_type;
			strHTML += "<td dtype='' class='cls_none' col='thumbnail_position'>" + objJSON.data[i].thumbnail_position;
			strHTML += "<td dtype='' class='cls_none' col='category_id'>" + objJSON.data[i].category_id;
			strHTML += "<td dtype='' class='cls_none' col='thumbnail_default_image_file'>" + objJSON.data[i].thumbnail_default_image_file
			strHTML += "<td dtype='' class='cls_none' col='user_id'>" + objJSON.data[i].user_id
			strHTML += "<td class='' class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	var setData =  {
		thumbnail_id: $("#id_inp_thumbnail_id").val(),
		thumbnail_title: $("#id_inp_thumbnail_title").val(),
		thumbnail_sort_type: $("#id_chk_thumbnail_sort_type:checked").val(),
		thumbnail_position: $("#id_chk_thumbnail_position:checked").val(),
		thumbnail_image_flag: $("#id_chk_thumbnail_image_flag:checked").val(),
		thumbnail_contents_flag: $("#id_chk_thumbnail_contents_flag:checked").val(),
		thumbnail_default_image_file: $("#id_inp_thumbnail_default_image_file").attr("filename"),
		category_id: $("#id_inp_category_id").val(),
		page_cnt: $("#id_inp_page_cnt").find("option:selected").val(),
		sort_no: $("#id_inp_sort_no").find("option:selected").val(),
	};

	if ($("#id_inp_thumbnail_id").val() == "-1") {
		$.post("./insert/page_thumbnail/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["thumbnail_id"] = $("#id_inp_thumbnail_id").val();
		$.post("./update/page_thumbnail/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}

	if ($("#id_inp_thumbnail_default_image_file")[0].files[0] != undefined) {
		$("#id_inp_thumbnail_default_image_file").upload("./upload/page_thumbnail/?max_height=400&max_width=1080&file_name=" + $("#id_inp_thumbnail_default_image_file").attr("filename"),
			function (data) {
				//alert("id_inp_title_image_file:" + data);
			},
			"text"
		);
	}

	return true;
}

function deleteCategory(objTr) {
	var setData =  {
		thumbnail_id: $(objTr).attr("key"),
	};

	$.post("./delete/page_thumbnail/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			//alert("削除が完了しました。");
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_thumbnail_id").val($(obj).attr("key"));
	$("#id_inp_thumbnail_title").val($(obj).find("td[col=thumbnail_title]").html());
	$("#id_inp_category_id").find("option[value='" + $(obj).find("td[col=category_id]").html() +"']").prop("selected",true);
	$("#id_inp_page_cnt").find("option[value='" + $(obj).find("td[col=page_cnt]").html() +"']").prop("selected",true);
	$("#id_inp_sort_no").find("option[value='" + $(obj).find("td[col=sort_no]").html() +"']").prop("selected",true);
	$("#id_chk_thumbnail_sort_type[value='" + $(obj).find("td[col=thumbnail_sort_type]").html() +"']").prop("checked",true);
	$("#id_chk_thumbnail_position[value='" + $(obj).find("td[col=thumbnail_position]").html() +"']").prop("checked",true);
	$("#id_chk_thumbnail_image_flag[value='" + $(obj).find("td[col=thumbnail_image_flag]").html() +"']").prop("checked",true);
	$("#id_chk_thumbnail_contents_flag[value='" + $(obj).find("td[col=thumbnail_contents_flag]").html() +"']").prop("checked",true);
	if ($(obj).find("td[col=thumbnail_default_image_file]").html().trim() != "") {
		$("#id_img_thumbnail_default_image_file").attr("src","./../../../home/" + $(obj).find("td[col=user_id]").html() + "/" + $(obj).find("td[col=thumbnail_default_image_file]").html());
		$("#id_inp_thumbnail_default_image_file").attr("filename",$(obj).find("td[col=thumbnail_default_image_file]").html());
	} else {
		$("#id_img_thumbnail_default_image_file").attr("src","./../../../images/noimage.png");
		$("#id_inp_thumbnail_default_image_file_del").hide();
	}
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>タイトル：";
	strHTML += "<td><input type='text' id='id_inp_thumbnail_title' dtype='' col='thumbnail_title' size=30>";
	strHTML += "<tr>";
	strHTML += "<th>表示位置：";
	strHTML += "<td>";
	strHTML += "<input type='radio' id='id_chk_thumbnail_position' name='id_chk_thumbnail_position' value='contents_top' checked> コンテンツ　";
	strHTML += "<input type='radio' id='id_chk_thumbnail_position' name='id_chk_thumbnail_position' value='menu_top'> サイドバー　";
	strHTML += "<tr>";
	strHTML += "<th>カテゴリ：";
	strHTML += "<td>";
	strHTML += "<select id='id_inp_category_id'>";
	$.ajaxSetup({async: false});
	$.getJSON("./select/category/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<option value='" + objJSON.data[i].category_id + "'>" + objJSON.data[i].category_name;
		}
	});
	strHTML += "<option value=' '>指定なし";
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>表示順：";
	strHTML += "<td>";
	strHTML += "<select id='id_inp_sort_no'>";
	for (var i = 0; i < 50; i++){
		strHTML += "<option value='" + i + "'>" + i;
	}
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>記事表示順：";
	strHTML += "<td>";
	strHTML += "<input type='radio' id='id_chk_thumbnail_sort_type' name='id_chk_thumbnail_sort_type' value='update' checked> 更新日　";
	strHTML += "<input type='radio' id='id_chk_thumbnail_sort_type' name='id_chk_thumbnail_sort_type' value='create'> 投稿日　";
	strHTML += "<tr>";
	strHTML += "<th>記事数：";
	strHTML += "<td>";
	strHTML += "<select id='id_inp_page_cnt'>";
	strHTML += "<option value='4'>4";
	strHTML += "<option value='6'>6";
	strHTML += "<option value='8'>8";
	strHTML += "<option value='8'>10";
	strHTML += "</select>";
	strHTML += "<tr>";
	strHTML += "<th>画像：";
	strHTML += "<td>";
	strHTML += "<input type='radio' id='id_chk_thumbnail_image_flag' name='id_chk_thumbnail_image_flag' value='Y' checked> 表示する　";
	strHTML += "<input type='radio' id='id_chk_thumbnail_image_flag' name='id_chk_thumbnail_image_flag' value='N'> 表示しない　";
	strHTML += "<tr>";
	strHTML += "<th>コンテンツ：";
	strHTML += "<td>";
	strHTML += "<input type='radio' id='id_chk_thumbnail_contents_flag' name='id_chk_thumbnail_contents_flag' value='Y' checked> 表示する　";
	strHTML += "<input type='radio' id='id_chk_thumbnail_contents_flag' name='id_chk_thumbnail_contents_flag' value='N'> 表示しない　";
	strHTML += "<tr>";
	strHTML += "<th rowspan=2>アイキャッチ<br>画像";
	strHTML += "<td><img src='' id='id_img_thumbnail_default_image_file' col='thumbnail_default_image_file' style='max-width:300px;max-height:100px;'>";
	strHTML += "<tr>";
	strHTML += "<td><label class='button small-button'>画像を選択<input type='file' id='id_inp_thumbnail_default_image_file' name='id_inp_thumbnail_default_image_file' class='cls_none' col='thumbnail_default_image_file' filename='' enctype='multipart/form-data'></label>";
	strHTML += "<input type='button' id='id_inp_thumbnail_default_image_file_del' class='red-button small-button' col='thumbnail_default_image_file' value='画像を削除'><br><br>";
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_thumbnail_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);
}

