//パラメータ定義
var params = {
	"id_inp_site_url":"サイトURL",
	"id_inp_site_title":"サイト名",
	"id_inp_rss_url":"RSSのURL"
};
//ルール定義
var rules = {
	"id_inp_site_url":"required",
	"id_inp_site_title":"required",
	"id_inp_rss_url":"required"
};

var objCategoryJSON;

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();

	//カテゴリ取得
	$.ajaxSetup({async: false});
	$.getJSON("./select/rss_category/", function(objJSON){
		objCategoryJSON = objJSON;
	});

});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {
	var strHTML = "";

	strHTML += "<h2 class='setting'>RSS登録</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML)

	createHTML_List();

	//ダイアログ
	$('#id_dialog').dialog({
		title: "編集",
		modal: true,
		height: 'auto',
		width: 680,
		autoOpen: false,
		buttons: {
			"登録": function(){
				if (!validateParams()) {
					return(false);
				}
				updateRss();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteRss(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//サイト取得ボタン
	$(document).on("click", "#id_btn_rss", function() {
		$("#id_inp_site_title").val("");
		$("#id_inp_rss_url").val("");
		
		var setData =  {
			 site_url: $("#id_inp_site_url").val()
		};
		
		$.post("../../../url/",
			setData,
			function(data){
				$("#id_inp_site_title").val(data.site_title);
				$("#id_inp_rss_url").val(data.rss_url);
			},"json"
		).fail(function(data) {
				alert("サイト名、RSSが取得できませんでした。それぞれを手入力してください。");
			}
		);
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";
	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
	strHTML += "<th>サイト名";
	strHTML += "<th class='cls_none'>サイトURL";
	strHTML += "<th class='cls_none'>RSSのURL";
	strHTML += "<th>カテゴリ";
	strHTML += "<th>更新日時";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/rss/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			var url = "../../../" + $("#session_user_name").val() + "/rss/" + objJSON.data[i].rss_id + "/";
			if ($("#session_user_name").val() == "admin") {
				url = "../../../rss/" + objJSON.data[i].rss_id + "/";
			}
			strHTML += "<tr key='" + objJSON.data[i].rss_id + "'>";
			strHTML += "<td dtype='' col='rss_id'>" + (i+1);
			strHTML += "<td dtype='' col='site_title'><div>" + objJSON.data[i].site_title + "</div>";
			strHTML += "<a href='" + url + "' target='_blank'>記事一覧</a>";
			strHTML += "<td dtype='' col='site_url' class='cls_none'>" + objJSON.data[i].site_url;
			strHTML += "<td dtype='' col='rss_url' class='cls_none'>" + objJSON.data[i].rss_url;
			strHTML += "<td dtype='' col='category_id' class='cls_none'>" + objJSON.data[i].category_id;
			strHTML += "<td dtype='' col='category_name'>" + objJSON.data[i].category_name;
			strHTML += "<td dtype='' col='time_stamp'>" + objJSON.data[i].time_stamp;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button> ";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateRss() {
	var rtn = true;
	var setData =  {
		rss_url: $("#id_inp_rss_url").val()
	}
	$.getJSON("./select/rss/", setData, function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			if (objJSON.data[i].rss_id != $("#id_inp_rss_id").val()) {
				alert("このRSSのURLは既に登録されています。");
				rtn = false;
				break;
			}
		}
	});
	if (!rtn) {
		return;
	}

	var setData =  {
		site_url: $("#id_inp_site_url").val()
	}
	$.getJSON("./select/rss/", setData, function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			if (objJSON.data[i].rss_id != $("#id_inp_rss_id").val()) {
				alert("このサイトのURLは既に登録されています。");
				rtn = false;
				break;
			}
		}
	});
	if (!rtn) {
		return;
	}

	var setData =  {
		rss_id: $("#id_inp_rss_id").val(),
		rss_url: $("#id_inp_rss_url").val(),
		site_url: $("#id_inp_site_url").val(),
		site_title: $("#id_inp_site_title").val(),
		category_id: $("#id_sel_category_id").val(),
		sort_no:"0"
	};
	if ($("#id_inp_rss_id").val() == "-1") {
		$.post("./insert/rss/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["rss_id"] = $("#id_inp_rss_id").val();
		$.post("./update/rss/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
}

function deleteRss(objTr) {
	var setData =  {
		rss_id: $(objTr).attr("key")
	};

	$.post("./delete/rss/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			createHTML_List();
		}
	);
	
	$.post("./delete/rss_article/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
		}
	);

	$.post("./delete/rss_counter/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_rss_id").val($(obj).attr("key"));
	$("#id_inp_rss_url").val($(obj).find("td[col=rss_url]").html());
	$("#id_inp_site_url").val($(obj).find("td[col=site_url]").html());
	$("#id_inp_site_title").val($(obj).find("td[col=site_title]").find("div").html());
	
	$("#id_sel_category_id").val($(obj).find("td[col=category_id]").html());
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>サイトURL：";
	strHTML += "<td><input type='text' id='id_inp_site_url' dtype='' col='site_url' size=70>";
	strHTML += "<div style='margin-top:8px;'><input type='button' id='id_btn_rss' class='small-button' value='サイト名・RSSを取得'></div>";
	strHTML += "<tr>";
	strHTML += "<th>サイト名：";
	strHTML += "<td><input type='text' id='id_inp_site_title' dtype='' col='site_title' size=70>";
	strHTML += "<tr>";
	strHTML += "<th>RSSのURL：";
	strHTML += "<td><input type='text' id='id_inp_rss_url' dtype='' col='rss_url' size=70>";
	strHTML += "<tr>";
	strHTML += "<th>カテゴリ：";
	strHTML += "<td><select id='id_sel_category_id' dtype='' col='category_id'>";
	for (var i = 0; i < objCategoryJSON.data.length; i++){
		strHTML += "<option value='" + objCategoryJSON.data[i].category_id + "'>" + objCategoryJSON.data[i].category_name;
	}
	strHTML += "</select>";
	strHTML += "</table>";
	
	strHTML += "<input type='hidden' id='id_inp_rss_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);
}

