var _sub_dir = window.location.pathname;
_sub_dir = _sub_dir.substring(0,_sub_dir.indexOf("/setting"));

var _spectrum = {
	allowEmpty: true,
	showInput: true,
	containerClassName: "full-_spectrum",
	showInitial: true,
	showPalette: true,
	showSelectionPalette: true,
	showAlpha: true,
	maxPaletteSize: 10,
	preferredFormat: "hex",
	localStorageKey: "_spectrum.color",
	palette: [
		["rgb(0, 0, 0)", "rgb(67, 67, 67)", "rgb(102, 102, 102)",
			"rgb(204, 204, 204)", "rgb(217, 217, 217)", "rgb(255, 255, 255)"],
		["rgb(152, 0, 0)", "rgb(255, 0, 0)", "rgb(255, 153, 0)", "rgb(255, 255, 0)", "rgb(0, 255, 0)",
			"rgb(0, 255, 255)", "rgb(74, 134, 232)", "rgb(0, 0, 255)", "rgb(153, 0, 255)", "rgb(255, 0, 255)"],
		["rgb(230, 184, 175)", "rgb(244, 204, 204)", "rgb(252, 229, 205)", "rgb(255, 242, 204)", "rgb(217, 234, 211)",
			"rgb(208, 224, 227)", "rgb(201, 218, 248)", "rgb(207, 226, 243)", "rgb(217, 210, 233)", "rgb(234, 209, 220)",
			"rgb(221, 126, 107)", "rgb(234, 153, 153)", "rgb(249, 203, 156)", "rgb(255, 229, 153)", "rgb(182, 215, 168)",
			"rgb(162, 196, 201)", "rgb(164, 194, 244)", "rgb(159, 197, 232)", "rgb(180, 167, 214)", "rgb(213, 166, 189)",
			"rgb(204, 65, 37)", "rgb(224, 102, 102)", "rgb(246, 178, 107)", "rgb(255, 217, 102)", "rgb(147, 196, 125)",
			"rgb(118, 165, 175)", "rgb(109, 158, 235)", "rgb(111, 168, 220)", "rgb(142, 124, 195)", "rgb(194, 123, 160)",
			"rgb(166, 28, 0)", "rgb(204, 0, 0)", "rgb(230, 145, 56)", "rgb(241, 194, 50)", "rgb(106, 168, 79)",
			"rgb(69, 129, 142)", "rgb(60, 120, 216)", "rgb(61, 133, 198)", "rgb(103, 78, 167)", "rgb(166, 77, 121)",
			"rgb(91, 15, 0)", "rgb(102, 0, 0)", "rgb(120, 63, 4)", "rgb(127, 96, 0)", "rgb(39, 78, 19)",
			"rgb(12, 52, 61)", "rgb(28, 69, 135)", "rgb(7, 55, 99)", "rgb(32, 18, 77)", "rgb(76, 17, 48)"]
	]
};

$(document).ready(function() {
	$.ajaxSetup({
		async: false,
		cache: false
	});

	var url = window.location.href;
	$("#left-contents").find("a").each(function() {
		if (url.indexOf($(this).attr("href")) >= 0) {
			if (!$(this).closest("div").hasClass("cls_menu")) {
				$(this).closest("div").addClass("cls_menu_selected");
				return;
			}
		}
	});
});

function validateParams() {
	$("input").removeClass("cls_error");

	for(rule in rules){
		vals = rules[rule].split(",");
		for(val in vals) {
			switch (vals[val]) {
				case "required":
					if ($("#" + rule).val().trim() == "") {
						$("#" + rule).addClass("cls_error");
						alert(params[rule] + "を入力してください。");
						return(false);
					}
					break;
				case "equal":
					cols = rule.split(",");
					if ($("#" + cols[0]).val().trim() != $("#" + cols[1]).val().trim()) {
						$("#" + cols[0]).addClass("cls_error");
						$("#" + cols[1]).addClass("cls_error");
						alert(params[cols[0]] + "と" + params[cols[0]] + "が一致していません。");
						return(false);
					}
//					$col = explode(",", $key);
//					if ($this->posts[$col[0]] != $this->posts[$col[1]]) {
//						$this->error_params = $key;
//						$this->error_message = $this->params[$col[0]]."と".$this->params[$col[1]]."に同じ文字を入力してください。";
//						return(false);
//					}
					break;
				case "numeric":
					if ($("#" + rule).val().match(/[^0-9]+/)) {
						$("#" + rule).addClass("cls_error");
						alert(params[rule] + "に数字を入力してください。");
						return(false);
					}
					break;
				case "alphanumeric":
					if ($("#" + rule).val().match(/^[A-Za-z0-9]+/)) {
						$("#" + rule).addClass("cls_error");
						alert(params[rule] + "に英数字・ハイフン・アンダースコアを入力してください。");
						return(false);
					}
					break;
				case "date":
//					if ($("#" + rule).val().match(/[^0-9]+/)) {
//						$("#" + rule).addClass("cls_error");
//						alert(params[rule] + "に日付を入力してください。");
//						return(false);
//					}
					break;
				case "email":
					if ($("#" + rule).val().match(/[\w.\-]+@[\w\-]+\.[\w.\-]+/)) {
						$("#" + rule).addClass("cls_error");
						alert(params[rule] + "に正しいメールアドレスを入力してください。");
						return(false);
					}
					break;
				case "url":
					if ($("#" + rule).val().match(/^(https?|ftp)(:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:\@&=+\$,%#]+)/)) {
						$("#" + rule).addClass("cls_error");
						alert(params[rule] + "に正しいURLを入力してください。");
						return(false);
					}
					break;
				case "length":
//					if ($("#" + rule).val().match(/[^0-9]+/)) {
//						$("#" + rule).addClass("cls_error");
//						alert(params[rule] + "に数字を入力してください。");
//						return(false);
//					}
//					list($min,$max) = explode("-", $set);
//					if (strlen($this->posts[$key]) < $min) {
//						$this->error_params = $key;
//						$this->error_message = $this->params[$key]."は".$min."文字以上で入力してください。";
//						return(false);
//					}
//					if (strlen($this->posts[$key]) > $max) {
//						$this->error_params = $key;
//						$this->error_message = $this->params[$key]."は".$max."文字以下で入力してください。";
//						return(false);
//					}
					break;
			}
		}
	}
	return(true);
}

function unCrLfHTMLtoBr(str) {
	return str.replace(/<crlf><\/crlf>/g, "<br>")
		.replace(/<crlf \/>/g, "<br>");
}

function escapeHTML(str,param) {
	var tmp = str;
	//tmp = tmp.replace(/\r?\n/g, "");
	//tmp = tmp.replace(/-->/g, "-->\n");

	tmp = tmp.replace(/<h1><\/h1>/g, "");
	tmp = tmp.replace(/<h2><\/h2>/g, "");
	tmp = tmp.replace(/<h3><\/h3>/g, "");
	tmp = tmp.replace(/<h4><\/h4>/g, "");
	tmp = tmp.replace(/<h5><\/h5>/g, "");
	tmp = tmp.replace(/<h6><\/h6>/g, "");
	tmp = tmp.replace(/<p><\/p>/g, "");
	tmp = tmp.replace(/<div><\/div>/g, "");

	if (param == undefined) {
		return tmp.replace(/script/g, "ssccrriipptt")
			.replace(/style/g, "ssttyyllee")
			.replace(/ping/g, "ppiinngg")
			.replace(/\t/g, '')
			.replace(/\r?\n/g, "<crlf \/>")
			.replace(/&/g, '&amp;')
			.replace(/</g, '&lt;')
			.replace(/>/g, '&gt;')
			.replace(/"/g, '&quot;')
			.replace(/'/g, '&#39;');
	}
	if (param.indexOf("\n") >= 0) {
		tmp = tmp.replace(/\r?\n/g, "<crlf \/>");
	} else if (param.indexOf("&") >= 0) {
		tmp = tmp.replace(/&/g, '&amp;');
	} else if (param.indexOf("<") >= 0) {
		tmp = tmp.replace(/</g, '&lt;');
	} else if (param.indexOf(">") >= 0) {
		tmp = tmp.replace(/>/g, '&lt;');
	} else if (param.indexOf('"') >= 0) {
		tmp = tmp.replace(/"/g, '&quot;');
	} else if (param.indexOf("'") >= 0) {
		tmp = tmp.replace(/'/g, '&#39;');
	}
	tmp = tmp.replace(/\r?\n/g, "");

	return(tmp);
}

function unEscapeHTML(str,param) {
	if (param == undefined) {
		var tmp = str;
		tmp = tmp.replace(/(&amp;)/g, '&')
		tmp = tmp.replace(/(&amp;)/g, '&')
		tmp = tmp.replace(/(&nbsp;)/g, ' ')
		tmp = tmp.replace(/(&lt;)/g, '<')
		tmp = tmp.replace(/(&gt;)/g, '>')
		tmp = tmp.replace(/(&quot;)/g, '"')
		tmp = tmp.replace(/(&#39;)/g, "'")
		tmp = tmp.replace(/<crlf><\/crlf>/g, "\n")
		tmp = tmp.replace(/<crlf \/>/g, "\n")
		tmp = tmp.replace(/\n\n\n/g, "\n")
		tmp = tmp.replace(/ppiinngg/g, "ping")
		tmp = tmp.replace(/ssccrriipptt/g, "script")
		tmp = tmp.replace(/ssttyyllee/g, "style");
		tmp = tmp.replace(/<div class='item_image'><\/div>/g, '<div>#item_image#</div>');
		tmp = tmp.replace(/<div class='item_image2'><\/div>/g, '<div>#item_image2#</div>');
		return(tmp);
	}
	var tmp = str;
	if (param.indexOf("<") >= 0) {
		tmp = tmp.replace(/(&lt;)/g, '<');
	} else if (param.indexOf(">") >= 0) {
		tmp = tmp.replace(/(&gt;)/g, '>');
	} else if (param.indexOf('"') >= 0) {
		tmp = tmp.replace(/(&quot;)/g, '"');
	} else if (param.indexOf("'") >= 0) {
		tmp = tmp.replace(/(&#39;)/g, "'");
	} else if (param.indexOf("&") >= 0) {
		tmp = tmp.replace(/(&amp;)/g, '&');
	} else if (param.indexOf("\n") >= 0) {
		tmp = tmp.replace(/<crlf><\/crlf>/g, "\n");
		tmp = tmp.replace(/<crlf \/>/g, "\n");
	}
	return(tmp);
}

function getFormatNumber(num) {
	var str = String(num).replace(/,/g,"");
	str = String(parseInt(str,10));
	return str.replace(/,/g,"").replace( /(\d)(?=(\d\d\d)+(?!\d))/g, '$1,');
}
function getFormatString(num) {
	var str = String(num).replace(/,/g,"");
	return(str);
}

function getFormatDate(year,month,date,format) {
	var dt = new Date(year,month-1,date);
	var strDate = "";
	switch(format) {
		case "yyyy/mm/dd":
			strDate = dt.getFullYear() + "/" + ("0"+String(dt.getMonth()+1)).slice(-2) + "/" + ("0"+String(dt.getDate())).slice(-2);
			break;
		case "yyyy-mm-dd":
			strDate = dt.getFullYear() + "-" + ("0"+String(dt.getMonth()+1)).slice(-2) + "-" + ("0"+String(dt.getDate())).slice(-2);
			break;
		case "Y-m-d":
			strDate = dt.getFullYear() + "-" + (dt.getMonth()+1) + "-" + dt.getDate();
			break;
		case "Y/m/d":
			strDate = dt.getFullYear() + "/" + (dt.getMonth()+1) + "/" + dt.getDate();
			break;
	}
	return(strDate);
}

function getNowDate() {
	var dt = new Date();
	var iYear = dt.getFullYear();
	var iMonth = dt.getMonth()+1;
	var iDate = dt.getDate();

	var tmpDate = getFormatDate(iYear,iMonth,iDate,"yyyy/mm/dd");
	return(tmpDate);
}

function getNendoStartDate(month) {
	var dt = new Date();
	var iYear = dt.getFullYear();
	var iMonth = dt.getMonth()+1;
	
	if (iMonth < month+1) {
		iYear--;
	}
	var tmpDate = getFormatDate(iYear,parseInt(month) + 1,1,"yyyy/mm/dd");
	return(tmpDate);
}

function getNendoEndDate(month) {
	var dt = new Date();
	var iYear = dt.getFullYear();
	var iMonth = dt.getMonth()+1;
	
	if (iMonth > month+1) {
		iYear++;
	}
	var tmpDate = getFormatDate(iYear,parseInt(month) + 1,0,"yyyy/mm/dd");
	return(tmpDate);
}

function createHTML_Date(objTo) {
	if ($(objTo).html() != "") {
		var dtNow = new Date($(objTo).html());
	} else {
		var dtNow = new Date();
	}
	var year = dtNow.getFullYear();
	var month = dtNow.getMonth() + 1;
	var date = dtNow.getDate();

	var strHTML = "";
	strHTML += "<div class='cls_div_header'>";
	strHTML += "<div class='cls_div_left'><input type='button' id='id_btn_prev' value='＜'></div>";
	strHTML += "<div class='cls_div_center'><div id='id_cal_date'></div></div>";
	strHTML += "<div class='cls_div_right'><input type='button' id='id_btn_next' value='＞'></div>";
	strHTML += "</div>";
	strHTML += "<div id='id_cal_main'></div>";
	strHTML += "<div id='id_cal_year' class='cls_none'></div>";
	strHTML += "<div id='id_cal_month' class='cls_none'></div>";
	
	strHTML += "<div class='cls_div_close'><input type='button' class='cls_btn_close' value='×'></div>";

	$("#id_opt_date").empty();
	$("#id_opt_date").html(strHTML);

	createHTML_Calender(year,month);
	
	$(document).on("click", "#id_cal_date", function() {
		var dtNow = new Date();
		var year = dtNow.getFullYear();
		var month = dtNow.getMonth() + 1;
		createHTML_Calender(year,month);
	});

	$(document).on("click", "#id_tbl_cal td", function() {
		$(objTo).val($(this).attr("dt"));
		$("div.cls_div_option").hide();
	});

	$("#id_btn_prev").on("click", function() {
		var year = $("#id_cal_year").html();
		var month = $("#id_cal_month").html();
		month--;
		if (month == 0) {
			year--;
			month = 12;
		}
		createHTML_Calender(year,month);
	});

	$("#id_btn_next").on("click", function() {
		var year = $("#id_cal_year").html();
		var month = $("#id_cal_month").html();
		month++;
		if (month == 13) {
			year++;
			month = 1;
		}
		createHTML_Calender(year,month);
	});
}

function createHTML_Calender(year,month) {
	var dt = getBaseDateForMonth(year,month,1);
	var iYear = dt.getFullYear();
	var iMonth = dt.getMonth() + 1;
	var iDate = dt.getDate();

	var strHTML = "";
	strHTML += "<table id='id_tbl_cal' class='cls_tbl_list cls_tbl_cal'>";
	var aryWeek = Array("日","月","火","水","木","金","土");
	strHTML += "<tr>";
	for (var row = 0; row < 7; row++){
		strHTML += "<td><div>" + aryWeek[row] + "</div></td>";
	}
	for (var row = 0; row < 6; row++){
		strHTML += "<tr>";
		for (var col = 0; col < 7; col++) {
			dt = new Date(iYear,iMonth-1,iDate);
			iYear = dt.getFullYear();
			iMonth = dt.getMonth()+1;
			iDate = dt.getDate();
			var tmpDate = getFormatDate(iYear,iMonth,iDate,"yyyy/mm/dd");
			
			strHTML += "<td dt='" + tmpDate + "'>" + iDate + "</td>";
			iDate++;
		}
	}
	strHTML += "</table>";
	
	$("#id_cal_main").html(strHTML);
		
	$("#id_cal_date").html(year + "年" + month + "月");
	$("#id_cal_year").html(year);
	$("#id_cal_month").html(month);
	$("#id_opt_date td").css("width",Math.round(100/7,2) + "%");
}

//基準日取得(月)
function getBaseDateForMonth(year,month,date) {
	var dtFirst = new Date(year, month-1, 1);		// 当月一日
	var first_day = dtFirst.getDay();				// 当月一日の曜日
	var dtLastPre = new Date(year, month-1, 0);		// 先月末
	var pre_last_date = dtLastPre.getDate();		// 先月末の日

	var iDate = pre_last_date - first_day + 1;
	var dt = new Date(year,month-2,iDate)
	return(dt);
}

function getHash(length) {
	// 生成する文字列に含める文字セット
	var base = "abcdefghijklmnopqrstuvwxyz0123456789";

	var str = "";
	for(var i = 0; i<length; i++){
		str += base[Math.floor(Math.random()*base.length)];
	}
	return(str);
}

function createHTML_imageDialog() {
	var strHTML = "";
	strHTML += "<div id='id_image_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").append(strHTML);

	//ダイアログ
	$('#id_image_dialog').dialog({
		title: "画像選択",
		modal: true,
		height: 'auto',
		width: 520,
		autoOpen: false,
		buttons: {
			"挿入": function(){
				if ($("div.cls_image_selected").size() == 0) {
					alert("画像を選択してください。")
					return;
				}
				var pid = $("#id_image_dialog").attr("editor");
				$("#" + pid).add_image($("div.cls_image_selected").find("img").attr("src"));
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});

	var strHTML = "";
	strHTML += "<label class='button small-button'>画像を追加<input type='file' id='id_inp_image_file' name='id_inp_image_file' class='cls_none' col='title_image_file' filename='' enctype='multipart/form-data'></label>";
	strHTML += "<input type='button' id='id_inp_image_file_del' class='red-button small-button' value='画像を削除'>";
	strHTML += "<br><br>";
	strHTML += "<div id='id_image_thumnail'>イメージ</div>";
	
	$("#id_image_dialog").html(strHTML);
	
	refreshHTML_imageDialog();

	//画像追加ボタン
	$(document).on("change", "#id_inp_image_file", function() {
		var file = $(this)[0].files[0];
		// 画像以外は処理を停止
		if (! file.type.match("image.*")) {
			// クリア
			$(this).val("");
			return;
		}
		$(this).attr("filename",getHash(12) + file.name.substr(file.name.lastIndexOf(".")));
		if ($("#id_inp_image_file")[0].files[0] != undefined) {
			$("#id_inp_image_file").upload("./upload/site/?max_height=&max_width=&file_name=" + $("#id_inp_image_file").attr("filename"),
				function (data) {
					//alert("data:" + data);
					refreshHTML_imageDialog();
					// クリア
					$("#id_inp_image_file").val("");
				},
				""
			);
		}
	});
	
	//画像削除ボタン
	$(document).on("click", "#id_inp_image_file_del", function() {
		$("#id_inp_image_file").upload("./upload/site/?proc_type=delete&file_name=" + $("div.cls_image_selected").find("img").attr("src"),
			function (data) {
				//alert("data:" + data);
				refreshHTML_imageDialog();
				// クリア
				$("#id_inp_image_file").val("");
			},
			""
		);
	});
	
	//画像選択
	$(document).on("click", "div.cls_image_thumnail", function() {
		$("div.cls_image_thumnail").removeClass("cls_image_selected");
		$(this).addClass("cls_image_selected");
	});

	//画像挿入
	$(document).on("dblclick", "div.cls_image_thumnail", function() {
		var pid = $("#id_image_dialog").attr("editor");
		$("#" + pid).add_image($("div.cls_image_selected").find("img").attr("src"));
		$("div.cls_div_option").hide();
		$('#id_image_dialog').dialog('close');
	});
}

function refreshHTML_imageDialog() {
	var strHTML = "";
	
	$.ajaxSetup({async: false});
	$.getJSON("./imagelist/site/", function(objJSON){
		if (objJSON.data != null) {
			for (var i = 0; i < objJSON.data.length; i++){
				strHTML += "<div class='cls_image_thumnail'>";
				strHTML += "<img src='" + _sub_dir + objJSON.data[i].image + "'>";
				strHTML += "</div>";
			}
		}
	});
	
	$("#id_image_thumnail").html(strHTML);
}

function createHTML_templateDialog() {
	var strHTML = "";
	strHTML += "<div id='id_template_dialog' class='cls_dialog'></div>";

	$("#id_div_PageContens").append(strHTML);

	//ダイアログ
	$('#id_template_dialog').dialog({
		title: "テンプレート選択",
		modal: true,
		height: 'auto',
		width: 640,
		autoOpen: false,
		buttons: {
			"テンプレート保存": function(){
				var setData =  {
					page_id: $("#id_inp_template_id").val(),
					template_type: $("#id_inp_template_type").val(),
					template_text: escapeHTML(CKEDITOR.instances['id_inp_template_text'].getData()),
				};
				if (setData["template_text"] == "") {
					setData["template_text"] = " ";
				}
				if ($("#id_inp_template_id").val() == "-1") {
					$.post("./insert/page_template/",
						setData,
						function(data){
							if (!post_check(data)) {return;}
							alert("テンプレートを保存しました。");
						}
					);
					//template_idを取得
					$.getJSON("./select/page_template/", function(objJSON){
						for (var i = 0; i < objJSON.data.length; i++){
							if (objJSON.data[i].template_type == $("#id_inp_template_type").val()) {
								$("#id_inp_template_id").val(objJSON.data[i].template_id);
								break;
							}
						}
					});
				} else {
					setData["template_id"] = $("#id_inp_template_id").val();
					$.post("./update/page_template/",
						setData,
						function(data){
							if (!post_check(data)) {return;}
							alert("テンプレートを保存しました。");
						}
					);
				}
			},
			"テンプレート挿入": function(){
				var pid = $("#id_template_dialog").attr("editor");
				$("#" + pid).add_text($("#id_inp_template_text").val());
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});

	var strHTML = "";
	strHTML += "<div>";
	strHTML += "<input type='button' id='id_btn_template_text1' class='button default-button small-button btn-template' value='テンプレート1'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text2' class='button default-button small-button btn-template' value='テンプレート2'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text3' class='button default-button small-button btn-template' value='テンプレート3'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text4' class='button default-button small-button btn-template' value='テンプレート4'>&nbsp;";
	strHTML += "</div>";
	strHTML += "<div style='margin-top:6px;margin-bottom:12px;'>";
	strHTML += "<input type='button' id='id_btn_template_text5' class='button default-button small-button btn-template' value='テンプレート5'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text6' class='button default-button small-button btn-template' value='テンプレート6'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text7' class='button default-button small-button btn-template' value='テンプレート7'>&nbsp;";
	strHTML += "<input type='button' id='id_btn_template_text8' class='button default-button small-button btn-template' value='テンプレート8'>&nbsp;";
	strHTML += "</div>";
	strHTML += "<textarea id='id_inp_template_text' class='ckeditor'></textarea>";
	strHTML += "<input type='hidden' id='id_inp_template_id' value='-1'>";
	strHTML += "<input type='hidden' id='id_inp_template_type' value='-1'>";
	
	$("#id_template_dialog").html(strHTML);
	
	CKEDITOR.replace("id_inp_template_text", {
		height: 300,
		toolbar: [
			["Bold", "Italic", "Underline", "Strike", "TextColor", "BGColor"],
			["JustifyLeft", "JustifyCenter", "JustifyRight"],
			["Link", "Image", "Table", "HorizontalRule"],
			["Styles", "Format", "FontSize"],
			["Maximize"],
			["Source"],
			["code"],
			["Recommend"],
		],
		uiColor: '#EEEEEE',
		enterMode: 2,
		shiftEnterMode: 2,
		allowedContent: true,
		fillEmptyBlocks: false,
		tabSpaces: 0
	});

	//テンプレート選択ボタン
	$(document).off("click", "input.btn-template");
	$(document).on("click", "input.btn-template", function() {
		$("input.btn-template").addClass("default-button");
		$("#" + $(this).attr("id")).removeClass("default-button");

		var template_type = $(this).attr("id").substr(-1);
		$("#id_inp_template_type").val(template_type);
		$("#id_inp_template_id").val("-1");
		$("#id_inp_template_text").val("");

		$.ajaxSetup({async: false});
		$.getJSON("./select/page_template/", function(objJSON){
			for (var i = 0; i < objJSON.data.length; i++){
				if (objJSON.data[i].template_type == template_type) {
					$("#id_inp_template_id").val(objJSON.data[i].template_id);
					$("#id_inp_template_text").val(unEscapeHTML(objJSON.data[i].template_text));
					break;
				}
			}
		});
		CKEDITOR.instances['id_inp_template_text'].setData($("#id_inp_template_text").val());
	});

	$("#id_btn_template_text1").trigger("click");
}

function createHTML_supportDialog() {
	var strHTML = "";
	strHTML += "<div id='id_support_dialog' class='cls_dialog'></div>";
	$("#id_div_PageContens").append(strHTML);

	//ダイアログ
	$('#id_support_dialog').dialog({
		title: "入力補助ツール",
		modal: true,
		height: 'auto',
		width: 960,
		autoOpen: false,
		buttons: {
			"閉じる": function () {
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	var strHTML = "";
	strHTML += "<table>";
	strHTML += "<tr>"; //<i class="fas fa-chevron-square-right"></i><i class="fas fa-arrow-alt-right"></i>
	strHTML += "<td><div class='cls_info_box support-box' col='header'><i class='fas fa-heading'></i> 見出し</div>";
	strHTML += "<td><div class='cls_info_box support-box' col='list'><i class='fa fa-list-ul'></i> リスト</div>";
	strHTML += "<td><div class='cls_info_box support-box' col='box'><i class='far fa-square'></i> 囲い枠</div>";
	strHTML += "<td><div class='cls_info_box support-box' col='button'><i class='fas fa-square'></i> ボタン</div>";
	strHTML += "<td><div class='cls_info_box support-box' col='talk'><i class='far fa-comments'></i> 会話</div>";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<div id='id_support_dialog_input'></div>";

	$("#id_support_dialog").html(strHTML);

	//種類
	$(document).off("click", "div.support-box");
	$(document).on("click", "div.support-box", function() {
		$("div.support-box").removeClass("cls_selected");
		$(this).addClass("cls_selected");
		switch($(this).attr("col")) {
			case "header":
				createHTML_headerDialog();
				break;
			case "list":
				createHTML_listDialog();
				break;
			case "box":
				createHTML_boxDialog();
				break;
			case "button":
				createHTML_buttonDialog();
				break;
			case "talk":
				createHTML_balloonDialog();
				break;
		}
	});
}

function createHTML_headerDialog() {
	var strHTML = "";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>タグ：<td><select type='text' id='id_inp_header_tag'>";
	strHTML += "<option value='h1'>h1";
	strHTML += "<option value='h2'>h2";
	strHTML += "<option value='h3'>h3";
	strHTML += "<option value='div'>div";
	strHTML += "</select>";
	strHTML += "<th>テキスト：<td colspan=3><input type='text' id='id_inp_header_text' size=40>";
	strHTML += "</table>";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>テキスト色：<td><input type='color' id='id_inp_header_text_color' value='#1f1f1f'>　";
	strHTML += "<th>背景色：<td><input type='color' id='id_inp_header_bg_color' value='#ffffff'>　";
	strHTML += "<th>枠線色：<td><input type='color' id='id_inp_header_border_color' value='#337ab7'>　";
	strHTML += "</table>";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th rowspan=5>スタイル：<td style='padding:4px;'><input type='radio' id='id_inp_header_text_style' name='id_inp_header_text_style' value='none' checked><td><div style='width:400px;background-color:#efefef;'>&nbsp;</div>";
	strHTML += "<tr><td style='padding:4px;'><input type='radio' id='id_inp_header_text_style' name='id_inp_header_text_style' value='box'><td><div style='width:400px;background-color:#efefef;border:3px solid #333;'>&nbsp;</div>";
	strHTML += "<tr><td style='padding:4px;'><input type='radio' id='id_inp_header_text_style' name='id_inp_header_text_style' value='top-bottom'><td><div style='width:400px;background-color:#efefef;border-top:3px solid #333;border-bottom:3px solid #333;'>&nbsp;</div>";
	strHTML += "<tr><td style='padding:4px;'><input type='radio' id='id_inp_header_text_style' name='id_inp_header_text_style' value='left-bottom'><td><div style='width:400px;background-color:#efefef;border-left:3px solid #333;border-bottom:3px solid #333;'>&nbsp;</div>";
	strHTML += "<tr><td style='padding:4px;'><input type='radio' id='id_inp_header_text_style' name='id_inp_header_text_style' value='bottom'><td><div style='width:400px;background-color:#efefef;border-bottom:3px solid #333;'>&nbsp;</div>";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<div><button type='button' class='btn btn-success' id='id_btn_add'><i class='fas fa-plus'></i> 挿入</button></div>";

	$("#id_support_dialog_input").html(strHTML);

	_spectrum["color"] = $("#id_inp_header_bg_color").val();
	$("#id_inp_header_bg_color").spectrum(_spectrum);

	_spectrum["color"] = $("#id_inp_header_text_color").val();
	$("#id_inp_header_text_color").spectrum(_spectrum);

	_spectrum["color"] = $("#id_inp_header_border_color").val();
	$("#id_inp_header_border_color").spectrum(_spectrum);

	//タグ挿入
	$(document).off("click", "#id_btn_add");
	$(document).on("click", "#id_btn_add", function () {
		if ($("#id_inp_header_text").val().trim() == "") {
			alert("テキストを入力してください。");
			return;
		}
		var pid = $("#id_support_dialog").attr("editor");
		var style = "";
		style += "color:" + $("#id_inp_header_text_color").val() + ";";
		style += "background-color:" + $("#id_inp_header_bg_color").val() + ";";
		if ($("#id_inp_header_text_style:checked").val() == "box") {
			style += "border:3px solid " + $("#id_inp_header_border_color").val() + ";";
		}
		if ($("#id_inp_header_text_style:checked").val().indexOf("top") >= 0) {
			style += "border-top:3px solid " + $("#id_inp_header_border_color").val() + ";";
		}
		if ($("#id_inp_header_text_style:checked").val().indexOf("bottom") >= 0) {
			style += "border-bottom:3px solid " + $("#id_inp_header_border_color").val() + ";";
		}
		if ($("#id_inp_header_text_style:checked").val().indexOf("left") >= 0) {
			style += "border-left:3px solid " + $("#id_inp_header_border_color").val() + ";";
		}
		var tag = $("#id_inp_header_tag").val();
		var html = "<" + tag + " style='" + style + "'>" + $("#id_inp_header_text").val() + "</" + tag + ">";
		$("#" + pid).add_text(html);
		$("div.cls_div_option").hide();
		$("#id_support_dialog").dialog('close');
	});
}

function createHTML_listDialog() {
	var strHTML = "";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>マーク：<td>";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-angle-right' checked> <i class='fas fa-angle-right'></i>　";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-angle-right'> <i class='fas fa-angle-right'></i>　";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-angle-double-right'> <i class='fas fa-angle-double-right'></i>　";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-arrow-alt-circle-right'> <i class='fas fa-arrow-alt-circle-right'></i>　";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-caret-right'> <i class='fas fa-caret-right'></i>　";
	strHTML += "<input type='radio' id='id_inp_mark_style' name='id_inp_mark_style' value='fas fa-check'> <i class='fas fa-check'></i>　";
	strHTML += "<tr>";
	strHTML += "<th>マーク色：<td><input type='color' id='id_inp_mark_color' value='#333'>";
	strHTML += "<tr>";
	strHTML += "<th>リスト：<br>(改行)<td><textarea id='id_inp_list_text'></textarea>";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<div><button type='button' class='btn btn-success' id='id_btn_add'><i class='fas fa-plus'></i> 挿入</button></div>";

	$("#id_support_dialog_input").html(strHTML);

	_spectrum["color"] = $("#id_inp_mark_color").val();
	$("#id_inp_mark_color").spectrum(_spectrum);

	//タグ挿入
	$(document).off("click", "#id_btn_add");
	$(document).on("click", "#id_btn_add", function () {
		if ($("#id_inp_list_text").val().trim() == "") {
			alert("リストを入力してください。");
			return;
		}
		var style = "";
		style += "color:" + $("#id_inp_mark_color").val() + ";font-size:110%;margin-right:-4px;";
		var list = "";
		var rows = $("#id_inp_list_text").val().replace(/\r?\n/g,'\n').split('\n');
		for (row in rows) {
			if (row != "") {
				list += "<li><i class='" + $("#id_inp_mark_style:checked").val() + "' style='" + style + "'>　</i>" + rows[row] + "</li>";
			}
		}
		var style = "list-style:none;padding:0px;margin:0px;margin-top:8px;margin-bottom:8px;";
		var html = "<ul style='" + style + "'>" + list + "</ul>";
		var pid = $("#id_support_dialog").attr("editor");
		$("#" + pid).add_text(html);
		$("div.cls_div_option").hide();
		$("#id_support_dialog").dialog('close');
	});
}

function createHTML_boxDialog() {
	var strHTML = "";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>タイトル：<td><input type='text' id='id_inp_box_title' size=40>";
	strHTML += "<tr>";
	strHTML += "<th>テキスト：<td><textarea id='id_inp_box_text'></textarea>";
	strHTML += "</table>";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>テキスト色：<td><input type='color' id='id_inp_box_text_color' value='#1f1f1f'>　";
	strHTML += "<th>枠線色：<td><input type='color' id='id_inp_box_border_color' value='#337ab7'>　";
	strHTML += "<th>背景色：<td><input type='color' id='id_inp_box_bg_color' value='#ffffff'>　";
	strHTML += "</table>";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th rowspan=2>スタイル：";
	strHTML += "<td valign='top'><div style='width:160px;height:106px;padding:4px;border:2px solid #337ab7;font-size:80%;margin-top:8px;'>テキストテキストテキストテキストテキストテキストテキストテキストテキストテキストテキストテキスト</div>";
	strHTML += "<td valign='top'><div style='width:160px;padding:4px;background-color:#337ab7;color:#fff;font-size:80%;margin-top:8px;'>タイトル</div>";
	strHTML += "<div style='width:160px;height:80px;padding:4px;border:2px solid #337ab7;font-size:80%;'>テキストテキストテキストテキストテキストテキストテキストテキストテキストテキスト</div>";
	strHTML += "<td valign='top'><div style='width:max-content;padding-right:4px;padding-left:4px;background-color:#fff;position:relative;top:8px;left:9px;font-size:80%;'>タイトル</div>";
	strHTML += "<div style='width:160px;height:96px;padding:4px;padding-top:12px;border:2px solid #337ab7;font-size:80%;'>テキストテキストテキストテキストテキストテキストテキストテキストテキストテキスト</div>";
	strHTML += "<tr>";
	strHTML += "<td align='center'><input type='radio' id='id_inp_box_style' name='id_inp_box_style' value='box' checked><br>";
	strHTML += "<td align='center'><input type='radio' id='id_inp_box_style' name='id_inp_box_style' value='title'><br>";
	strHTML += "<td align='center'><input type='radio' id='id_inp_box_style' name='id_inp_box_style' value='title2'><br>";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<div><button type='button' class='btn btn-success' id='id_btn_add'><i class='fas fa-plus'></i> 挿入</button></div>";

	$("#id_support_dialog_input").html(strHTML);

	_spectrum["color"] = $("#id_inp_box_border_color").val();
	$("#id_inp_box_border_color").spectrum(_spectrum);

	_spectrum["color"] = $("#id_inp_box_bg_color").val();
	$("#id_inp_box_bg_color").spectrum(_spectrum);

	//タグ挿入
	$(document).off("click", "#id_btn_add");
	$(document).on("click", "#id_btn_add", function () {
		if ($("#id_inp_box_text").val().trim() == "") {
			alert("テキストを入力してください。");
			return;
		}
		var html = "";
		var style1 = "";
		var style2 = "";
		switch ($("#id_inp_box_style:checked").val()) {
			case "box":
				style1 = "width:90%;padding:8px;margin-top:8px;border:2px solid " + $("#id_inp_box_border_color").val() + ";background-color:" + $("#id_inp_box_bg_color").val() + ";";
				html = "<div style='" + style1 + "'>" + $("#id_inp_box_text").val().replace(/\n/g,"<br>") + "</div>";
				break;
			case "title":
				style1 = "width:90%;padding:8px;margin-top:8px;;border:2px solid " + $("#id_inp_box_border_color").val() + ";background-color:" + $("#id_inp_box_border_color").val() + ";color:#fff;";
				style2 = "width:90%;padding:8px;border:2px solid " + $("#id_inp_box_border_color").val() + ";background-color:" + $("#id_inp_box_bg_color").val() + ";";
				html += "<div style='" + style1 + "'>" + $("#id_inp_box_title").val() + "</div>";
				html += "<div style='" + style2 + "'>" + $("#id_inp_box_text").val().replace(/\n/g,"<br>") + "</div>";
				break;
			case "title2":
				style1 = "width:max-content;padding-right:6px;padding-left:6px;margin-top:8px;background-color:#fff;position:relative;top:10px;left:10px;";
				style2 = "width:90%;padding:8px;padding-top:16px;border:2px solid " + $("#id_inp_box_border_color").val() + ";background-color:" + $("#id_inp_box_bg_color").val() + ";";
				html += "<div style='" + style1 + "'>" + $("#id_inp_box_title").val() + "</div>";
				html += "<div style='" + style2 + "'>" + $("#id_inp_box_text").val().replace(/\n/g,"<br>") + "</div>";
				break;
		}
		var pid = $("#id_support_dialog").attr("editor");
		$("#" + pid).add_text(html);
		$("div.cls_div_option").hide();
		$("#id_support_dialog").dialog('close');
	});
}

function createHTML_buttonDialog() {
	var strHTML = "";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th>テキスト：<td colspan=3><input type='text' id='id_inp_button_text' size=40>";
	strHTML += "<tr>";
	strHTML += "<th>リンクURL：<td colspan=3><input type='text' id='id_inp_button_url' size=60>";
	strHTML += "<tr>";
	strHTML += "<th>サイズ：<td><input type='radio' id='id_inp_button_size' name='id_inp_button_size' value='large' checked> 大　";
	strHTML += "<input type='radio' id='id_inp_button_size' name='id_inp_button_size' value='middle'> 中　";
	strHTML += "<input type='radio' id='id_inp_button_size' name='id_inp_button_size' value='small'> 小　";
	strHTML += "<tr>";
	strHTML += "<th>色：<td><input type='color' id='id_inp_header_bg_color' value='#337ab7'>";
	strHTML += "</table>";
	strHTML += "<table cellpadding=4>";
	strHTML += "<tr>";
	strHTML += "<th rowspan=5>スタイル：<td style='padding:4px;'><input type='radio' id='id_inp_button_style' name='id_inp_button_style' value='button1' checked><td><div style='width:200px;font-weight:bold;background-color:#337ab7;padding:8px;text-align:center;color:#fff;'>ボタン</div>";
	strHTML += "<td style='padding:4px;'><input type='radio' id='id_inp_button_style' name='id_inp_button_style' value='button2'><td><div style='width:200px;font-weight:bold;background-color:#337ab7;padding:8px;text-align:center;color:#fff;border-radius:5px;'>ボタン</div>";
	strHTML += "<tr><td style='padding:4px;'><input type='radio' id='id_inp_button_style' name='id_inp_button_style' value='button3'><td><div style='width:200px;font-weight:bold;background-color:#fff;border:2px solid #337ab7;padding:8px;text-align:center;color:#337ab7;'>ボタン</div>";
	strHTML += "<td style='padding:4px;'><input type='radio' id='id_inp_button_style' name='id_inp_button_style' value='button4'><td><div style='width:200px;font-weight:bold;background-color:#fff;border:2px solid #337ab7;padding:8px;text-align:center;color:#337ab7;border-radius:5px;'>ボタン</div>";
	strHTML += "</table>";
	strHTML += "<br>";
	strHTML += "<div><button type='button' class='btn btn-success' id='id_btn_add'><i class='fas fa-plus'></i> 挿入</button></div>";

	$("#id_support_dialog_input").html(strHTML);

	_spectrum["color"] = $("#id_inp_header_bg_color").val();
	$("#id_inp_header_bg_color").spectrum(_spectrum);

	_spectrum["color"] = $("#id_inp_header_text_color").val();
	$("#id_inp_header_text_color").spectrum(_spectrum);

	_spectrum["color"] = $("#id_inp_header_border_color").val();
	$("#id_inp_header_border_color").spectrum(_spectrum);

	//タグ挿入
	$(document).off("click", "#id_btn_add");
	$(document).on("click", "#id_btn_add", function () {
		if ($("#id_inp_button_text").val().trim() == "") {
			alert("テキストを入力してください。");
			return;
		}
		if ($("#id_inp_button_url").val().trim() == "") {
			alert("リンクURLを入力してください。");
			return;
		}

		var style1 = $("#id_inp_button_style:checked").closest("tr").find("div").attr("style");
		style1 = style1.replace(/#337ab7/g, $("#id_inp_header_bg_color").val());
		style1 += "margin-top:12px;margin-bottom:12px;";
		switch ($("#id_inp_button_size:checked").val()) {
			case "large":
				style1 = style1.replace(/width:200px/g, "width:90%");
				style1 = "margin:0 auto;" + style1;
				break;
			case "middle":
				style1 = style1.replace(/width:200px/g, "width:50%");
				style1 = "margin:0 auto;" + style1;
				break;
		}

		var style2 = "";
		switch ($("#id_inp_button_style:checked").val()) {
			case "button1":
			case "button2":
				style2 = "text-decoration:none;color:#fff;";
				break;
			case "button3":
			case "button4":
				style2 = "text-decoration:none;color:" + $("#id_inp_header_bg_color").val() + ";";
				break;
		}
		var html = "<div style='" + style1 + "'><a href='" + $("#id_inp_button_url").val() + "' style='" + style2 + "'>" + $("#id_inp_button_text").val() + "</a></div>";
//		var html = "<span style='" + style1 + "'><a href='" + $("#id_inp_button_url").val() + "' style='" + style2 + "'>" + $("#id_inp_button_text").val() + "</a></span>";
		var pid = $("#id_support_dialog").attr("editor");
		$("#" + pid).add_text(html);
		$("div.cls_div_option").hide();
		$("#id_support_dialog").dialog('close');
	});
} 

function createHTML_balloonDialog() {
	var strHTML = "";
	strHTML += "<table>";
	strHTML += "<tr>";
	strHTML += "<th colspan=2 style='background-color:#333;color:#fff;text-align:center;'>会話(左)<td width=40px;><th colspan=2 style='background-color:#333;color:#fff;text-align:center;'>会話(右)";
	strHTML += "<tr>";
	strHTML += "<td><img src='" + _sub_dir + "/images/animal_inu.png' id='id_inp_balloon_left_user_image' style='max-width:60px;max-height:60px;'>";
	strHTML += "<td><input type='button' id='id_inp_balloon_left_user_image_file' class='small-button' col='id_inp_balloon_left_user_image' value='画像' style='min-width:30px;'>";
	strHTML += "<input type='button' id='id_inp_balloon_left_user_image_file_del' class='red-button small-button' col='id_inp_balloon_left_user_image' value='削除' style='min-width:30px;'>";
	strHTML += "<td>";
	strHTML += "<td><img src='" + _sub_dir + "/images/animal_usagi.png' id='id_inp_balloon_right_user_image' style='max-width:60px;max-height:60px;'>";
	strHTML += "<td><input type='button' id='id_inp_balloon_right_user_image_file' class='small-button' col='id_inp_balloon_right_user_image' value='画像' style='min-width:30px;'>";
	strHTML += "<input type='button' id='id_inp_balloon_right_user_image_file_del' class='red-button small-button' col='id_inp_balloon_right_user_image' value='削除' style='min-width:30px;'>";
	strHTML += "<tr>";
	strHTML += "<th>名前：<td><input type='text' id='id_inp_balloon_left_user' value=''>";
	strHTML += "<td>";
	strHTML += "<th>名前：<td><input type='text' id='id_inp_balloon_right_user' value=''>";
	strHTML += "<tr>";
	strHTML += "<th>コメント<td><textarea id='id_inp_balloon_left_comment' rows=3 cols=30 style='min-width:300px;min-height:80px;'></textarea>";
	strHTML += "<td>";
	strHTML += "<th>コメント<td><textarea id='id_inp_balloon_right_comment' rows=3 cols=30 style='min-width:300px;min-height:80px;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<td><td><input type='button' id='id_btn_balloon_left_add' class='button small-button btn-balloon' value='追加'>&nbsp;";
	strHTML += "<td>";
	strHTML += "<td><td><input type='button' id='id_btn_balloon_right_add' class='button small-button btn-balloon' value='追加'>&nbsp;";
	strHTML += "</table>";

	strHTML += "<div style='margin-top:12px;'><input type='button' id='id_inp_balloon_clear' class='small-button' value='クリア'></div>";
	strHTML += "<div id='id_balloon_area' style='width:760px;min-height:100px;border:1px solid #ccc;padding:10px;margin-top:10px;font-size:90%;'></div>";
	strHTML += "<br>";
	strHTML += "<div><button type='button' class='btn btn-success' id='id_btn_add'><i class='fas fa-plus'></i> 挿入</button></div>";
	
	$("#id_support_dialog_input").html(strHTML);

	$("#id_inp_balloon_left_user").val("Aさん");
//$("#id_inp_balloon_left_comment").val("左コメント。左コメント。左コメント。");
	$("#id_inp_balloon_right_user").val("Bさん");
//$("#id_inp_balloon_right_comment").val("右コメント。右コメント。右コメント。");

	//タグ挿入
	$(document).off("click", "#id_btn_add");
	$(document).on("click", "#id_btn_add", function () {
		var pid = $("#id_support_dialog").attr("editor");
		$("#" + pid).add_text($("#id_balloon_area").html());
		$("div.cls_div_option").hide();
		$("#id_support_dialog").dialog('close');
	});

	//会話追加ボタン
	$(document).off("click", "input.btn-balloon");
	$(document).on("click", "input.btn-balloon", function() {
		var user = $("#id_inp_balloon_left_user").val();
		var comment = $("#id_inp_balloon_left_comment").val();
		var src = $("#id_inp_balloon_left_user_image").attr("src");
		var position = "left";
		if ($(this).attr("id") == "id_btn_balloon_right_add") {
			user = $("#id_inp_balloon_right_user").val();
			comment = $("#id_inp_balloon_right_comment").val();
			var src = $("#id_inp_balloon_right_user_image").attr("src");
			position = "right";
		}

		var strHTML = "";
		strHTML += "<div class='balloon'>";
		strHTML += "<div class='balloon-image-" + position + "'><img src='" + src + "'>";
		strHTML += "<div class='balloon-image-description'>" + user + "</div>";
		strHTML += "</div>";
		strHTML += "<div class='balloon-text-" + position + "'>" + comment + "</div>";
		strHTML += "</div>";
		$("#id_balloon_area").append(strHTML);
	});

	//画像選択ボタン
	$(document).off("click", "#id_inp_balloon_left_user_image_file,#id_inp_balloon_right_user_image_file");
	$(document).on("click", "#id_inp_balloon_left_user_image_file,#id_inp_balloon_right_user_image_file", function() {
		$("#id_image_dialog").attr("editor",$(this).attr("col"));
		$("#id_image_dialog").dialog("open");
	});

	//画像削除ボタン
	$(document).on("click", "#id_inp_balloon_left_user_image_file_del,#id_inp_balloon_right_user_image_file_del");
	$(document).on("click", "#id_inp_balloon_left_user_image_file_del,#id_inp_balloon_right_user_image_file_del", function() {
		$("#" + $(this).attr("col")).attr("src",_sub_dir + "/images/animal_inu.png");
		if ($(this).attr("id") == "id_inp_balloon_right_user_image_file_del") {
			$("#" + $(this).attr("col")).attr("src",_sub_dir + "/images/animal_usagi.png");
		}
	});

	//クリアボタン
	$(document).on("click", "#id_inp_balloon_clear");
	$(document).on("click", "#id_inp_balloon_clear", function() {
		$("#id_balloon_area").html("");
	});
}

//テキストエリアに画像を追加
$.fn.extend({
	add_image: function(image_path) {
		if ($(this).prop("tagName") == "IMG") {
			add_tag($(this).attr("id"), '', image_path);
		} else {
			add_tag($(this).attr("id"), '', '<div><img src="' + image_path + '"/></div>');
		}
	},
	add_text: function(text) {
		add_tag($(this).attr("id"), '', text);
	}
});

//テキストエリアの選択位置にタグ挿入
function add_tag(pid, start, image) {
	if ($("#" + pid).prop("tagName") == "IMG") {
		$("#" + pid).attr("src",image);
		return;
	}

	var editor = CKEDITOR.instances[pid];
	if (editor.mode == undefined) {
	} else if (editor.mode == "wysiwyg") {
//		editor.insertHtml(image);
		//直接挿入するとタグが削られるので代替文字を置換
		var rep = "@@@@@@@@@@";
		editor.insertHtml(rep);
		var html = editor.getData();
		html = html.replace(rep,image);
		editor.setData(html);
	} else {
		alert("ソースモードでは挿入できません。");
	}
}

//データ更新後のチェック
function post_check(jsonText) {
	//alert(jsonText);
	if (jsonText.indexOf("9") >=0) {
		//alert("一定期間、操作がなかったため、ログアウトします。")
		window.location.reload();
		return(false);
	}
	return(true);
}

//ページャ
function create_PagerHtml() {
	var disp_page = 9;
	var strHTML = "";
	var page = parseInt($("#id_search_page").val());
	var max_page = parseInt($("#id_search_maxpage").val());
	
	var start_page = page - Math.floor((disp_page)/2);
	if (start_page < 1) {
		start_page = 1;
	}
	var end_page = start_page + disp_page - 1;
	if (end_page > max_page) {
		end_page = max_page;
	}
	strHTML += "<div class='cls_navi'>\n";
	strHTML += "<div class='cls_page_box' page=1>＜＜</div>\n";
	if (page > 1) {
		strHTML += "<div class='cls_page_box' page='" + (page - 1) + "'>＜前へ</div>";
	}

	for (var i = start_page; i <= end_page; i++) {
		style = "";
		if (i == page) {
			style = " cls_now_page";
		}
		strHTML += "<div class='cls_page_box" + style + "' page='" + i + "'>&nbsp;" + i + "&nbsp;</div>";
	}

	if (page < max_page) {
		strHTML += "<div class='cls_page_box' page='" + (page + 1) + "'>次へ＞</a></div>";
	}
	strHTML += "<div class='cls_page_box' page='" + max_page + "'>＞＞</div>";
	strHTML += "</div><br><br>\n";

	$("#id_div_pager").html(strHTML);
}
