var params = {};
//ルール定義
var rules = {};

var _version = "";
var _option = "";

var _result_type_name = {
	"mixed":"評価",
	"recent":"新着",
	"popular":"人気",
};
var _disp_type_name = {
	"page": "コンテンツ",
	"menu": "サイドバー",
};
var _position_name = {
	"top": "上部",
	"bottom": "下部",
};
var _filter_type_name = {
	"": "指定なし",
	"images": "画像あり",
	"videos": "動画あり",
	"media": "画像または動画あり",
};

$(document).ready(function() {
	//ヘッダ
	createHTML_Header();

	//コンテンツ
	createHTML_Contents();
});

//ヘッダ表示
function createHTML_Header() {
	var strHTML = "";
	
	//strHTML = "test";
	$("#id_div_PageHeader").html(strHTML)
}

//コンテンツ表示
function createHTML_Contents() {	
	var strHTML = "";

	strHTML += "<h2 class='setting'>Twitterキーワード検索</h2>";

	strHTML += "<div class='cls_block'>";
	strHTML += "<button type='button' class='btn btn-primary' id='id_btn_add'><i class='fas fa-plus'></i> 追加</button>";
	strHTML += "</div>";

	strHTML += "<div id='id_div_list'></div>";

	strHTML += "<div id='id_dialog' class='cls_dialog'></div>";
	strHTML += "<div id='id_dialog2' class='cls_dialog'></div>";

	$("#id_div_PageContens").html(strHTML);

	createHTML_List();
	createHTML_templateDialog();
	createHTML_supportDialog();	
	createHTML_imageDialog();

	//ダイアログ
	$('#id_dialog').dialog({
		title: "Twitterキーワード検索編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"登録": function(){
				//パラメータ定義
			 	params = {
					"id_inp_keyword":"キーワード"
				};
				//ルール定義
				rules = {
					"id_inp_keyword":"required"
				};

				if (!validateParams()) {
					return(false);
				}
				updateCategory();
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	$('#id_dialog2').dialog({
		title: "Twitterキーワード検索編集",
		modal: true,
		height: 'auto',
		width: 800,
		autoOpen: false,
		buttons: {
			"設定": function(){
				var pid = $("#id_inp_pid").val();
				$("#" + pid).val(CKEDITOR.instances['id_inp_page_body'].getData());
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			},
			"閉じる": function(){
				$("div.cls_div_option").hide();
				$(this).dialog('close');
			}
		}
	});
	
	//新規登録ボタン
	$(document).on("click", "#id_btn_add", function() {
		createHTML_dialog();

		$("#id_dialog").dialog("open");
	});

	//編集ボタン
	$(document).on("click", "button.cls_btn_edit", function() {
		createHTML_dialog();

		var objTr = $(this).closest("tr");
		setInputFromList(objTr);
		$("#id_dialog").dialog("open");
	});

	//削除ボタン
	$(document).on("click", "button.cls_btn_delete", function() {
		if (confirm("削除しますか？")) {
			var objTr = $(this).closest("tr");
			deleteCategory(objTr);
		}
	});

	//閉じるボタン
	$(document).on("click", "input.cls_btn_close", function() {
		$(this).parent().parent().hide();
	});

	//ビジュアルエディタ
	$(document).on("click", "button.cls_btn_dialog", function() {
		createHTML_dialog2();

		var objTr = $(this).closest("tr");
		setInputFromList2(objTr);
		$("#id_dialog2").dialog("open");
	});

	//画像挿入ボタン
	$(document).on("click", "#id_inp_btn_image", function () {
		$("#id_image_dialog").attr("editor", "id_inp_page_body");
		$("#id_image_dialog").dialog("open");
	});
	//入力補助挿入ボタン
	$(document).on("click", "#id_inp_btn_support", function () {
		$("#id_support_dialog").attr("editor", "id_inp_page_body");
		$("#id_support_dialog").dialog("open");
	});
	//テンプレート挿入ボタン
	$(document).on("click", "#id_inp_btn_template", function () {
		$("#id_template_dialog").attr("editor", "id_inp_page_body");
		$("#id_template_dialog").dialog("open");
	});
}

//リスト表示
function createHTML_List() {
	var strHTML = "";

	strHTML += "<table id='id_tbl_list' class='cls_tbl_list'>";
	strHTML += "<tr>";
	strHTML += "<th width=50>No";
//	strHTML += "<th>カテゴリ";
	strHTML += "<th>タイトル";
	strHTML += "<th>キーワード";
	strHTML += "<th width=50px>表示順";
	strHTML += "<th width=150px>表示位置";
	strHTML += "<th width=100px>表示タイプ";
	strHTML += "<th width=150px>画像/動画";
	strHTML += "<th width=40px>表示順";
	strHTML += "<th>";
	strHTML += "<tbody>";

	$.ajaxSetup({async: false});
	$.getJSON("./select/twitter/", function(objJSON){
		for (var i = 0; i < objJSON.data.length; i++){
			if (objJSON.data[i].twitter_title == "") {
				objJSON.data[i].twitter_title = objJSON.data[i].keyword;
			}
			strHTML += "<tr key='"+ objJSON.data[i].twitter_id + "'>";
			strHTML += "<td col='twitter_id'>" + (i+1);
//			strHTML += "<td col='category_name'>" + objJSON.data[i].category_name;
			strHTML += "<td col='twitter_title'>" + objJSON.data[i].twitter_title;
			strHTML += "<td col='keyword'>" + objJSON.data[i].keyword;
			strHTML += "<td>" + _result_type_name[objJSON.data[i].result_type];
			strHTML += "<td>" + _disp_type_name[objJSON.data[i].disp_type];
			strHTML += "<td>" + "横" + objJSON.data[i].col_num + " × 縦" + objJSON.data[i].row_num;
			strHTML += "<td>" + _filter_type_name[objJSON.data[i].filter_type.trim()];
			strHTML += "<td col='sort_no'>" + objJSON.data[i].sort_no;
			strHTML += "<td col='result_type' class='cls_none'>" + objJSON.data[i].result_type;
			strHTML += "<td col='twitter_contents_header' class='cls_none'>" + objJSON.data[i].twitter_contents_header;
			strHTML += "<td col='twitter_contents_footer' class='cls_none'>" + objJSON.data[i].twitter_contents_footer;
			strHTML += "<td col='disp_type' class='cls_none'>" + objJSON.data[i].disp_type;
			strHTML += "<td col='position' class='cls_none'>" + objJSON.data[i].position;
			strHTML += "<td col='col_num' class='cls_none'>" + objJSON.data[i].col_num;
			strHTML += "<td col='row_num' class='cls_none'>" + objJSON.data[i].row_num;
//			strHTML += "<td col='category_id' class='cls_none'>" + objJSON.data[i].category_id;
			strHTML += "<td col='overlay_tag' class='cls_none'>" + objJSON.data[i].overlay_tag;
			strHTML += "<td col='filter_type' class='cls_none'>" + objJSON.data[i].filter_type;
			strHTML += "<td class='cls_right'><button type='button' class='btn btn-primary cls_btn_edit'><i class='far fa-edit'></i> 編集</button>&nbsp;";
			strHTML += "<button type='button' class='btn btn-danger cls_btn_delete'><i class='far fa-trash-alt'></i> 削除</button>";
		}
	});

	strHTML += "</tbody>";
	strHTML += "</table>";
	
	$("#id_div_list").hide();
	$("#id_div_list").html(strHTML);
	$("#id_div_list").fadeIn(300);
}

function updateCategory() {
	var setData =  {
		twitter_id: $("#id_inp_twitter_id").val(),
		keyword: $("#id_inp_keyword").val(),
		result_type: $("#id_inp_result_type").val(),
		image_flag: "N",
		twitter_contents_header: escapeHTML($("#id_inp_twitter_contents_header").val()),
		twitter_contents_footer: escapeHTML($("#id_inp_twitter_contents_footer").val()),
		disp_type: $("#id_inp_disp_type:checked").val(),
		sort_no: $("#id_inp_sort_no").val(),
		position: $("#id_inp_position:checked").val(),
		col_num: $("#id_inp_col_num").val(),
		row_num: $("#id_inp_row_num").val(),
		overlay_tag: escapeHTML($("#id_inp_overlay_tag").val()),
		filter_type: $("#id_inp_filter_type").val(),
		twitter_title: $("#id_inp_twitter_title").val(),
		//category_id: $("#id_inp_category_id").val(),
	};
	if ($("#id_inp_image_flag").prop("checked")) {
		setData["image_flag"] = "Y";
	}
	if (setData["sort_no"] == "") {
		setData["sort_no"] = "0";
	}
	if (setData["disp_type"] == "menu") {
		if (setData["col_num"] >= "3") {
			alert("サイドメニューの表示タイプ(横)は1または2を設定してください。");
			return;
		}
	}
	if (setData["filter_type"] == "") {
		setData["filter_type"] = " ";
	}
	if (setData["twitter_contents_header"] == "") {
		setData["twitter_contents_header"] = " ";
	}
	if (setData["twitter_contents_footer"] == "") {
		setData["twitter_contents_footer"] = " ";
	}
	if (setData["overlay_tag"] == "") {
		setData["overlay_tag"] = " ";
	}

	if ($("#id_inp_twitter_id").val() == "-1") {
		$.post("./insert/twitter/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	} else {
		setData["twitter_id"] = $("#id_inp_twitter_id").val();
		$.post("./update/twitter/",
			setData,
			function(data){
				if (!post_check(data)) {return;}
				createHTML_List();
			}
		);
	}
	return true;
}

function deleteCategory(objTr) {
	var setData =  {
		twitter_id: $(objTr).attr("key")
	};

	$.post("./delete/twitter/",
		setData,
		function(data){
			if (!post_check(data)) {return;}
			//alert("削除が完了しました。");
			createHTML_List();
		}
	);
}

function setInputFromList(obj) {
	$("#id_inp_keyword").val($(obj).find("td[col=keyword]").html());
	$("#id_inp_twitter_contents_header").val(unEscapeHTML($(obj).find("td[col=twitter_contents_header]").html()));
	$("#id_inp_twitter_contents_footer").val(unEscapeHTML($(obj).find("td[col=twitter_contents_footer]").html()));
	$("#id_inp_overlay_tag").val(unEscapeHTML($(obj).find("td[col=overlay_tag]").html()));
	$("#id_inp_twitter_id").val($(obj).attr("key"));
//	$("#id_inp_category_id").val($(obj).find("td[col=category_id]").html());
	$("#id_inp_result_type").find("option[value='" + $(obj).find("td[col=result_type]").html() + "']").prop("selected",true);
	if ($(obj).find("td[col=image_flag]").html() != "Y") {
		$("#id_inp_image_flag").prop("checked",false);
	}
	$("#id_inp_disp_type[value='" + $(obj).find("td[col=disp_type]").html() + "']").prop("checked", true);
	$("#id_inp_sort_no").val($(obj).find("td[col=sort_no]").html());
	$("#id_inp_position[value='" + $(obj).find("td[col=position]").html() + "']").prop("checked", true);
	$("#id_inp_col_num").find("option[value='" + $(obj).find("td[col=col_num]").html() + "']").prop("selected",true);
	$("#id_inp_row_num").find("option[value='" + $(obj).find("td[col=row_num]").html() + "']").prop("selected", true);
	$("#id_inp_overlay_tag").val(unEscapeHTML($(obj).find("td[col=overlay_tag]").html()));
	$("#id_inp_filter_type").find("option[value='" + $(obj).find("td[col=filter_type]").html() + "']").prop("selected",true);
	$("#id_inp_twitter_title").val($(obj).find("td[col=twitter_title]").html());
}

function setInputFromList2(obj) {
	var pid = $(obj).find("button.cls_btn_dialog").attr("col");
	$("#id_inp_page_body").val((($("#" + pid).val())));
	$("#id_inp_pid").val(pid);
}

function createHTML_dialog() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<th>タイトル：";
	strHTML += "<td><input type='text' id='id_inp_twitter_title' col='twitter_title' size=50>";
	strHTML += "<tr>";
	strHTML += "<th>キーワード：";
	strHTML += "<td><input type='text' id='id_inp_keyword' col='keyword' size=50>";
	strHTML += "<tr>";
	strHTML += "<th>表示順：";
	strHTML += "<td><select id='id_inp_result_type'></select>";
	strHTML += "<tr>";
	strHTML += "<th>表示タイプ";
	strHTML += "<td>";
	strHTML += "横：<select id='id_inp_col_num'>";
	strHTML += "<option value='5' selected>5</option>";
	strHTML += "<option value='4'>4</option>";
	strHTML += "<option value='3'>3</option>";
	strHTML += "<option value='2'>2</option>";
	strHTML += "<option value='1'>1</option>";
	strHTML += "</select>　×　";
	strHTML += "縦：<select id='id_inp_row_num'>";
	strHTML += "<option value='10'>10</option>";
	strHTML += "<option value='9'>9</option>";
	strHTML += "<option value='8'>8</option>";
	strHTML += "<option value='7'>7</option>";
	strHTML += "<option value='6'>6</option>";
	strHTML += "<option value='5'>5</option>";
	strHTML += "<option value='4'>4</option>";
	strHTML += "<option value='3'>3</option>";
	strHTML += "<option value='2' selected>2</option>";
	strHTML += "<option value='1'>1</option>";
	strHTML += "</select>";
	strHTML += "<td>";
	strHTML += "<tr>";
	strHTML += "<th>表示場所";
	strHTML += "<td><input type='radio' id='id_inp_disp_type' name='id_inp_disp_type' value='page' checked>コンテンツ　";
	strHTML += "<input type='radio' id='id_inp_disp_type' name='id_inp_disp_type' value='menu'>サイドメニュー　";
	strHTML += "<tr class='cls_none'>";
	strHTML += "<th>表示位置";
	strHTML += "<td><input type='radio' id='id_inp_position' name='id_inp_position' value='top' checked>上部　";
	strHTML += "<input type='radio' id='id_inp_position' name='id_inp_position' value='bottom'>下部　";
	strHTML += "<tr>";
	strHTML += "<th>表示順";
	strHTML += "<td><input type='text' id='id_inp_sort_no' col='sort_no' size=10>";
	strHTML += "<tr>";
	strHTML += "<th>画像/動画：";
	strHTML += "<td><select id='id_inp_filter_type'>";
	strHTML += "<option value=''>指定なし</option>";
	strHTML += "<option value='images'>画像あり</option>";
	strHTML += "<option value='videos'>動画あり</option>";
	strHTML += "<option value='media'>画像または動画あり</option>";
	strHTML += "</selected>";
	strHTML += "<tr>";
	strHTML += "<th>ページヘッダー：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_twitter_contents_header'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_twitter_contents_header' col='twitter_contents_header' style='width:100%;'></textarea>";
	strHTML += "<tr>";
	strHTML += "<th>ページフッター：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_twitter_contents_footer'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_twitter_contents_footer' col='twitter_contents_footer' style='width:100%;'></textarea>";
	strHTML += "<tr class='cls_none'>";
	strHTML += "<th>コンテンツ<br>オーバーキャッシュ<br>(オーバレイ広告)：";
	strHTML += "<br><button type='button' class='btn btn-success cls_btn_dialog' col='id_inp_overlay_tag'><i class='far fa-edit'></i> 編集</button>";
	strHTML += "<td><textarea id='id_inp_overlay_tag' col='overlay_tag' style='width:100%;'></textarea>";
	strHTML += "</table>";	
	strHTML += "<input type='hidden' id='id_inp_twitter_id' value='-1'>";
	
	$("#id_dialog").html(strHTML);

	var keys = Object.keys(_result_type_name);
	for (var key in keys) {
		$("#id_inp_result_type").append("<option value='" + keys[key] + "'>" + _result_type_name[keys[key]] + "</option>");
	}

/*
	strHTML += "<tr>";
	strHTML += "<th>カテゴリ：";
	strHTML += "<td><select id='id_inp_category_id'>";
	$.ajaxSetup({async: false});
	$.getJSON("./select/twitter_category/", function(objJSON){
		strHTML += "<option value=''>未設定";
		for (var i = 0; i < objJSON.data.length; i++){
			strHTML += "<option value='" + objJSON.data[i].category_id + "'>" + objJSON.data[i].category_name;
		}
	});
*/
//	$("#id_inp_category_id").find("option").eq(1).attr("selected",true)
}

function createHTML_dialog2() {
	var strHTML = "";

	strHTML += "<table class='cls_tbl_input'>";
	strHTML += "<tr>";
	strHTML += "<td><textarea id='id_inp_page_body' class='ckeditor' col='page_body'></textarea>";
	strHTML += "</table>";
	strHTML += "<br>";
	
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_image'><i class='fas fa-image'></i> 画像挿入</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_support2'><i class='fas fa-pencil-alt'></i> 入力補助</button>　";
	strHTML += "<button type='button' class='btn btn-success' id='id_inp_btn_template2'><i class='fas fa-list'></i> テンプレート挿入</button>　";
	strHTML += "<input type='hidden' id='id_inp_pid' value='-1'>";
	
	$("#id_dialog2").html(strHTML);
	
	CKEDITOR.replace("id_inp_page_body", {
		height: 300,
		toolbar: [
			["Bold", "Italic", "Underline", "Strike", "TextColor", "BGColor"],
			["JustifyLeft", "JustifyCenter", "JustifyRight"],
			["Link", "Image", "Table", "HorizontalRule"],
			["Styles", "Format", "FontSize"],
			["Maximize"],
			["Source"],
			["code"],
			["Recommend"],
		],
		uiColor: '#EEEEEE',
		enterMode: 2,
		shiftEnterMode: 2,
		allowedContent: true,
		fillEmptyBlocks: false,
		contentsCss: [_sub_dir + '/css/style.css', 'https://use.fontawesome.com/releases/v5.7.2/css/all.css'],
		tabSpaces: 0
	});
}
