<?php

class ModelApiItem extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_API_ITEM";
		$this->columns = array(
			"user_id"=>"index",
			"api_id"=>"index",
			"page_id"=>"index",
			"item_code"=>"",
			"item_name"=>"",
			"item_price"=>"",
			"item_caption"=>"",
			"item_url"=>"",
			"small_image_url"=>"",
			"medium_image_url"=>"",
			"shop_name"=>"",
			"shop_code"=>"",
			"shop_url"=>"",
			"genre_id"=>"",
			"time_stamp"=>""
		);
	}
	function bulkControl() {
		$rtn = parent::insertControl();
		return($rtn);
	}
	// メイン処理(select)
	function selectControl() {
		$this->columns["page_id"] = "index";
		$sql = "select a.*,b.category_id,c.category_name from ".$this->tblname." a";
		$sql .= " left join ".TABLE_PREFIX."_API b on b.api_id = a.api_id";
		$sql .= " left join ".TABLE_PREFIX."_PAGE_CATEGORY d on d.page_id = a.page_id";
		$sql .= " left join ".TABLE_PREFIX."_API_CATEGORY c on c.category_id = ifnull(d.category_id,b.category_id)";
		$sql .= " where ".$this->getConds($this->getIndexes(),"a");
		if ($this->gets["search_text"] != "") {
			$sql .= " and a.item_name like '%".$this->gets["search_text"]."%'";
		}
		if ($this->gets["search_category_id"] != "") {
			$sql .= " and ifnull(d.category_id,b.category_id) = '".$this->gets["search_category_id"]."'";
		}
		$sql .= " order by a.time_stamp desc limit 0,1000";
		$json = $this->query($sql);
		return($json);
	}
	function selectControl2() {
		$this->columns["page_id"] = "index";
		$sql = "select a.*,b.category_id,c.category_name from ".$this->tblname." a";
		$sql .= " left join ".TABLE_PREFIX."_API b on b.api_id = a.api_id";
		$sql .= " left join ".TABLE_PREFIX."_PAGE_CATEGORY d on d.page_id = a.page_id";
		$sql .= " left join ".TABLE_PREFIX."_API_CATEGORY c on c.category_id = ifnull(d.category_id,b.category_id)";
		$sql .= " where ".$this->getConds($this->getIndexes(),"a");
		if ($this->gets["search_text"] != "") {
			$sql .= " and a.item_name like '%".$this->gets["search_text"]."%'";
		}
		if ($this->gets["search_category_id"] != "") {
			$sql .= " and ifnull(d.category_id,b.category_id) = '".$this->gets["search_category_id"]."'";
		}
		$sql .= " order by a.time_stamp desc";
		$json = $this->query($sql);
		return($json);
	}
}
?>