<?php

class ModelRssArticle extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_RSS_ARTICLE";
		$this->columns = array(
			"rss_id"=>"index",
			"article_id"=>"",
			"article_title"=>"",
			"article_url"=>"",
			"article_image"=>"",
			"article_time"=>"",
			"time_stamp"=>""
		);
	}
	// メイン処理(select)
	function select($keys,$orders = null,$offset = 0,$row = 0) {
		$sql = "select a.*,b.site_title from ".$this->tblname." a";
		$sql .= " inner join ".TABLE_PREFIX."_RSS b on b.user_id = a.user_id and b.rss_id = a.rss_id";
		$sql .= " where ".$this->getConds($keys,"a");
		$sql .= " order by ".$this->getOrders($orders,"a");
		if ($row != 0) {
			$sql .= " limit ".$offset.",".$row;
		}
		$json = $this->query($sql);
		return($json);
	}
	// メイン処理(count)
	function count($keys) {
		$sql = "select count(*) as cnt from ".$this->tblname." a";
		$sql .= " inner join ".TABLE_PREFIX."_RSS b on b.user_id = a.user_id and b.rss_id = a.rss_id";
		$sql .= " inner join ".TABLE_PREFIX."_SITE c on c.user_id = a.user_id";
		$sql .= " inner join ".TABLE_PREFIX."_USER d on d.user_id = a.user_id";
		$sql .= " where ".$this->getConds($keys,"a");
		$rs = $this->query($sql);
		while ($item = mysql_fetch_array($rs)) {
			return($item["cnt"]);
		}
		return(0);
	}
	// メイン処理(select)
	function selectTop($keys,$orders = null,$offset = 0,$row = 0) {
		$sql = "select a.*,b.site_title,c.site_title as user_site_title,d.user_name,c.title_image_file,c.favicon_image_file from ".$this->tblname." a";
		$sql .= " inner join ".TABLE_PREFIX."_RSS b on b.user_id = a.user_id and b.rss_id = a.rss_id";
		$sql .= " inner join ".TABLE_PREFIX."_SITE c on c.user_id = a.user_id";
		$sql .= " inner join ".TABLE_PREFIX."_USER d on d.user_id = a.user_id";
		$sql .= " where 0=0";
		$sql .= " and not exists(select * from ".TABLE_PREFIX."_NG_WORD x where x.user_id = a.user_id and a.article_title like concat('%',x.ng_word,'%') and x.replace_word = ' ')";
		if ($keys["article_title"] != "") {
			$sql .= " and article_title like '".$keys["article_title"]."'";
		}
		$sql .= " order by ".$this->getOrders($orders,"a");
		if ($row != 0) {
			$sql .= " limit ".$offset.",".$row;
		}
		$json = $this->query($sql);
		return($json);
	}
		// メイン処理(select)
	function selectHot($keys,$orders = null,$offset = 0,$row = 0,$days = 0) {
		$sql = "select a.*,b.site_title,c.site_title as user_site_title,d.user_name,c.title_image_file,c.favicon_image_file,e.in_count,e.out_count from ".$this->tblname." a";
		$sql .= " inner join ".TABLE_PREFIX."_RSS b on b.user_id = a.user_id and b.rss_id = a.rss_id";
		$sql .= " inner join ".TABLE_PREFIX."_SITE c on c.user_id = a.user_id";
		$sql .= " inner join ".TABLE_PREFIX."_USER d on d.user_id = a.user_id";
		$sql .= " left join (select rss_id,article_id,sum(in_count) as in_count,sum(out_count) as out_count from ".TABLE_PREFIX."_RSS_COUNTER";
		$sql .= " where 0=0";
		if ($days > 0) {
			$sql .= " and access_date >= '".date('Y-m-d', strtotime("-".$days." days"))."'";
		}
		if ($keys["user_id"] != "") {
			$sql .= " and rss_id in(select rss_id from ".TABLE_PREFIX."_RSS where user_id = '".$keys["user_id"]."')";
		}
		$sql .= " group by rss_id,article_id) e on e.rss_id = a.rss_id and e.article_id = a.article_id";
		$sql .= " where 0=0";
		$sql .= " and not exists(select * from ".TABLE_PREFIX."_NG_WORD x where x.user_id = a.user_id and a.article_title like concat('%',x.ng_word,'%') and x.replace_word = ' ')";
		if ($keys["user_id"] != "") {
			$sql .= " and a.user_id = '".$keys["user_id"]."'";
		}
		$sql .= " and a.article_time >= '".date('Y-m-d H:i:s', strtotime("-".$days." days"))."'";
		$sql .= " order by (e.in_count + e.out_count) desc ,".$this->getOrders($orders,"a");
		if ($row != 0) {
			$sql .= " limit ".$offset.",".$row;
		}
		$json = $this->query($sql);
		return($json);
	}
	// メイン処理(insert)
	function insertControl() {
		$this->posts["rss_id"] = createID();
		$rtn = parent::insertControl();
		return($rtn);
	}
}
?>