<?php

class ModelRssCounter extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_RSS_COUNTER";
		$this->columns = array(
			"rss_id"=>"index",
			"article_id"=>"index",
			"access_date"=>"index",
			"in_count"=>"",
			"out_count"=>"",
			"in_ip_address"=>"",
			"out_ip_address"=>"",
			"time_stamp"=>""
		);
	}
	// メイン処理(select)
	function selectControl() {
		$sql = "select a.rss_id,sum(a.in_count) as in_count,sum(a.out_count) as out_count,max(a.time_stamp) as time_stamp,max(b.site_title) as site_title from ".$this->tblname." a";
		$sql .= " left join ".TABLE_PREFIX."_RSS b on b.rss_id = a.rss_id";
		$sql .= " where ".$this->getConds($this->getIndexes(),"a");
		$sql .= " and b.user_id = '".$this->posts["user_id"]."'";
		$sql .= " group by a.rss_id";
		$sql .= " order by a.rss_id";
		$json = $this->query($sql);
		return($json);
	}
	// メイン処理(countUpIn)
	function countUpIn($keys,$params) {
		$keys["access_date"] = date("Y-m-d");
		$params["access_date"] = date("Y-m-d");
		if ($this->count($keys,"in_count") == 0) {
			$params["in_count"] = 1;
			$params["out_count"] = 0;
			$params["in_ip_address"] = $_SERVER["REMOTE_ADDR"];
			$params["out_ip_address"] = "xx.xx.xx.xx";
			$params["time_stamp"] = date("Y-m-d H:i:s");
			$rtn = $this->insert($params);
		} else {
			$keys2 = $this->getIndexes();
			$keys2["access_date"] = date("Y-m-d");
			$keys2["in_ip_address"] = $_SERVER["REMOTE_ADDR"];
			//前回のIPアドレスと異なる場合にカウントアップ
			if ($this->count($keys2,"in_ip_address") == 0) {
				$cnt = $this->max($keys,"in_count");
				$params["in_count"] = $cnt + 1;
				$params["in_ip_address"] = $_SERVER["REMOTE_ADDR"];
				$rtn = $this->update($params,$keys);
			}
		}
	}
	// メイン処理(countUpOut)
	function countUpOut($keys,$params) {
		$keys["access_date"] = date("Y-m-d");
		$params["access_date"] = date("Y-m-d");
		if ($this->count($keys,"out_count") == 0) {
			$params["in_count"] = 0;
			$params["out_count"] = 1;
			$params["in_ip_address"] = "xx.xx.xx.xx";
			$params["out_ip_address"] = $_SERVER["REMOTE_ADDR"];
			$params["time_stamp"] = date("Y-m-d H:i:s");
			$rtn = $this->insert($params);
		} else {
			$keys2 = $this->getIndexes();
			$keys2["access_date"] = date("Y-m-d");
			$keys2["out_ip_address"] = $_SERVER["REMOTE_ADDR"];
			//前回のIPアドレスと異なる場合にカウントアップ
			if ($this->count($keys2,"out_ip_address") == 0) {
				$cnt = $this->max($keys,"out_count");
				$params["out_count"] = $cnt + 1;
				$params["out_ip_address"] = $_SERVER["REMOTE_ADDR"];
				$rtn = $this->update($params,$keys);
			}
		}
	}
	// メイン処理(Common)
	function commonControl($func) {
		switch ($func) {
			case "groupDate":
				$sql = "select access_date,sum(in_count) as in_count,sum(out_count) as out_count from ".$this->tblname." a";
				$sql .= " left join ".TABLE_PREFIX."_RSS b on b.rss_id = a.rss_id";
				$sql .= " where ".$this->getConds($this->getIndexes());
				$sql .= " and b.user_id = '".$this->posts["user_id"]."'";
				$sql .= " group by access_date";
				$sql .= " order by access_date";
				$json = $this->query($sql);
				return($json);
				break;
			case "countUpIn":
				$params = $this->getParams();
				$keys = $this->getIndexes();
				countUpIn($keys,$params);
				break;
			case "countUpOut":
				$params = $this->getParams();
				$keys = $this->getIndexes();
				countUpOut($keys,$params);
				break;
		}
		return($rtn);
	}
}
?>