<?php

class ModelUser extends ModelDatabase {
	protected $tblname;
	protected $columns;
	//コンストラクタ
	function __construct() {
		$this->tblname = TABLE_PREFIX."_USER";
		$this->columns = array(
			"user_id"=>"index",
			"pass_word"=>"",
			"user_name"=>"",
			"mail_address"=>"",
			"enable_flag"=>"",
			"login_time"=>"",
			"ip_address"=>"",
			"time_stamp"=>""
		);
	}
	// メイン処理(update)
	function updateControl() {
		if ($this->posts["pass_word"] != "") {
			$this->posts["pass_word"] = hashStr($this->posts["pass_word"]);
		}
		$rtn = parent::updateControl();
		
		if (!is_admin()) {
			if ($this->posts["pass_word"] != "") {
				//パスワード変更メール送信
				mailPasswordUpdate($this->posts["mail_address"],$this->posts["user_id"]);
			}
		}
		if ($this->posts["update_mail_address"] == "Y") {
			//メールアドレス変更メール送信
			mailAddressUpdate($this->posts["mail_address"],$this->posts["user_name"]);
		}
		if ($this->posts["update_enable_flag"] == "Y") {
			////アカウント再開・停止メール送信
			mailEnableFlagUpdate($this->posts["mail_address"],$this->posts["user_name"],$this->posts["enable_flag"]);
		}
		
		return($rtn);
	}
	// メイン処理(Common)
	function commonControl($func) {
		switch ($func) {
			case "all":
				if (is_admin()) {
					$this->getToPost();
					$keys = $this->getIndexes();
					
					$page = $this->gets["page"];
					$row = $this->gets["maxcnt"];
					$offset = ($page - 1) * $row;
					
					$sql = "select * from ".$this->tblname;
					$sql .= " where ".$this->getConds($keys);
					$sql .= " order by time_stamp desc";
					$sql .= " limit ".$offset.",".$row;
					$json = $this->query($sql);
					return($json);
				}
				break;
			case "allcnt":
				if (is_admin()) {
					$this->getToPost();
					$keys = $this->getIndexes();
					
					$sql = "select count(*) as cnt from ".$this->tblname;
					$sql .= " where ".$this->getConds($keys);
					$json = $this->query($sql);
					return($json);
				}
				break;
		}
		return($rtn);
	}
	
	function getToPost() {
		foreach ($this->columns as $key => $val) {
			$this->posts[$key] = $this->gets[$key];
			$this->columns[$key] = "index";
		}
	}
}
?>