<?php
	include("../include/config.php");
	include("../include/getdata.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/session.php");
	include("./models/user.php");
	include("./models/site.php");

	initProc();

	$auth_mode = $_GET["auth_mode"];

	if (!is_authenticated($auth_mode)) {
		//loginページへ
		header("Location:${sub_dir}/setting/users/login/?err=timeout");
	}

	$user_id = $_SESSION["user_id"];
	if ($auth_mode == "admin") {
		if (is_admin()) {
			$user_id = $_SESSION["admin_id"];
		}
	}

	//design.jsonをコピー
	$site_path = SITE_PATH;
	if (!file_exists($site_path."home/".$user_id."/design.json")) {
		copy($site_path."design_template.json", $site_path."home/${user_id}/design.json");
	}
	if (!file_exists($site_path."home/".$user_id."/layout.json")) {
		copy($site_path."layout_template.json", $site_path."home/${user_id}/layout.json");
	}

	$app_id = $_GET["app"];
	if ($app_id == "") {
		$app_id = "user";
	}
	$page_id = $_GET["page"];
	if ($page_id == "") {
		$page_id = "index";
	}

	switch ($app_id) {
		case "user":
		case "contact":
		case "support":
		case "site":
		case "design":
		case "layout":
		case "page_index":
		case "page_contents":
		case "page_comment":
		case "category":
		case "tag_contents":
		case "tag_menu":
		case "request_msg":
		case "request":
		case "counter":
		case "faq":
		case "mail":
		case "api":
		case "api_item":
		case "api_title":
		case "api_body":
		case "api_category":
		case "api_channel":
		case "ranking_item":
		case "ranking_body":
		case "rss":
		case "rss_category":
		case "ng_word":
		case "random_contents":
		case "page_thumbnail":
		case "distribute":
		case "twitter":
			break;
		default:
			header("Location:${sub_dir}/setting/users/login/");
	}

	//ユーザ取得
	$ModelUser = new ModelUser();
	$data = array(
		"user_id"=>$user_id
	);
	$rs = $ModelUser->select($data);
	while ($item = mysqli_fetch_array($rs)) {
		$user_name = $item["user_name"];
	}

	$ModelSite = new ModelSite();
	$data = array(
		"user_id"=>$user_id
	);
	$rs = $ModelSite->select($data);
	while ($item = mysqli_fetch_array($rs)) {
		$site_title = $item["site_title"];
	}

	if ($auth_mode == "admin") {
		$htmlCenter .= getAdminHeaderHtml();
		$htmlLeft .= getAdminMenuHtml();
	} else {
		$htmlCenter .= getUserHeaderHtml($user_name,$site_title);
		$htmlLeft .= getUserMenuHtml();
	}

	$htmlRight .= "<div class='cls_main align-left'>\n";
	$htmlRight .= "<div id='id_div_PageContens' class='cls_div_Page'></div>\n";
	$htmlRight .= "</div>\n";

	$html_script .= <<<EOF
	function reloadPage() {
		$.get(window.location.href, function(data){
			//console.log(window.location.href);
		});
	}
	setInterval(reloadPage,10*60*1000);
EOF;

	//Viewモデル
	$modelView = new ModelView();

	$modelView->app_id = $app_id;
	$modelView->page_id = $page_id;
	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = SITE_TITLE." - ユーザーページ";
	$modelView->description = SITE_DESCRIPTION;
	$modelView->keywords = KEY_WORDS;
	$modelView->printHTML();

	endProc();

?>
