<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/user.php");
	include("../models/session.php");
	include("../models/page.php");
	include("../models/site.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_user_name'=>'アカウント名',
		'txt_pass_word'=>'パスワード'
	);
	//ルール定義
	$rules = array(
		'txt_user_name'=>'required',
		'txt_pass_word'=>'required'
	);

	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "login") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$ModelUser = new ModelUser();
			$data = array(
				"pass_word"=>hashStr($modelView->posts["txt_pass_word"]),
				"user_name"=>$modelView->posts["txt_user_name"],
				"enable_flag"=>"Y"
			);
			$rs = $ModelUser->select($data);
			while ($item = mysqli_fetch_array($rs)) {
				$user_id = $item["user_id"];
			}
			//管理者ログイン
			if ($modelView->posts["txt_user_name"] == ADMIN_USER_ID && $modelView->posts["txt_pass_word"] == ADMIN_PASSWORD) {
				$user_id = ADMIN_USER_ID;
			}
			//管理者のユーザログイン
			if ($_POST["login_mode"] == "admin") {
				$data = array(
					"user_id"=>$modelView->posts["txt_user_id"],
					"user_name"=>$modelView->posts["txt_user_name"],
					"mail_address"=>$modelView->posts["txt_mail_address"]
				);
				$rs = $ModelUser->select($data);
				while ($item = mysqli_fetch_array($rs)) {
					$user_id = $item["user_id"];
				}
			}
			if ($user_id == ""){
				$modelView->error_params = "txt_user_name,txt_pass_word";
				$modelView->error_message = "アカウント名またはパスワードに誤りがあります。";
				$login_fail_count = 0;
//			} else if ($login_fail_count >= 2){
//				$modelView->error_params = "txt_mail_address,txt_pass_word";
//				$modelView->error_message = "パスワードに誤りがあります。残り".(5-$login_fail_count)."回の入力を間違えるとアカウントをロックします。";
//			} else if ($login_fail_count >= 5){
//				$modelView->error_params = "txt_mail_address,txt_pass_word";
//				$modelView->error_message = "パスワードを一定回数間違えたため、アカウントをロックしました。パスワードの再発行を行ってください。";
			} else {
				//ログイン処理
				loginProc($user_id);

				header("Location:${sub_dir}/setting/app/user/");
			}
			if ($modelView->error_message != "") {
//				$ModelUser = new ModelModelUser();
//				//fail回数をup
//				$ModelUser->failCountUp($modelView->posts["txt_mail_address"],$login_fail_count);
			}
		}
	}

	$htmlCenter .= getHomeHeaderHtml();

	$htmlLeft .= "";	//getHomeMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$url = $_SERVER["REQUEST_URI"];
		$hash = parse_url($url);
		parse_str($hash['query'],$query);

		if ($query["err"] == "timeout") {
			$modelView->validate_on = true;
			$modelView->error_params = "txt_user_name,txt_pass_word";
			$modelView->error_message = "一定期間、操作がなかったため、タイムアウトしました。";
		}

		$htmlRight .= "<div id='login-contents' class='align-center' style='background-color:#fff;margin-top:40px;margin-bottom:0px;padding-bottom:8px;'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<td class='align-left'><h2  class='setting'>ログイン</h2>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "<div id='login-contents' class='align-center' style='margin-top:0px;margin-bottom:0px;'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<table cellpadding=3>";
		$htmlRight .= "<tr><th style='padding-right:20px;'><div class='cls_section'>".$params["txt_user_name"]."</div>";
		$htmlRight .= "<td><div><input type='text' id='txt_user_name' name='txt_user_name' size=40></div>";
		$htmlRight .= "<tr><th style='padding-right:20px;'><div class='cls_section'>".$params["txt_pass_word"]."</div>";
		$htmlRight .= "<td><div><input type='password' id='txt_pass_word' name='txt_pass_word' size=40></div>";
		$htmlRight .= "</table>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='login'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_login' name='btn_login' value='ログイン'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "<div id='login-contents' class='align-center' style='background-color:#fff;margin-top:0px;'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<table cellpadding=3>";
		$htmlRight .= "<tr><td><div class='btn-normal'><i class='fas fa-chevron-circle-right' style='color:#fff;'></i> <a href='${sub_dir}/setting/users/password_reset/'>パスワード変更</a></div><td>パスワードを忘れた方はこちら";
		$htmlRight .= "<tr><td><div class='btn-normal'><i class='fas fa-chevron-circle-right' style='color:#fff;'></i> <a href='${sub_dir}/setting/users/sign_up/'>新規登録</a></div><td>まだアカウントをお持ちでない方はこちら";
		$htmlRight .= "</table>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= $modelView->error_message;

		$html_script .= <<<EOF
$(document).on("click", "#btn_login", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = "ログイン";
	$modelView->description = ””;
	$modelView->keywords = ””;
	$modelView->printHTML();

	endProc();
?>
