<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/user.php");
	include("../models/session.php");
	include("../models/page.php");
	include("../models/site.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'メールアドレス'
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required,email'
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "reset") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$mail_address = $modelView->posts["txt_mail_address"];
			$pass_word_temp = randStr(6);
			$login_key = createLoginKey();

			//ユーザ情報を取得
			$ModelUser = new ModelUser();
			$keys = array(
				"mail_address"=>$mail_address
			);
			$rs = $ModelUser->select($keys);
			while ($item = mysqli_fetch_array($rs)) {
				$user_id = $item["user_id"];
			}

			//仮パスワードを設定
			$ModelUser = new ModelUser();
			$params = array(
				"pass_word"=>hashStr($pass_word_temp)
			);
			$keys = array(
				"user_id"=>$user_id,
				"mail_address"=>$mail_address
			);
			$ModelUser->update($params,$keys);

			//ログイン情報を生成
			$ModelSession = new ModelSession();
			$params = array(
				"user_id"=>$user_id,
				"sess_id"=>$login_key,
				"expire"=>date('Y-m-d H:i:s', time()+3600*2)
			);
			$ModelSession->insert($params);

			//パスワード再発行メール送信
			mailPasswordReset($mail_address,$pass_word_temp,$login_key);

			$htmlRight .= "<div class='cls_main align-left'>\n";
			$htmlRight .= "<b>パスワードの再発行が完了しました。</b><br>";
			$htmlRight .= "<br>";
			$htmlRight .= "入力されたメールアドレス宛に、新しいパスワードを送信しました。<br>";
			$htmlRight .= "※メールが来ない場合は、迷惑メールボックスに振り分けられていないか確認してください。<br>";
			$htmlRight .= "</div>";
		}
	}

	$htmlCenter .= getHomeHeaderHtml();

	$htmlLeft .= "";	//getHomeMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2  class='setting'>パスワード再発行</h2>";
		$htmlRight .= "<form id='frmLogin' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='reset'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_login' name='btn_login' value='送信'></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";

		$html_script .= <<<EOF
$(document).on("click", "#btn_login", function(){
	$("#frmLogin").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = SITE_TITLE." - ".SITE_DESCRIPTION;
	$modelView->description = SITE_DESCRIPTION;
	$modelView->keywords = KEY_WORDS;
	$modelView->printHTML();

	endProc();
?>
