<?php
	include("../../include/config.php");
	include("../../include/getdata.php");
	include("../include/modelView.php");
	include("../include/modelDatabase.php");
	include("../models/user.php");
	include("../models/session.php");
	include("../models/site.php");
	include("../models/page.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_mail_address'=>'メールアドレス',
		'txt_user_name'=>'アカウント名',
	);
	//ルール定義
	$rules = array(
		'txt_mail_address'=>'required,email',
		'txt_user_name'=>'required,alphanumeric'
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	$html = "";
	$html_script = "";

	if ($_POST["proc_type"] == "entry") {
		//パラメータチェック
		if ($modelView->validateParams()){
			$user_id = createID();

			$ModelUser = new ModelUser();
			$data = array(
				"mail_address"=>$modelView->posts["txt_mail_address"]
			);
			if ($ModelUser->count($data) == 0) {
				$data = array(
					"user_name"=>$modelView->posts["txt_user_name"]
				);
				$check_user = array("article","category","channel","channel_item","contact","css","faq","feed","feed_item","feed_page","home","images","include","index","js","link","local","models","page","rank","request","rss","rss_category","scripts","search","setting","support","url");
				if ($ModelUser->count($data) == 0 && !in_array($data["user_name"],$check_user)) {
					//ユーザ登録
					$ModelUser = new ModelUser();
					$data = array(
						"user_id"=>$user_id,
						"pass_word"=>hashStr(randStr(16)),
						"user_name"=>$modelView->posts["txt_user_name"],
						"mail_address"=>$modelView->posts["txt_mail_address"],
						"enable_flag"=>"N",
						"login_time"=>date("Y-m-d H:i:s"),
						"ip_address"=>$_SERVER["REMOTE_ADDR"],
						"time_stamp"=>date("Y-m-d H:i:s")
					);
					$ModelUser->insert($data);

					//サイト登録
					$ModelSite = new ModelSite();
					$data = array(
						"user_id"=>$user_id,
						"site_title"=>$modelView->posts["txt_user_name"]."のサイト名",
						"site_description"=>"サイトの説明",
						"site_url"=>"",
						"title_image_file"=>"",
						"bg_image_file"=>"",
						"favicom_image_file"=>"",
						"icon_image_file"=>"",
						"bg_color"=>"#f6f6f6",
						"link_color"=>"#0000aa",
						"h1_color"=>"#3369aa",
						"h2_color"=>"#3369aa",
						"h3_color"=>"#3369aa",
						"menu_color"=>"#333333",
						"tag_contents_header"=>"",
						"tag_contents_middle"=>"",
						"tag_contents_footer"=>"",
						"tag_menu_header"=>"",
						"tag_menu_middle"=>"",
						"tag_menu_footer"=>"",
						"tag_access"=>"",
						"api_key"=>"",
						"time_stamp"=>date("Y-m-d H:i:s", time()+3600*24),
						"mail_form_header"=>"",
						"mail_form_middle"=>"",
						"mail_form_footer"=>"",
						"header_tag"=>"",
						"site_keywords"=>"",
						"h1_type"=>"",
						"h2_type"=>"",
						"h3_type"=>"",
						"menu_layout"=>"",
						"h4_color"=>"#333333",
						"h4_type"=>"",
						"h5_color"=>"#333333",
						"h5_type"=>"",
						"header_bg_color"=>"#f6f6f6",
						"global_navi_color"=>"#ffffff",
						"global_navi_bg_color"=>"#666666"
					);
					$ModelSite->insert($data);

					//ログイン処理
					loginProc($user_id);
					
					//仮登録のメール送信
					mailSignup($modelView->posts["txt_mail_address"],$_SESSION["login_key"]);
					
					//homeページへ
					header("Location:${sub_dir}/setting/users/register/");
				} else {
					$modelView->error_params = "txt_mail_address";
					$modelView->error_message = "このアカウント名は既に登録されています。他のアカウント名を入力してください。";
				}
			} else {
				$modelView->error_params = "txt_mail_address";
				$modelView->error_message = "このメールアドレスは既に登録されています。他のメールアドレスを入力してください。";
			}
		}
	}

	$htmlCenter .= getHomeHeaderHtml();

	$htmlLeft .= "";	//getHomeMenuHtml();

	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div class='cls_main align-left'>\n";
		$htmlRight .= "<div class='align-center' style='min-width:540px'>";
		$htmlRight .= "<table class='align-center' style='min-width:540px;'>";
		$htmlRight .= "<tr>";
		$htmlRight .= "<td class='align-left' colspan=5><h2 class='setting'>新規登録の流れ</h2>";
		$htmlRight .= "<tr>";
		$htmlRight .= "<td><div class='cls_info_box cls_selected'>登録内容入力</div>";
		$htmlRight .= "<td style='vertical-align:middle;'><i class='fas fa-arrow-right'></i>";
		$htmlRight .= "<td><div class='cls_info_box cls_noselected'>仮登録完了</div>";
		$htmlRight .= "<td style='vertical-align:middle;'><i class='fas fa-arrow-right'></i>";
		$htmlRight .= "<td><div class='cls_info_box cls_noselected'>本登録完了</div>";
		$htmlRight .= "<tr>";
		$htmlRight .= "<td>メールアドレスと<br>アカウント名を<br>入力ください。<br>&nbsp;";
		$htmlRight .= "<td>";
		$htmlRight .= "<td>メール内のURLを<br>クリックし、<br>パスワードを設定<br>ください。";
		$htmlRight .= "<td>";
		$htmlRight .= "<td>ログイン画面から<br>メールアドレスと<br>パスワードで<br>ログインください。";
		$htmlRight .= "</table>";
		$htmlRight .= "</div>";

		$htmlRight .= "<div id='login-contents' class='align-center'>";
		$htmlRight .= "<div class='align-left'>";
		$htmlRight .= "<h2 class='setting'>新規登録</h2>";
		$htmlRight .= "<form id='frmEntry' action='${sub_dir}/setting/users/sign_up/' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<div class='cls_section'>アカウント名</div>";
		$htmlRight .= "<div><input type='text' id='txt_user_name' name='txt_user_name' size=40></div>";
		$htmlRight .= "※URLは、".$HTML_HOME_URL."<b>アカウント名</b>/になります。<br>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='entry'>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><input type='button' id='btn_entry' name='btn_entry' class='large-button' value='アカウントを作成する'></div>";
		$htmlRight .= "<br>";
		$htmlRight .= "<div><a href='${sub_dir}/setting/users/login/'>既にアカウントをお持ちの方はこちら</a></div>";
		$htmlRight .= "</form>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>";
		$htmlRight .= "</div>\n";

		$html_script .= <<<EOF
$(document).on("click", "#btn_entry", function(){
	$("#frmEntry").submit();
});
EOF;
	}

	$modelView->htmlCenter = $htmlCenter;
	$modelView->htmlLeft = $htmlLeft;
	$modelView->htmlRight = $htmlRight;
	$modelView->htmlScripts = $html_script;
	$modelView->title = SITE_TITLE." - ".SITE_DESCRIPTION;
	$modelView->description = SITE_DESCRIPTION;
	$modelView->keywords = KEY_WORDS;
	$modelView->printHTML();

	endProc();
?>
