<?php
	include("./include/config.php");
	include("./include/getdata.php");
	include("./include/modelView.php");
	include("./include/modelDatabase.php");
	include("./models/user.php");
	include("./models/session.php");
	include("./models/support.php");
	include("./models/page.php");
	include("./models/site.php");
	include("./models/rss.php");
	include("./models/rssArticle.php");
	include("./models/rssCategory.php");
	include("./models/ngWord.php");
	include("./twitter/twitter_oauth.php");

	initProc();

	//パラメータ定義
	$params = array(
		'txt_name'=>'名前',
		'txt_mail_address'=>'メールアドレス',
		'txt_url'=>'違反ページのURL',
		'txt_content_text'=>'内容',
		'txt_detail_text'=>'本文',
	);
	//ルール定義
	$rules = array(
		'txt_name'=>'required',
		'txt_mail_address'=>'required,email',
		'txt_url'=>'required,url',
		'txt_content_text'=>'required',
		'txt_detail_text'=>'required',
	);
	//POSTデータ取得
	$posts = postToArray();

	//Viewモデル
	$modelView = new ModelView();
	$modelView->params = $params;
	$modelView->rules = $rules;
	$modelView->posts = $posts;

	if ($_POST["proc_type"] == "entry") {
		if ($modelView->validateParams()){
			$support_id = createID();

			//RSS依頼登録
			$ModelSupport = new ModelSupport();
			$data = array(
				"support_id"=>$support_id,
				"name"=>$modelView->posts["txt_name"],
				"mail_address"=>$modelView->posts["txt_mail_address"],
				"url"=>$modelView->posts["txt_url"],
				"content_text"=>$modelView->posts["txt_content_text"],
				"detail_text"=>crLfHTML($modelView->posts["txt_detail_text"]),
				"ip_address"=>$_SERVER["REMOTE_ADDR"],
				"enable_flag"=>"Y",
				"time_stamp"=>date("Y-m-d H:i:s")
			);
			$ModelSupport->insert($data);
			
			//メール送信
			mailSupport($modelView->posts["txt_mail_address"],$modelView->posts["txt_name"],$modelView->posts["txt_url"],$modelView->posts["txt_content_text"],$modelView->posts["txt_detail_text"]);
			//メール送信(管理者)
			mailSupportToAdmin($modelView->posts["txt_mail_address"],$modelView->posts["txt_name"],$modelView->posts["txt_url"],$modelView->posts["txt_content_text"],$modelView->posts["txt_detail_text"]);
		}
	}
	if ($_POST["proc_type"] == "" or $modelView->error_message != "") {
		$htmlRight .= "<div class='align-left'>\n";

		$htmlRight .= "<h2>違反報告フォーム</h2>\n";
		$htmlRight .= "";
		
		$htmlRight .= "<form id='frmEntry' action='./' method='post'>";
		$htmlRight .= "<div class='cls_message'></div>";
		$htmlRight .= "<div class='cls_section'>名前</div>";
		$htmlRight .= "<div><input type='text' id='txt_name' name='txt_name' size=40></div>";
		$htmlRight .= "<div class='cls_section'>メールアドレス</div>";
		$htmlRight .= "<div><input type='text' id='txt_mail_address' name='txt_mail_address' size=40></div>";
		$htmlRight .= "<div class='cls_section'>違反ページのURL</div>";
		$htmlRight .= "<div><input type='text' id='txt_url' name='txt_url' size=50></div>";
		$htmlRight .= "<div class='cls_section'>内容</div>";
		$htmlRight .= "<div><select id='txt_content_text' name='txt_content_text'>";
		$htmlRight .= "<option value='権利侵害'>権利侵害";
		$htmlRight .= "<option value='その他利用規約違反'>その他利用規約違反";
		$htmlRight .= "</select></div>";
		$htmlRight .= "<div class='cls_section'>本文</div>";
		$htmlRight .= "<div><textarea rows=10 cols=60 id='txt_detail_text' name='txt_detail_text'></textarea></div>";
		$htmlRight .= "<input type='hidden' id='proc_type' name='proc_type' value='entry'>";
		$htmlRight .= "<br><br>";

		$htmlRight .= "<div><input type='button' id='btn_entry' name='btn_entry' value='報告する'></div>";
		$htmlRight .= "<br>";
		$htmlRight .= "</form>";

		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";

		$htmlRight .= <<<EOF
<script type="text/javascript">
$(document).on("click", "#btn_entry", function(){
	if ($("#txt_name").val().trim() == "") {
		alert("名前を入力してください。");
		return;
	}
	if ($("#txt_mail_address").val().trim() == "") {
		alert("メールアドレスを入力してください。");
		return;
	}
	if ($("#txt_url").val().trim() == "") {
		alert("違反ページのURLを入力してください。");
		return;
	}
	if ($("#txt_detail_text").val().trim() == "") {
		alert("内容を入力してください。");
		return;
	}
	$("#txt_detail_text").val(escapeHTML($("#txt_detail_text").val()));
	$("#frmEntry").submit();
});
</script>
EOF;
	} else {

		$htmlRight .= "<div class='align-left'>\n";
		$htmlRight .= "<h2>違反報告フォーム</h2>\n";
		$htmlRight .= "<div style='line-height:1.8;'>";
		$htmlRight .= "ありがとうございます。<br>";
		$htmlRight .= "違反報告フォームを受け付けました。<br>";
		$htmlRight .= "<br>\n";
		if (!is_authenticated()) {
			$htmlRight .= "このサイトは <b>".$admin_site_title."</b> を利用して作成されています。<br>";
			$htmlRight .= "あなたも、アンテナサイトを運営してみませんか？<br><br>";
			$htmlRight .= "<a href='${sub_dir}/'>".$admin_site_title."</a>";
			$htmlRight .= "<br>\n";
		}
		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";
		$htmlRight .= "</div>\n";
	}

	$htmlRight = cnvContents($htmlRight);
	
	//ヘッダ部
	$title = "";
	$description = "";
	$keywords = "";
	getHeaderHTML($title,$description,$keywords);

	print $htmlRight;

	//メニュー
	getMenuHTML(ADMIN_USER_ID);

	//フッター
	getFooterHTML();

	print $_POST["proc_type"];
	endProc();

?>
